#ifndef CONDOUV_H
#define CONDOUV_H

#include<vector>
#include <string>
#include "FL/Fl.H"
#include "dll.h"

using namespace std;
const char* const joueurs[4]={"nord","est","sud","ouest"};
const char* const sacouls[5]={"SA","pique","cœur","carreau","trèfle"};
const char* const vl[14]={"A","R","D","V","X","9","8","7","6","5","4","3","2"};
//const string ranks = "0123456789XVDRA";
const char* const num[17]={"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16"};
const char* const numm[15]={"-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13"};
const char* const esnum[14]={"&0","&1","&2","&3","&4","&5","&6","&7","&8","&9","10","11","12","13"};
const char* const alph[26]={"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"};
const char* const Alph[26]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"};
const char* const symbcoul[5]={"♣","\u2666","\u2665","\u2660","SA"};
const char* const scoul[5]={"\u2660","\u2665","\u2666","♣","SA"};
const Fl_Color coulsymb[5]={59,169,89,136,0};
const Fl_Color couls[5]={136,89,169,59,0};

int espcoul(int c);

const char P=0;
const char C=1;
const char K=2;
const char T=3;

//const char* const njoueurs[4]={"Nord","Est","Sud","Ouest"};

const vector<string> vcoulssa={"Pique","Cœur","Carreau","Trèfle","Sans-atout"};
const vector<string> nomjoueur={"Nord","Est","Sud","Ouest"};
const char jsymbs[4]={'N','E','S','O'};
const char symbj[4]={'S','O','N','E'};

const vector<char> vide(52,'V');

typedef std::vector<string> serie_donnes;

//Structures conditions
struct v_n{
v_n(int id,string s):v(id),nom(s),nombrut(s){}
v_n(int id,string s,string ss):v(id),nom(s),nombrut(ss){}
  int v;//la valeur
  string nom;//l'affichage
  string nombrut;
};

struct Condition{
Condition(int n,string s):no(n),nom(s){}
  int no;
  string nom;
  vector<string> params;//noms des paramètres
  vector<vector<v_n>> choix;
  vector<int> l_browsers;//longueurs des browsers
  vector<int> xvsb;//longueur + etiquette
  string nomchoix(int i,int v);
  string nombrutchoix(int i,int v);//défini dans contraintes.cpp
};


vector<Condition> ajoute_conditions();
extern vector<Condition> conditions;

struct Param_Choix{
Param_Choix(int i,v_n c): param(i),choix(c){v=c.v;}
  int param;
  v_n choix;
  int v;
};


struct Condouv{
  Condouv(){
    joueur=2;
    id_condition=-3;
  }
  int id_condition;
  int joueur;
  vector<int> params;

  virtual ~Condouv(){}
};

struct Calcul{
  string nom;
  string alg;
  bool affiche;
};

//Contraintes
struct Contraintes{
  Contraintes(string s="");
  string con;
  int id;
  string nom;
  char cfixees[52];
  int numerofixe;//0 si le numéro varie, sinon numéro fixé, négatif pour donneur fixe
  vector<Condouv> cocos;
  vector<int> numrestants;
  int nbmarquees[4];
  int nblibres;
  //string alg;
  vector<Calcul> calculs;
  //const char* contexte;
  
  void eff();
  unsigned short nb_cocos(){return cocos.size();};
};

struct structpar{
  int score;
  int joueur;
  int contrat;
};

//Fonctions de ddd
int vainqueur(int couleurs[4],int rangs[4],int atout);

//Fonctions de boucle
void randomise(vector<int>& A);
void distribue(Contraintes& contr,char* liste);
void creedonne(char* liste,const char fixees[52],const Contraintes& contr);
serie_donnes boucle(int nb_donnes,Contraintes& contraintes,int limite,int *pi);
string cartes_couleur(char* liste,char j,int c);
string cartes_couleur(string liste,char j,int c);
vector<bool> vconditions(char* liste,int no);
bool traite(std::vector<bool>& conds,std::string alg);
bool traite(vector<bool>& conds,string alg,vector<bool>& calcs);
bool cond_ouvs(char* liste,Contraintes& contr,int no=1);

//Fonctions de co
bool cond_points(char* liste,Condouv& coco);
bool cond_ldj(char* liste,Condouv& coco);
bool ouverture(char* liste,int no,Condouv& coco);
bool ouv1T(char* liste,int joueur,int sys,int no,int part=0);
bool ouv1K(char* liste,int joueur,int sys,int no,int part=0);
bool ouv1C(char* liste,int joueur,int sys,int no,int part=0);
bool ouv1P(char*,int joueur,int sys,int no,int part=0);
bool ouv1SA(char* liste,int joueur,int sys,int no,int part=0);
bool ouv2T(char* liste,int joueur,int sys,int no,int part=0);
bool ouv2K(char* liste,int joueur,int sys,int no,int part=0);
bool ouv2C(char* liste,int joueur,int sys,int no);
bool ouv2P(char* liste,int joueur,int sys,int no);
bool ouv2M(char* liste,int joueur,int sys,int no);
bool cond_2Mfaible(int c,char* liste,int joueur,bool);
bool ouv2C_Muiderberg(char* liste,int joueur,int no);
bool ouv2C_Ekren(char* liste,int joueur,int no);
bool ouv2SA(char* liste,int joueur,int sys,int no);
bool ouvsuper2SA(char* liste,int joueur,int sys,int no);
bool cond2Mfort(int c,char* liste,int joueur);
bool cond2mfort(int c,char* liste,int joueur);
bool ouv3T(char* liste,int joueur,int sys,int no);
bool ouv3K(char* liste,int joueur,int sys,int no);
bool ouv3C(char liste[52], int joueur, int sys,int no);
bool ouv3P(char liste[52], int joueur, int sys,int no);
bool ouv3SA(char liste[52], int joueur, int sys,int no);
bool ouv4T(char* liste,int joueur,int sys,int no);
bool ouv4K(char* liste,int joueur,int sys,int no);
bool ouv4C(char liste[52],int joueur,int sys,int no);
bool ouv4P(char liste[52],int joueur,int sys,int no);
bool repo(char* liste,int no,Condouv& coco);
bool intervention(char* liste,Condouv& coco,int no);
bool forme(char* liste, Condouv& coco);
bool coul_plus_longue(char* liste,int joueur,int couleur,int mode);
bool comp_couleurs(char liste[52], Condouv& coco);
bool distribution(char liste[52], Condouv& coco);
bool coul_plus_longue(char liste[52],Condouv& coco);
bool teneur(char liste[52], Condouv& coco);
bool nb_cartes(char liste[52], Condouv& coco);
bool cartes_niveau(char liste[52],Condouv& coco);
bool arret(char liste[2], int joueur, std::vector<int>& params);
bool arret(char* liste,Condouv& coco);
bool cles(char* liste,const Condouv& coco);
bool contr_italiens(char* liste,const Condouv& coco);

//Fonctions de fonctions
//int indexliste(char liste[4],char v);
//extern const string cartes;
extern const char* sycoul[4];
bool dans(int k,int m,int M);
void tri(int*);
//void tri(vector<int>&);
void tri(vector<int>& t,vector<float>& v);
void tri(vector<int>& t,vector<int>& v);
void trifut(int suit[13],int rank[13],int score[13]);
void affiche(const vector<int>&);
int bitdans(unsigned int b,int r);
int comptebit(unsigned int v, int maxr=15, int minr=0);
unsigned int maxbit(unsigned int v,unsigned int maxr);
unsigned int minbit(unsigned int v,unsigned int minr,unsigned int lim);
void remaintoliste(unsigned int rc[4][4],char*);
void listetoremain(char*,unsigned int rc[4][4]);
string bitstocartes(unsigned int n);
int coulno(int no);
int rang(int no);
string aff_carte(int no);
char* cartetochar(int no);
int nomstoent(const string& s);
string enttonoms(int);
vector<int> maxlongs(unsigned int rc[4][4]);
vector<int> numeros(char*,char L);
vector<int> numeros_entame(char*,char L);
vector<int> numeros_utiles(char*,char L);
vector<int> numeros_jouables(char*,char L,int c);
string enchere(int contrat);
void complete_rc(int remainCards[4][4]);
void complete_donne(char fixees[52]);

//Fonctions de fbridge
int coulenbits(char liste[52], int joueur,int couleur);
int compte(char* liste,int joueur,int couleur,int sup=13,int inf=0);
bool aas(char* liste,int joueur, int couleur);
bool roi(char* liste,int joueur,int couleur);
bool dame(char* liste,int joueur,int couleur);
bool valet(char* liste, int joueur,int couleur);
bool dix(char liste[52], int joueur,int couleur);
int points(char* liste,int joueur);
int points(char* liste,int joueur,int couleur);
void fodistr(char* liste, int joueur, int* dist,int* disttri);
int pointsHL(char* liste,int joueur);
float pointsDHS(char* liste,int joueur,int couleur);
int xxxx(char* liste,int joueur);
int pointsDH(char* liste,int joueur);
int couleur_max(char* liste,int joueur);
int vul(int joueur,int no);
unsigned short position(int joueur,int no);
unsigned short nbas(char*,int joueur);
unsigned short nbcles(char*,int joueur,int couleur);
int condSA(char*,int joueur,int zone=1,bool maj=1);
bool donneur(int joueur,int no);
float ldj(char liste[52],int joueur);
bool ouv_barrage_nat(char liste[52], int joueur, int couleur, int palier, int no);
int perdantes(char liste[52], int joueur);
int arrets(char*,int,int);
int nb_rang(char liste[52],int joueur,int rang);
int nb_contr_it(char* liste,int joueur);
bool cond_bicolore(char* liste,int joueur,int couleur1,int couleur2,int H1=1,int H2=2);

//Fonctions de interventions
bool cond_int1(char* liste,int joueur,int couleur,bool vv);
bool cond_int1sur(char* liste,int joueur,int couleur,bool vv);
bool cond_int1SA(char* liste,int joueur,int coul_ouv);
bool cond_int2(char* liste,int joueur,int couleur,bool vv);
bool cond_int2sur(char* liste,int joueur,int couleur,bool vv);
bool cond_contre(char* liste,int joueur,int contrat,bool vv);
bool cond_int_bic(char* liste,int joueur,int couleur1,int couleur2,bool vv);
bool cond_Landy(char* liste,int joueur,bool vul);

//Fonctions de ddd
void free_fut(futureTricks& fut);

//Fonctions de scores
int fscore(int levees,int niv,int couleur,bool vul,int contre);
double esperance(vector<double>& probas,int niv,int co,bool vul,int contre=0);
int par(int tabddt[5][4],int no,structpar& resupar);

//Fonctions de points
double pointshl(int,float);

#endif


