#ifndef FENETRE_H
#define FENETRE_H

#include "gen.h"
#include <fstream>
#include "fltk.h"
#include <vector>
#include <ctime>

#include "condouv.h"
#include "dll.h"

#define CC 20
#define HC 20 //hauteur bouton carte
#define ESPC 3
#define ESPD 8
#define HMENU 28
#define HCOCO 25


void affiche(char*);



//INITIALISATION
struct Config{
  string cmdpdf;
  string nomcontr;
  int nbthreads=1;
  int remplace(string,string);
  bool debug=false;
};
extern Config config;

template <typename T>
std::string to_string(T value){
  std::ostringstream os;
  os<<value;
  return os.str();
}

//std::string istring(int n);

extern int nbstat;
//int limite=31;


inline int x_max() { return Fl::w(); }	// width of screen in pixels
inline int y_max() { return Fl::h(); }	// height of screen in pixels

const int xm = x_max();
const int ym = y_max();

//Longueur et hauteur d'un jeu
const int ljeu=14*CC+15*ESPC;
const int hjeu=4*CC+5*ESPC;



//Coin supérieur gauche de la boîte fmains contenant les jeux pour fixées
const int xfmains=(xm-3*ljeu)/2+100;
const int yfmains=50;
const int wfmains=3*ljeu+2*ESPD;
const int hfmains=3*hjeu+2*ESPD;

//Constantes pour affichage des donnes
const Fl_Color couleur_affichage=fl_rgb_color(172,251,202);
//Largeur fenêtre affichage waff
const int waff=2*xm/3+30;
//Largeur une donne daff
const int daff=(waff-2*ESPC)/3;
//Coté d'une main maff
const int maff=(daff-2*ESPC)/3;

//Position dans le groupe gcocos
const int xbcocos=xfmains;
const int ybcocos=yfmains+hfmains+ESPD;
const int wbcocos=wfmains;
//const int hbcocos=400;
const int wajouter=200;

//Ordonnée de la première coco
const int ypremcoco=ybcocos+ESPD;
//abscisse première boîte
const int xnumcoco=xbcocos+ESPD+CC;
//abscisse boîte des joueurs
const int xjcoco=xnumcoco+35;
//abscisse boîte choix condition
const int xbcond=xjcoco+130;
const int xgparams=xbcond+160;

///////////////////////////////////////////////////////////////////////
/* ------------------------------ Couleurs --------------------------*/
///////////////////////////////////////////////////////////////////////
const int couleur_main=87;

//Constantes pour l'affichage des contraintes
const Fl_Color coul_fenetre_contr=fl_rgb_color(250,244,184);
const Fl_Color couleur_bord=fl_rgb_color(255,187,68);
const Fl_Color couleur_fond=fl_rgb_color(255,255,208);

const Fl_Color blanc_casse=fl_rgb_color(254,254,226);
const Fl_Color bleu_leger=fl_rgb_color(190,231,239);
const Fl_Color beige_clair=fl_rgb_color(245,245,220);

const Fl_Color coulformext=fl_rgb_color(40,101,80);
const Fl_Color coulformint=fl_rgb_color(250,255,224);

//Constantes DDS et STATS
const int xddd=xfmains;
//const int yddd=150;
//const int wddd=wfmains;
const int hddd=y_max()-150;
const int xbchoix=xddd;
const int ybchoix=150;
const int wbchoix=wfmains;

//Constantes statistique
const int dxSelect=180;
const int largeurSelect=70;
const int hboutonSelect=25;
const int hauteurSelect=80;
const int hcg=50; //hauteur Check Groupe
const int xbcontrats=xbchoix+50;
const int ybcontrats=ybchoix+50+ESPD;
const int wbcontrats=wbchoix-100;

extern Contraintes contr;
extern deal* pdl;
extern int target;
extern int limite;

//extern const string cartes;
const string cartes("0123456789XVDRA");

typedef void(*Callback)(Fl_Widget*,void*);

struct BoutonSymb;


struct Deux_Vides{
Deux_Vides(int n,Fl_Button* b,Fl_Group* g):pb(b),pg(g),no_coco(n){}
Deux_Vides(int n,Fl_Button* b):pb(b),pg(0),no_coco(n){}
  Fl_Button* pb;
  Fl_Group* pg;
  unsigned short no_coco;
};

//Un entier et un output
struct Int_Output{
Int_Output(unsigned short n,Fl_Output* b,Fl_Group* g):no_coco(n),pb(b),pg(g){}
Int_Output(unsigned short n,Fl_Output* b):no_coco(n),pb(b),pg(0){}
  Fl_Output* pb;
  Fl_Group* pg;
  unsigned short no_coco;
};

//Un entier et un BoutonSymb
struct Int_BS{
Int_BS(unsigned short n,BoutonSymb* bs):no_coco(n),pbs(bs){}
  BoutonSymb* pbs;
  unsigned short no_coco;
};

bool dans(int k,int m,int M);//dans statistiques.cpp

void enregistre_contr(const char*);//dans contraintes.cpp

class BoitePar:public Fl_Box{
 public:
 BoitePar(int X,int Y,int W,int H,structpar& R):Fl_Box(X,Y,W,H),resupar(R){
  }
  structpar resupar;
  char niveau[5];
  char ccc[15];
  double xx;
  void draw(){
    xx=x();
    fl_color(FL_GRAY0);
    fl_draw("Par:",xx,y(),fl_width("Par: "),25,FL_ALIGN_LEFT);
    sprintf(niveau,"%d",resupar.contrat/10);
    xx+=fl_width("Par: ");
    fl_draw(niveau,xx,y(),fl_width(niveau),25,FL_ALIGN_CENTER);
    int a=resupar.contrat%5;
    fl_color(coulsymb[resupar.contrat%5]);
    if (a<4) fl_font(FL_HELVETICA,18);
    sprintf(ccc,"%s",symbcoul[resupar.contrat%5]);
    xx+=fl_width(niveau);
    fl_draw(ccc,xx,y(),fl_width(ccc),25,FL_ALIGN_LEFT);
    xx+=fl_width(ccc)+3;
    fl_font(FL_HELVETICA,14);
    fl_color(FL_GRAY0);
    if (resupar.contrat%10 >= 5) fl_draw("X",xx,y(),fl_width("X"),25,FL_ALIGN_LEFT);
    xx+=10;
    sprintf(ccc," par %s %d",joueurs[resupar.joueur],resupar.score);
    fl_draw(ccc,xx,y(),100,25,FL_ALIGN_LEFT);
  }
};

class BoutonSelect:public Fl_Button{
  //Bouton pour select carte entame
public:
  BoutonSelect(int X,int Y,int W,int H,int N=-1,const char* L=0L):Fl_Button(X,Y,W,H,L),no(N){
    color(FL_WHITE);
  }
  int no;
  char csc[2];
  char ccc[8];
  void draw(){
    if (no==-1) Fl_Button::draw();
    else {
      //cout<<"retrace "<<no<<endl;
      fl_color(FL_WHITE);
      fl_draw_box(FL_UP_BOX,x(),y(),w(),h(),FL_WHITE);
      sprintf(csc,"%c",cartes[rang(no)]);
      fl_color(FL_BLACK);
      fl_draw(csc,x()+w()/2-11,y(),14,25,FL_ALIGN_CENTER);
      fl_color(coulsymb[coulno(no)]);
      fl_font(FL_HELVETICA,18);
      sprintf(ccc,"%s",scoul[coulno(no)]);
      fl_draw(ccc,x()+w()/2,y(),15,23,FL_ALIGN_CENTER);
      fl_font(FL_HELVETICA,15);
    }
  }
};



class Fenetre:public Fl_Double_Window{
 public:
  Fenetre(int w,int h,const char *s);
  virtual ~Fenetre(){}

  int x_max() const { return w; }
  int y_max() const { return h; }


  void ajoute_titre(const char* titre);
  void ajoute_menu();
  void ajoute_image();

  //callbacks du menu
  static void cb_quit(Fl_Widget*,void* p){ 
    Fenetre* win=(Fenetre*)p;
    enregistre_contr((char*)"contraintes/perso");
    win->hide();}
  static void cb_ini(Fl_Widget*,void* p){
    Fenetre* win=(Fenetre*)p;
    win->initialise();}
  static void cb_fixe(Fl_Widget*,void* p){
    Fenetre* win=(Fenetre*)p;
    win->changer_contraintes();
  }
  static void cb_distr(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    win->affiche();}
  static void cb_enr_contr(Fl_Widget*,void* pw){
    if (env.page=="ajoute"){
      fl_alert("Coco ajoutée mais non définie");
      return;
    }
    Fenetre* win=(Fenetre*)pw;
    win->enr_contr();}
  static void cb_choisir_contr(Fl_Widget*,void*);
  
  //static void cb_dddini(Fl_Widget*,void*);
  static void cb_demarre_analyse(Fl_Widget*,void*);
  static void cb_retour(Fl_Widget*,void*);
  static void cb_analyse(Fl_Widget*,void*);
  
  static void cb_comparer(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    //Donneur et vulnérabilité sont fixes.
    if (contr.numerofixe <1) {
      fl_alert(" Donneur et vulnérabilités doivent être fixés ");
      return;
    }
    else win->comparer();
  }
  static void cb_stats_levees(Fl_Widget*,void* pw){
   Fenetre* win=(Fenetre*)pw;
   env.page="levees";
   if (contr.numerofixe<1) {
    fl_alert("Attention la vulnérabilité n'est pas fixée, calculs pour donne 1");
    contr.numerofixe=1;
  }
   win->stats_levees();}
  static void cb_entames(Fl_Widget*,void* pw);
  static void cb_formpasapas(Fl_Widget*,void*);
  static void cb_ajouter(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    if (win->gcontr) win->ajoute();
    else{
      cout<<"pas de gcontr"<<endl;
      win->changer_contraintes();
    }
  }
  static void cb_contexte(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    win->ajoute_contexte();}
  static void cb_calcul(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    win->ajoute_calcul();}
  static void cb_distribution(Fl_Widget*,void* pw){
    Fenetre* win=(Fenetre*)pw;
    win->distribution();
  }
  static void cb_evaluation(Fl_Widget*,void* pw);


  //Utilitaires contraintes
  void initialise();
  //void montrer_contraintes();
  void affiche();
  void enr_contr();
  void choisir_contr();
  void charge_contr(const char* charnom);
  //void ddd(const char* nom="Vous pouvez rentrer la donne complète ou partielle. Si la donne est complète, 3 jeux suffisent.");
  void enr_dds();
  void choisir_dds();

  static void cb_bjoueur(Fl_Widget* pw,void* pd){
    Fl_Select_Browser* jb=(Fl_Select_Browser*)pd;
    jb->show();
    }
  static void cb_joueur(Fl_Widget* w,void* sdata);
  static void cb_ojoueur(Fl_Widget* w,void* sdata);
  static void cb_condition(Fl_Widget*,void*);
  static void cb_ocondition(Fl_Widget*,void*);
  static void cb_param(Fl_Widget*,void*);

  //Utilitaires affichage contraintes
  void ini_gcontr();
  void montrer_fixees(int x,int y,Callback cb,char*,const char* lab=0L);
  void changer_contraintes();
  void ajoute();
  void ajoute_params(int,const Condition&);
  void modif_coco(int n);
  void supprime_coco(int n);
  void montre_cocos();
  void montre_params(Condouv&,int,Fl_Group*);
  void place_params(int n,const Condition& condition,Fl_Group* gparams);
  void montre_calculs();
  void ajoute_contexte();
  void ajoute_calcul();
  void place_calcul(int i);
 

  //Utilitaires affichage dds
  void affiche_dds();
  void place_jeu_dds(int x,int y,int joueur,int first);
  void place_couleur_dds(int x,int y,int couleur,int nini,int n,int);

  //Utilitaires pour statistiques (statistiques.cpp)
  void comparer(bool brep=0,int nb=0,int t=0);
  void res_compare();
  void stats_levees();
  void res_levees(vector<bool>&);
  void entames();
  void res_compentames();
  void formpasapas();
  void sur();
  void aff_sur_result(vector<int>&);

  //Utilitaires pour probas
  void distribution(double PA=-1,double PAB=-1);
  void calcdistr();

  //Utilitaires pour évaluation
  void evaluation();

  //Widgets de la fenêtre
  Fl_Group* gimage=0;
  Fl_Box* btitre=0;
  Fl_Group* gcontr=0;
  Fl_Scroll* scroll=0;
  Fl_Group* gmains=0;
  Fl_Box* bcocos=0;
  Fl_Scroll* gcocos=0;
  Fl_Group* gcalculs=0;
  Fl_Output* input_contr=0;
  //Fl_Group* gddd=0;
  Fl_Group* gjdds=0;
  Fl_Group* gcompare=0;
  Fl_Group* gstats=0;
  Fl_Group* gres_lev=0;
  Fl_Input* ialg=0;
  Fl_Input* inbstat=0;
  Fl_Group* gmodif=0;
  Fl_Scroll* gentames=0;
  Fl_Group* bres=0;
  Fl_Group* gpasapas=0;
  Fl_Group* gsur=0;
  Fl_Group* gdistribution=0;
  Fl_Group* geval=0;


  void detruit_widgets();
  
  private:
  int w,h;
  void init();
};


////////////////////////////////////////////////////////////////////////////////
/* ---------------------------- LES BOITES ---------------------------------- */
////////////////////////////////////////////////////////////////////////////////
// Les définitions non présentes ici sont dans boites.cpp

//Structure pour les boîtes de mise en page
struct BoiteForm:Fl_Box{
 BoiteForm(int Y,int H,const char* s=0L,int X=xbcontrats,int W=wbcontrats):Fl_Box(X,Y,W,H,s){
    box(FL_UP_BOX);
    align(FL_ALIGN_LEFT_TOP);
    labeltype(FL_ENGRAVED_LABEL);
    labelsize(18);
    color(coul_fenetre_contr);
  }
};

//Boîte avec cadre
struct BoiteCadre:Fl_Box{
 BoiteCadre(int X,int Y,int W,int H,const char* L=0L,int B=2,int CB=couleur_bord,int CF=couleur_fond):Fl_Box(X,Y,W,H,L),bord(B),cbord(CB),fond(CF){}
  int bord;
  Fl_Color cbord;
  Fl_Color fond;
  void draw();
};

//Structure pour les titres de page
struct Titrepage:Fl_Box{
 Titrepage(const char* s,int Y=80,int X=100,int W=x_max()-200):Fl_Box(X,Y,W,50,s){
    labelsize(40);
    labelfont(FL_HELVETICA_BOLD);
    align(FL_ALIGN_WRAP);
  }
};

//Boite de formulaire avec légende type fieldset
struct BoiteChamp:Fl_Box{
 BoiteChamp(int X,int Y,int W,int H,const char* L):Fl_Box(X,Y,W,H,L){}
  void draw();
};

//Boites pour texte court
struct BoiteTexte:Fl_Box{
 BoiteTexte(const char* L, int X,int Y,int fs=14,Fl_Color c=FL_GRAY0,int ff=FL_HELVETICA):Fl_Box(X,Y,0,0,L),fonte(ff),taille(fs),couleur(c){}

  int fonte;
  int taille;
  Fl_Color couleur;
  void draw(){
    fl_font(fonte,taille);
    int ll=fl_width(label());
    fl_color(couleur);
    fl_draw(label(),x(),y(),ll,taille+2*ESPD,FL_ALIGN_CENTER,0,0);
  }
};

struct BoiteTexte2:Fl_Box{
 BoiteTexte2(int X,int Y,const char* L):Fl_Box(X,Y,80,25,L){
    int ll=fl_width(L);
    size(ll,25);
  }
};

//Boite avec carte type A♣ //
struct BoiteCarte:Fl_Box{
 BoiteCarte(int n,int X,int Y,int W,int H):Fl_Box(X,Y,W,H),no(n){}
  int no;
  void draw();
};

//Boites pour nombre de tirages et limite (dans statistiques.cpp)
void intparametres(int Y,int X=xbcontrats,int W=wbcontrats);
void parametres(int Y,int X=xbcontrats,int W=wbcontrats);

//Boites pour texte contenant un symbole de couleur
struct BoiteParams:Fl_Box{
 BoiteParams(string S,int X,int Y,int W,int H):Fl_Box(X,Y,W,H),ch(S){}

  string ch;
  void draw();
};


/* ------------------------------ BOUTONS ---------------------------------------*/
//Bouton pour select
struct BoutonChoix:Fl_Button{
 BoutonChoix(int X,int Y,int W,int H,const char* L=0L):Fl_Button(X,Y,W,H,L){}
  void draw();
};

//Bouton avec symbole couleur dans étiquette
struct BoutonSymb:Fl_Button{
 BoutonSymb(string s,int X,int Y,int W,int H):Fl_Button(X,Y,W,H),ch(s){}

  string ch;
  void draw();

};


//Voir BoutonCarte dans stat.h
/* ------------------------------ BROWSERS ------------------------------------- */
//Select Browser pour intervalle de nombres
struct SelectNombre:Fl_Select_Browser{
 SelectNombre(int X,int Y,int W,int H,int M,int m=0):Fl_Select_Browser(X,Y,W,H){
    for (int i=m;i<M+1;i++) add(to_string(i).c_str());
    hide();
  }
};
//Select Browser pour couleur
struct SelectCouleur:Fl_Select_Browser{
 SelectCouleur(int X,int Y,int W,int H):Fl_Select_Browser(X,Y,W,H){
    for (int i=0;i<5;i++) add(sacouls[i]);
    hide();
  }
};
//Select Browser pour joueur
struct SelectJoueur:Fl_Select_Browser{
 SelectJoueur(int X,int Y,int W,int H):Fl_Select_Browser(X,Y,W,H){
    for (int j=0;j<4;j++) add(joueurs[(j+2)%4]);
    hide();
  }
};
//////////////////////////////////////////////////////////////////////////////////
/* ------------------------- STRUCURES DATA DE CALLBACK ----------------------- */
//////////////////////////////////////////////////////////////////////////////////

//Structure contenant 1 entier et un bouton
struct IntBouton{
IntBouton(int c,Fl_Button* b):entier(c),bouton(b){}
  int entier;
  Fl_Button* bouton;
};

//Structure contenant 1 entier, un vecteur d'entiers, un bouton et la fenêtre
struct IntVIBouton{
IntVIBouton(int c,vector<int> vi,Fl_Button* b):entier(c),vecteur(vi),bouton(b){}
  int entier;
  vector<int> vecteur;
  Fl_Button* bouton;
};

//Structure contenant 1 entier, un vecteur d'entiers, un BoutonSelect
struct IntVIBS{
IntVIBS(int c,vector<int> vi,BoutonSelect* b):entier(c),vecteur(vi),bouton(b){}
  int entier;
  vector<int> vecteur;
  BoutonSelect* bouton;
};

//Structure contenant un entier et un select
//struct IntSelect{
//IntSelect(int n,Fl_Select_Browser* s):entier(n),select(s){}
//  int entier;
//  Fl_Select_Browser* select;
//};

//Fenetre, output et groupe
struct DataCond{
DataCond(int n,Fenetre* w,Fl_Output* b,Fl_Group* g):no_coco(n),win(w),pb(b),pg(g){}
  Fenetre* win;
  Fl_Output* pb;
  Fl_Group* pg;
  unsigned short no_coco;
  };


//Structure pour la fenêtre et un bouton
struct WinBout{
WinBout(Fenetre* f,Fl_Button* b):win(f),bout(b){}
  Fenetre* win;
  Fl_Button* bout;
  };


//Structure pour la fenêtre, un entier et un bouton
struct WinNBout{
WinNBout(Fenetre* f,int n,Fl_Button* b):win(f),no_coco(n),bouton(b){}
  Fenetre* win;
  int no_coco;
  Fl_Button* bouton;
};

//Structure pour la fenêtre, un entier et un output
struct WinNOut{
WinNOut(Fenetre* f,int n,Fl_Output* b):win(f),no_coco(n),bouton(b){}
  Fenetre* win;
  int no_coco;
  Fl_Output* bouton;
};

//Structure pour la fenêtre, un entier et un goupe
struct WinNG{
WinNG(Fenetre* f,int no,Fl_Group* b):fenetre(f),n(no),groupe(b){}
  Fenetre* fenetre;
  int n;
  Fl_Group* groupe;
};

//Structure contenant 1 entier et l'adresse de la fenêtre
struct IntWin{
IntWin(int nn,Fenetre* f):n(nn),fenetre(f){}
  int n;
  Fenetre* fenetre;
};

//Structure contenant un joueur, une carte(couleur+rang) et l'adresse de la fenêtre
struct CardWin{
CardWin(int j,int s,int r,Fenetre* f):joueur(j),suit(s),rank(r),fenetre(f){}
  int joueur;
  int suit;
  int rank;
  Fenetre* fenetre;
};

//Structure pour stat_levées contenant les couleurs, les déclarants, le nb de donnes)
struct IntIntWin{
  IntIntWin(int nb,int lim,Fenetre* w):nbstat(nb),limite(lim),win(w){}

  //vector<bool> couleurs;
  //vector<int> declarants;
  int nbstat;
  int limite;
  Fenetre* win;
};

struct Symb_Couleur:Fl_Button{
 Symb_Couleur(int x,int y,char c):
  Fl_Button(x,y,CC,CC,""){
    box(FL_NO_BOX);
    labelsize(18);
    switch(c){
    case 'P':
      labelcolor(fl_rgb_color(17,17,68));
      label("♠");
      break;
    case 'C':
      labelcolor(FL_RED);
      label("♥");
      break;
    case 'K':
      labelcolor(fl_rgb_color(240,68,51));
      label("♦");
      break;
    case 'T':
      labelcolor(fl_rgb_color(17,68,17));
      label("♣");
      break;
    default:
      break;
    }
  }
};

struct Symb_couleur:Fl_Box{
 Symb_couleur(int x,int y,int c):
  Fl_Box(x,y,CC,CC){
    box(FL_NO_BOX);
    labelsize(18);
    switch(c){
    case P:
      labelcolor(fl_rgb_color(17,17,68));
      label("♠");
      break;
    case C:
      labelcolor(FL_RED);
      label("♥");
      break;
    case K:
      labelcolor(fl_rgb_color(240,68,51));
      label("♦");
      break;
    case T:
      labelcolor(fl_rgb_color(17,68,17));
      label("♣");
      break;
    default:
      break;
    }
  }
};



//Une boîte pour placer une main à partir du caractère du joueur. (x,y) est la position de la bpîte englobant les 4 jeux.
// Si les fixees ne sont pas contr.cfixees, celles-ci sont grisées.
struct Boite_Jeu:Fl_Box{
 Boite_Jeu(int xx,int yy,int ljeu,int hjeu,char J,Callback cb_c,char fixees[52],Fl_Color c=FL_WHITE):Fl_Box(xx,yy,ljeu,hjeu){
    int k=0;
    color(c);
    labeltype(FL_NO_LABEL);
    switch(J){
    case 'N':
      position(x()+ESPC+ljeu,y()+ESPC);
      break;
    case 'O':
      position(x()+ESPC,y()+ESPC+hjeu);
      k=3;
      break;
    case 'E':
      position(x()+ESPC+2*ljeu,y()+ESPC+hjeu);
      k=1;
      break;
    case 'S':
      position(x()+ESPC+ljeu,y()+ESPC+2*hjeu);
      k=2;
      break;
    default:
      break;
    }
    new Symb_Couleur(x()+ESPC,y()+2*ESPC,'P');
    new Symb_Couleur(x()+ESPC,y()+2*ESPC+CC,'C');
    new Symb_Couleur(x()+ESPC,y()+3*ESPC+2*CC,'K');
    new Symb_Couleur(x()+ESPC,y()+4*ESPC+3*CC,'T');
    for (int i=0;i<4;i++){
      for (int j=0;j<13;j++){
	Fl_Button* bout=new Fl_Button(x()+(CC+ESPC)*(j+1),y()+(CC+ESPC)*i+ESPC,CC,CC,vl[j]);
	int *num=new int;
	*num=k+4*i+16*(14-j);//k joueur i couleur j rang (As=14)
	int no=13*(3-i)+j;
	if (jsymbs[k]==fixees[no]){
	  bout->value(0);
	  bout->labelcolor(FL_DARK_BLUE);
	  bout->color(255);}
	else {
	  bout->value(1);
	  if (fixees!=contr.cfixees && jsymbs[k]==contr.cfixees[no]){
	    bout->down_color(FL_GRAY);
	  }
	  else bout->down_color(couleur_main);
	  bout->labelcolor(FL_RED);
	}
	bout->callback(cb_c,(void*)num);
	vnord.push_back(bout);
      }
    }
  }
  vector<Fl_Button*> vnord;
  virtual ~Boite_Jeu(){};
  static void cb_carte(Fl_Widget*,void*);
};

struct Boite_Main:Fl_Box{
  Boite_Main(int x,int y,int w,int h,char* liste,char J);
  virtual ~Boite_Main(){};
};
struct Centre:Fl_Box{
  Centre(int x,int y,int w,int n);

  virtual ~Centre(){};
};

//Bouton carte est un bouton de carte jouable
struct Bouton_carte:Fl_Button{
 Bouton_carte(int x,int y,int r):Fl_Button(x,y,CC,HC,vl[14-r]){
    color(FL_WHITE);
}
  virtual ~Bouton_carte(){};
};

void place_couleur_dds(int x,int y,int c,int n);
void place_couleur_dds(int x,int y,int couleur,int nini,int n,int joueur,futureTricks& fut);
void place_jeu_dds(int x,int y,deal* pdl,int joueur);

void cb_boutoncarte(Fl_Widget* obj,void* data);

void cb_ncoco(Fl_Widget* pw,void* data);
void cb_bval(Fl_Widget* w,void* pw);
void cb_sup(Fl_Widget*,void*);

void res_entames();

void cb_probas(Fl_Widget*,void*);
void cb_options(Fl_Widget*,void*);
void cb_surcontraintes(Fl_Widget*,void*);

void cb_tabdds(Fl_Widget*,void*);

// Statistique
struct DonneesStat{
  int target;
  int atout;
  int first;
  int contre;
  DonneesStat(){};
  DonneesStat(int niveau,int couleur,int declarant,int contr):
    target(8-niveau),atout(couleur),first((declarant+1)%4),contre(contr){}
};

int statlevees(DonneesStat& dstat);
void cb_inbdonnes(Fl_Widget* w,void*);

void ecrit_debug(string texte);
/*{
  ofstream fichier;
  fichier.open("debug");
  fichier<<texte<<"\n";
  fichier.close();
  };*/

#endif
