#include "fenetre.h"
#include <FL/Fl_Table.H>

#define MAX_ROWS 14
#define MAX_COLS 15

//int lcol=100;		// A-Z

/* --------------------- TABLEAU STAT LEVEES -------------------- */

// Derive a class from Fl_Table
class MyTable : public Fl_Table {
 public:
  int data[14][4];		// data array for cells
  double pourcentage[14];
 private:
  
  const char* hdata[4]={"Levées","% réussite","Esp. NV","Esp. V"};
  // Draw the row/col headings
  //    Make this a dark thin upbox with the text inside.
  //
  void DrawHeader(const char *s, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
    //fl_draw_box(FL_THIN_UP_BOX, X,Y,W,H, row_header_color());
    fl_draw_box(FL_THIN_UP_BOX, X,Y,W,2*H,coul_fenetre_contr);
    //fl_color(FL_BLACK);
    fl_color(FL_DARK_BLUE);
    fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
    fl_pop_clip();
  } 
  // Draw the cell data
  //    Dark gray text on white background with subtle border
  //
  void DrawData(const char *s, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
      // Draw cell bg
      fl_color(FL_WHITE); fl_rectf(X,Y,W,H);
      // Draw cell data
      fl_color(FL_GRAY0); fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
      // Draw box border
      fl_color(color()); fl_rect(X,Y,W,H);
    fl_pop_clip();
  } 
  // Handle drawing table's cells
  //     Fl_Table calls this function to draw each visible cell in the table.
  //     It's up to us to use FLTK's drawing functions to draw the cells the way we want.
  //
  void draw_cell(TableContext context, int ROW=0, int COL=0, int X=0, int Y=0, int W=0, int H=0) {
    static char s[40];
    switch ( context ) {
      case CONTEXT_STARTPAGE:                   // before page is drawn..
        fl_font(FL_HELVETICA, 16);              // set the font for our drawing operations
        return; 
      case CONTEXT_COL_HEADER:                  // Draw column headers
        //sprintf(s,"%c",'A'+COL);              // "A", "B", "C", etc.
	sprintf(s,"%s",hdata[COL]);
	DrawHeader(s,X,Y,W,H);
        return; 
      case CONTEXT_ROW_HEADER:                  // Draw row headers
        sprintf(s,"%03d:",ROW);                 // "001:", "002:", etc
        DrawHeader(s,X,Y,W,H);
        return; 
      case CONTEXT_CELL:                        // Draw data in cells
	if (COL==0 || (ROW>6 && COL!=1)) sprintf(s,"%d",data[ROW][COL]);
	else if (COL==1) sprintf(s,"%3.1f",pourcentage[ROW]);
	else sprintf(s,"",ROW);
	DrawData(s,X,Y,W,H);
	return;
      default:
        return;
    }
  }
public:
  // Constructor
  //     Make our data array, and initialize the table options.
  //
  MyTable(int X, int Y, int W, int H, const char *L=0) : Fl_Table(X,Y,W,H,L) {
    // Fill data array
    for ( int r=0; r<14; r++ ){
      data[r][0]=r;
      //for ( int c=1; c<MAX_COLS; c++ )
      //  data[r][c] = 1000+(r*1000)+c;
    }
    // Rows
    rows(14);             // how many rows
    row_header(0);              // enable row headers (along left)
    row_height_all(30);         // default height of rows
    row_resize(0);              // disable row resizing
    // Cols
    //cols(MAX_COLS);  // how many columns
    cols(4);
    col_header_height(35);
    col_header(1);              // enable column headers (along top)
    col_width_all(110);          // default width of columns
    col_resize(0);              // enable column resizing
    end();			// end the Fl_Table group
  }
  ~MyTable() { }
};


/* ----------------  TABLEAU ENTAMES niveau >0 ------------------------- */

//Essai table pour entames
// Derive a class from Fl_Table
class MaTable : public Fl_Table {
 public:
  int data[MAX_ROWS][MAX_COLS];		// data array for cells
 private:
  // Draw the row/col headings
  //    Make this a dark thin upbox with the text inside.
  //
  void DrawHeader(const char *s, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
    //fl_draw_box(FL_THIN_UP_BOX, X,Y,W,H, row_header_color());
    fl_draw_box(FL_THIN_UP_BOX, X,Y,W,2*H,coul_fenetre_contr);
    fl_color(FL_DARK_BLUE);
    fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
    fl_pop_clip();
  } 
  void DrawHHeader(const char *s,const char *ss, int X, int Y, int W, int H,Fl_Color C) {
    fl_push_clip(X,Y,W,H);
    fl_draw_box(FL_THIN_UP_BOX, X,Y,W,2*H,coul_fenetre_contr);
    fl_color(FL_DARK_BLUE);
    fl_draw(s, X-5,Y,W,H, FL_ALIGN_CENTER);
    fl_color(C);
    fl_draw(ss,X+5,Y,W,H,FL_ALIGN_CENTER);
    fl_pop_clip();
  } 
  // Draw the cell data
  //    Dark gray text on white background with subtle border
  //
  void DrawData(const char *s, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
      // Draw cell bg
      fl_color(FL_WHITE); fl_rectf(X,Y,W,H);
      // Draw cell data
      fl_color(FL_GRAY0); fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
      // Draw box border
      fl_color(color()); fl_rect(X,Y,W,H);
    fl_pop_clip();
  } 
  // Handle drawing table's cells
  //     Fl_Table calls this function to draw each visible cell in the table.
  //     It's up to us to use FLTK's drawing functions to draw the cells the way we want.
  //
  void draw_cell(TableContext context, int ROW=0, int COL=0, int X=0, int Y=0, int W=0, int H=0) {
    static char ss[1];
    static char s[40];
    switch ( context ) {
      case CONTEXT_STARTPAGE:                   // before page is drawn..
        fl_font(FL_HELVETICA, 16);              // set the font for our drawing operations
        return; 
      case CONTEXT_COL_HEADER:                  // Draw column headers
        //sprintf(s,"%c",'A'+COL);              // "A", "B", "C", etc.
	sprintf(s,"%s",hdata[COL]);
	DrawHeader(s,X,Y,W,H);
        return; 
      case CONTEXT_ROW_HEADER:                  // Draw row headers
        //sprintf(s,"%03d:",ROW); 
	sprintf(s,"%s",vdata[ROW]); 
	sprintf(ss,"%s",vvdata[ROW]);// "001:", "002:", etc
        DrawHHeader(s,ss,X,Y,W,H,couleur[ROW]);
        return; 
      case CONTEXT_CELL:                        // Draw data in cells
	sprintf(s,"%d",data[ROW][COL]);
	DrawData(s,X,Y,W,H);
	return;
      default:
        return;
    }
  }
public:
  const char* hdata[4]={"Levées","% réussite","Esp. NV","Esp. V"};
  const char* vdata[13];
  const char* vvdata[13];
  Fl_Color couleur[13];
  // Constructor
  //     Make our data array, and initialize the table options.
  //
  MaTable(int X, int Y, int W, int H, const char *L=0) : Fl_Table(X,Y,W,H,L) {
    // Fill data array
    //for ( int r=0; r<MAX_ROWS; r++ ){
    //  data[r][0]=r;
      //for ( int c=1; c<MAX_COLS; c++ )
      //  data[r][c] = 1000+(r*1000)+c;
    //}
    // Rows
    rows(MAX_ROWS);             // how many rows
    row_header(0);              // enable row headers (along left)
    row_height_all(30);         // default height of rows
    row_resize(0);              // disable row resizing
    // Cols
    cols(MAX_COLS);             // how many columns
    col_header_height(35);
    col_header(1);              // enable column headers (along top)
    col_width_all(110);          // default width of columns
    col_resize(0);              // enable column resizing
    end();			// end the Fl_Table group
  }
  ~MaTable() { }
};


/* ---------------------------------------------------------------------------*/
/* ------------------ Table pour entames niveau=0 ----------------------------*/
/* ---------------------------------------------------------------------------*/

// Derive a class from Fl_Table
class MaaTable : public Fl_Table {
 public:
  int data[13][14];	// data array for cells
  int ddata[13][14];
  double esp[13];
 private:
  // Draw the row/col headings
  //    Make this a dark thin upbox with the text inside.
  //
  void DrawHeader(const char *s, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
    fl_draw_box(FL_THIN_UP_BOX, X,Y,W,2*H,coul_fenetre_contr);
    fl_color(FL_DARK_BLUE);
    fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
    fl_pop_clip();
  } 
  void DrawHHeader(const char *s,const char *ss, int X, int Y, int W, int H,Fl_Color C) {
    fl_push_clip(X,Y,W,H);
    fl_draw_box(FL_THIN_UP_BOX, X,Y,W,2*H,coul_fenetre_contr);
    fl_color(FL_DARK_BLUE);
    fl_draw(s, X-5,Y,W,H, FL_ALIGN_CENTER);
    fl_color(C);
    fl_draw(ss,X+5,Y,W,H,FL_ALIGN_CENTER);
    fl_pop_clip();
  } 
  // Draw the cell data
  //    Dark gray text on white background with subtle border
  //
  void DrawData(const char *s,int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
      // Draw cell bg
      fl_color(FL_WHITE); fl_rectf(X,Y,W,H);
      // Draw cell data
      fl_color(FL_GRAY0); fl_draw(s, X,Y,W,H, FL_ALIGN_CENTER);
      // Draw box border
      //fl_color(color()); fl_rect(X,Y,W,H);
    fl_pop_clip();
  } 
  void DrawData(const char *s,const char* ss, int X, int Y, int W, int H) {
    fl_push_clip(X,Y,W,H);
      // Draw cell bg
      fl_color(FL_WHITE); fl_rectf(X,Y,W,H);
      // Draw cell data
      fl_color(FL_GRAY0); fl_draw(s, X,Y+5,W,H, FL_ALIGN_TOP);
      // Draw box border
      fl_font(FL_HELVETICA_ITALIC,14);
      fl_color(FL_DARK_GREEN); fl_draw(ss, X,Y,W,H, FL_ALIGN_BOTTOM);
      fl_color(color()); fl_rect(X,Y,W,H);
      fl_font(FL_HELVETICA,16);
    fl_pop_clip();
  } 
  // Handle drawing table's cells
  //     Fl_Table calls this function to draw each visible cell in the table.
  //     It's up to us to use FLTK's drawing functions to draw the cells the way we want.
  //
  void draw_cell(TableContext context, int ROW=0, int COL=0, int X=0, int Y=0, int W=0, int H=0) {
    //static char t[2];
    //static char tt[1];
    static char s[40];
    static char ss[5];

    switch ( context ) {
      case CONTEXT_STARTPAGE:                   // before page is drawn..
        fl_font(FL_HELVETICA, 16);              // set the font for our drawing operations
        return; 
      case CONTEXT_COL_HEADER:                  // Draw column headers
        //sprintf(s,"%c",'A'+COL);              // "A", "B", "C", etc.
	sprintf(s,"%s",hdata[COL]);
	DrawHeader(s,X,Y,W,H);
        return; 
      case CONTEXT_ROW_HEADER:                  // Draw row headers
        //sprintf(s,"%03d:",ROW); 
	sprintf(s,"%s",vdata[ROW]); 
	sprintf(ss,"%s",vvdata[ROW]);// "001:", "002:", etc
        DrawHHeader(s,ss,X,Y,W,H,couleur[ROW]);
        return; 
      case CONTEXT_CELL:
	// Draw data in cells
	if (COL<14){
	  sprintf(s,"%d",data[ROW][COL]);
	  sprintf(ss,"%d",ddata[ROW][COL]);
	  //cout<<ROW <<" "<<COL<<" "<<ss<<endl;
	  DrawData(s,ss,X,Y,W,H);
	}
	else{
	  sprintf(s,"%3.1f",esp[ROW]);
	  DrawData(s,X,Y,W,H);}
	return;
      default:
        return;
    }
  }
public:
  const char* hdata[15];//={"Levées","% réussite","Esp. NV","Esp. V"};
  const char* vdata[13]={"0","1","2","3","4","5","6","7","8","9"};
  const char* vvdata[13]={"0","1","2","3","4","5","6","7","8","9"};
  Fl_Color couleur[13]={0,0,0,0,0,0,0,0,0,0,0,0,0};
  // Constructor
  //     Make our data array, and initialize the table options.
  //
  MaaTable(int X, int Y, int W, int H, const char *L=0) : Fl_Table(X,Y,W,H,L) {
    // Rows
    rows(MAX_ROWS);             // how many rows
    row_header(1);              // enable row headers (along left)
    row_height_all(40);         // default height of rows
    row_resize(0);              // disable row resizing
    // Cols
    cols(MAX_COLS);             // how many columns
    col_header_height(35);
    col_header(1);              // enable column headers (along top)
    col_width_all(110);          // default width of columns
    col_resize(0);              // enable column resizing
    end();			// end the Fl_Table group
  }
  ~MaaTable() { }
};


/* ------------------------ TABLEAU DDT ----------------------------------- */
class TabDDT:public Fl_Table{
 public:
  int data[4][5]; // lignes joueurs, colonnes couleurs
 private:
  const char* hdata[5]={"P","C","K","T","SA"};
  const char* vdata[4]={"N","E","S","O"};
  
  void DrawHeader(const char* s,int X,int Y,int W,int H){
    fl_push_clip(X,Y,W,H);
    fl_draw_box(FL_FRAME_BOX,X,Y,W,H,coul_fenetre_contr);
    fl_color(FL_DARK_BLUE);
    fl_draw(s,X,Y,W,H,FL_ALIGN_CENTER);
    fl_pop_clip();
  }

  void DrawData(const char *s,int X,int Y,int W, int H){
    fl_push_clip(X,Y,W,H);
    fl_draw_box(FL_FRAME_BOX,X,Y,W,H,255);
    //fl_color(FL_WHITE);fl_rectf(X,Y,W,H);//fond
    fl_color(FL_GRAY0);fl_draw(s,X,Y,W,H,FL_ALIGN_CENTER);//texte
    //fl_color(color());fl_rect(X,Y,W,H);//bord
    fl_pop_clip();
  }

  void draw_cell(TableContext context,int ROW=0,int COL=0,int X=0,int Y=0,int W=0,int H=0){
    static char s[40];
    switch(context){
    case CONTEXT_STARTPAGE:
      fl_font(FL_HELVETICA,15);
      return;
    case CONTEXT_COL_HEADER:
      sprintf(s,"%s",hdata[COL]);
      DrawHeader(s,X,Y,W,H);
      return;
    case CONTEXT_ROW_HEADER:
      sprintf(s,"%s",vdata[ROW]);
      DrawHeader(s,X,Y,W,H);
      return;
    case CONTEXT_CELL:
      sprintf(s,"%d",data[ROW][COL]);
      DrawData(s,X,Y,W,H);
      return;
    default:
      return;
    }
  }

 public:
 TabDDT(int X,int Y,int W,int H,const char *L=0): Fl_Table(X,Y,W,H,L){
    color(fl_rgb_color(202,251,242));
    box(FL_FRAME_BOX);
    rows(4);
    row_header(1);
    row_height_all(25);
    row_resize(0);
    cols(5);
    col_header(1);
    col_resize(0);
    col_width_all(41);
    end();
  }
  ~TabDDT(){}
};

/* Tableau pas à pas */
//class Tablepap : public Fl_Table{
// public:
//  int data[13][1];
//}
