#include <iostream>
#include "condouv.h"

//Pour les conditions non installées, voir verifie_coco dans fenetre.cpp 548

//70  ouvertures
//523 réponses
//790 coul_plus_longue
//641 intervention
//898 teneurs
//893 clés
//768 distribution


bool cond_points(char* liste,Condouv& coco){
  //cout<<"cond_points"<<endl;
  int joueur=coco.joueur;
  int part=(joueur+2)%4;
  bool ligne=coco.params[0];
  int nature= coco.params[1];
  int couleur=coco.params[2];
  int min = coco.params[3];
  int max = coco.params[4];
  int pts=points(liste,joueur);
  int hl=pointsHL(liste,joueur);
  int dh = pointsDH(liste,joueur);
  double r=points(liste,joueur);
  if (nature==0){
    if (couleur<4)
      r=points(liste,joueur,couleur);
  }
  if (ligne) r+=points(liste,part);
  else if (nature==1){
    int hlp= pointsHL(liste,part);
    r=hl+ligne*hlp;
  }
  else if (nature==2){
    int dhp= pointsDH(liste,part);
    r=dh+ligne*dhp;
  }
  else if (nature==3){r=pointsDHS(liste,joueur,couleur);}
  return r>=min-0.51 && r<=max+0.51;
}

// 11 (ex n°27) ..
bool cond_ldj(char* liste, Condouv& coco){
  int joueur=coco.joueur;
  int couleur=coco.params[0];
  float mini=coco.params[1]/10;
  float maxi=coco.params[2]/10;
  float lj=ldj(liste,joueur);
  if (couleur < 4 && couleur_max(liste,joueur) != couleur) return 0;
  //if ( mini <= lj && lj <= maxi)
  //  cout<<"couleur : "<<joueur<<" mini : "<<mini<<" lj : "<<lj<<"; maxi : "<<maxi<<endl;
  return mini <= lj && lj <= maxi;
}

bool passe(char liste[52],int joueur,int sys,int no){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int maxi = disttri[3];
  return points(liste,joueur) < 12 &&
    !ouv1T(liste,joueur,sys,no,0) &&
    !ouv1K(liste,joueur,sys,no,0) &&
    !ouv1C(liste,joueur,sys,no,0) &&
    !ouv1P(liste,joueur,sys,no) &&
				//!ouv2K(liste,joueur,sys,no) &&
    !ouv2C(liste,joueur,sys,no) &&
    !ouv2P(liste,joueur,sys,no) &&
    !(maxi>=7 && ldj(liste,joueur)-vul(joueur,no)>=6.75);
}


//param1:système
//param2:choix
//param3:particularités
bool ouverture(char* liste,int no,Condouv& coco){
  int sys = coco.params[0];
  int ouv =coco.params[1];
  int part=coco.params[2];
  int joueur=coco.joueur;
  switch(ouv){
  case 42: 
    return ouv4C(liste,joueur,sys,no);
  case 43: 
    return ouv4P(liste,joueur,sys,no);
  case 20:
    return ouv2T(liste,joueur,sys,no,part);
  case 21:
    return ouv2K(liste,joueur,sys,no,part);
  case 24:
    return ouv2SA(liste,joueur,sys,no);
  case 240:
    return ouvsuper2SA(liste,joueur,sys,no);
  case 22:
    return ouv2C(liste,joueur,sys,no);
  case 23:
    return ouv2P(liste,joueur,sys,no);
  case 220:
    return ouv2C(liste,joueur,sys,no) || ouv2P(liste,coco.joueur,sys,no);
  case 14:
    return ouv1SA(liste,joueur,sys,no);
  case 12:
    return ouv1C(liste,joueur,sys,no,part);
  case 13:
    return  ouv1P(liste,joueur,sys,no,part);//L260	
  case 11:
    return ouv1K(liste,joueur,sys,no,part);
  case 10:
    return ouv1T(liste,joueur,sys,no,part);
 case 100:
   return ouv1T(liste,joueur,sys,no,part) || ouv1K(liste,joueur,sys,no,part);
  case 222:
    return ouv2C_Muiderberg(liste,joueur,no);
  case 221:
    return ouv2C_Ekren(liste,joueur,no);
  case 400: 
    return ouv1T(liste,joueur,sys,no) || ouv1K(liste,joueur,sys,no)
      || ouv1C(liste,joueur,sys,no) || ouv1P(liste,joueur,sys,no);
  case 30:
    return ouv3T(liste,joueur,sys,no);
  case 31:
    return ouv3K(liste,joueur,sys,no);
  case 32:
    return ouv3C(liste,joueur,sys,no);
  case 33:
    return ouv3P(liste,joueur,sys,no);
  case 34:
    return ouv3SA(liste,joueur,sys,no);
  case 40:
    return ouv4T(liste,joueur,sys,no);
  case 41:
    return ouv4K(liste,joueur,sys,no);
  case 0:
    return passe(liste,joueur,sys,no);
  default:
    return 0;
  }
}


bool ouv1T(char* liste,int joueur,int sys,int no,int part){
  int pts = points(liste,joueur);
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  //int mini = disttri[0];
  int maxi = disttri[3];
  int nt = dist[3];
  int nk=dist[2];
  //int nc = dist[1];
  //int np = dist[0];
  int dh = pointsDH(liste,joueur);
  int forme = xxxx(liste,joueur);
  bool r=0;
  if (pts<11 || dh<12 || pts>21) return 0;
  //ouvrir DXxx,Rx,Ax,Dxxxx
  else if (condSA(liste,joueur,1)){
    if (pts==15 && ((forme==4432 && sys==1) || forme==4423)) r=1;
    else return 0;}
  else if (condSA(liste,joueur,3)) return 0;
  else if (nt<=3){
    if (sys==0 && forme==4432) r=0;
    else if (sys==1 && forme==3343) r=1;
    else if (maxi==4 && nk<=3) r=1; 
    else return 0;
  }
  //else if (nt==3){
    //if (sys==1 && forme==4432) return 0;
    //else return 0;
  //}
  else if (nt==4){
    if ((forme==2344 || forme ==3244) && points(liste,joueur,T)>=6 && points(liste,joueur,K)<=1) r = 1;
    else if (forme == 1444 ||forme == 4144|| maxi>4 || forme==2344 || forme==3244) return 0;
    else if (maxi==4) r=1;
    else return 0;
  }
  else if (coul_plus_longue(liste,joueur,3,1)) r=1;
  /* Ouvertures particulières */
  if (r==0) return 0;
  else
    switch(part){
    case 0:
      return 1;
    case 1214:
      return condSA(liste,joueur,0,0);
    case 1819:
      return condSA(liste,joueur,2,0);
    default:
      return 1;
  }
  return r;	  
};

//1: 18-19 régulier
//3: redemande à 1SA sur 1P
bool ouv1K(char* liste,int joueur,int sys,int no,int part){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int maxi = disttri[3];
  int mini = disttri[0];
  int nt = dist[3];
  int nk = dist[2];
  int nc = dist[1];
  int np = dist[0];
  int pts = points(liste,joueur);
  int dh = pointsDH(liste,joueur);
  int forme = xxxx(liste,joueur);
  int nbH = compte(liste,joueur,K,3);
  bool r=0;
  if (dh<13 || pts>21 || pts<10) return 0;
  else if (condSA(liste,joueur,1)) return 0;
  else if (condSA(liste,joueur,3)) return 0;
  else if (nk==3 && sys==0 &&  forme==4432) r=1;
  else if (nk<4) return 0;
  else if (nk==4){
    if (mini == 3 && sys==1) return 0;
    else if (nt==4 && nbH==0 && compte(liste,joueur,T,3)>=2) return 0;
    else if (maxi==4) r=1;
  }
  //cas des 6-5 faibles
  else if (nk==6 && (nc==5 || np==5) && pts<=12) r=0;
  else if (coul_plus_longue(liste,joueur,2,0)) r= 1;
  /* Ouvertures particulières */
  if (r==0) return 0;
  else
    switch(part){
    case 0:
      return 1;
    case 1214:
      return condSA(liste,joueur,0,0);
    case 1819:
      return condSA(liste,joueur,2,0);
    default:
      return 1;
  }
  return r;	  
};

//sys1: rouqui
//part6:zone 3
bool ouv1C(char* liste,int joueur,int sys,int no,int part){
  int nc = compte(liste,joueur,1);
  int nt = compte(liste,joueur,T);
  int nk = compte(liste,joueur,K);
  int np = compte(liste,joueur,P);
  int pts = points(liste,joueur);
  int dh = pointsDH(liste,joueur);
  int r=1;
  if (pts<10 || (pts<12 && pointsDH(liste,joueur)<13)) r= 0;
  //Cas des 6-5 faibles
  if (nc==5 && (nk==6 || nt==6) && pts<12) r=1;
  else if (nc==6 && np==5 &&pts<12) r=0; 
  else if (couleur_max(liste,joueur) != 1 || nc < 5) r= 0;
  if (sys==1 && ouv1SA(liste,joueur,sys,no)) r= 0;
  //Provisoire à remplacer pas qqchose de plus fin (pas ouv forte ni barrage)
  if (pts>21 || dh>23) r= 0;
 
  if (r==0) return 0;
  else
    switch(part){
    case 0:
      return 1;
    case 1819:
      return condSA(liste,joueur,2,true);
    case 1214:
      return condSA(liste,joueur,0);
    default:
      return 1;
    }
};

bool ouv1P(char* liste,int joueur,int sys,int no,int part){
  int np = compte(liste,joueur,0);
  int coulmax = couleur_max(liste,joueur);
  int pts = points(liste,joueur);
  int pDH = pointsDH(liste,joueur);
  int r=1;
  if (np<5) r=0;
  if (ouv1SA(liste,joueur,sys,no)) r=0;
  if ((pDH<13 && pts<12) || points(liste,joueur)<10) r=0;
  //cas des 6-5 faible
  else if (np==5 && coulmax==0) r=1;
  else if (np>4 && !coulmax) r=0;
  else if (ouv_barrage_nat(liste,joueur,P,4,no)) r=0;
  else if (ouv_barrage_nat(liste,joueur,P,3,no)) r=0;
  if (r==0) return 0;
  else
    switch(part){
    case 0:
      return 1;
    case 1214:
      return condSA(liste,joueur,0);
    default:
      return 1;
    }
};

bool ouv1SA(char* liste,int joueur,int sys,int no,int part){
  int np=compte(liste,joueur,0);
  int nc=compte(liste,joueur,1);
  int pts = points(liste,joueur);
  //if (part == 10 && np<5 && nc<5) return 0;
  //if ((sys==0||pts==17) && (np==5 || nc==5)) return 0;
  if ((pts==17 || part==10) && (np==5 || nc==5)) return 0;
  return (condSA(liste,joueur,1));
};

bool ouvFM(char liste[52],int joueur){
  cout<<"perdantes : "<<perdantes(liste,joueur)<<"HL : "<<pointsHL(liste,joueur)<<endl;
  return  (perdantes(liste, joueur) <= 3 ||  pointsHL(liste,joueur) >= 24) || ldj(liste,joueur)>=8.5 && points(liste,joueur) > 13;
};

bool ouv2T(char* liste,int joueur,int sys,int no,int part){
  int pts = points(liste,joueur);
  cout <<"part : "<<part<<endl;
  if (part==20){
    cout<< "FM "<<endl;
    return ouvFM(liste,joueur);
  }
  else {
    cout <<"pas FM" <<endl;
    return cond2Mfort(C,liste,joueur) || cond2Mfort(P,liste,joueur) || ouvsuper2SA(liste,joueur,sys,no) || cond2mfort(T,liste,joueur) || cond2mfort(K,liste,joueur) || (cond_bicolore(liste,joueur,C,P,2,2) && pts>=18 && pts<=21);
  }
}

bool ouv2K(char* liste,int joueur,int sys,int no,int part){
  if (part==20) return ouvFM(liste,joueur);
}


bool cond_2Mfaible(int c,char* liste,int joueur,bool v){
  int pts = points(liste,joueur);
  int n = compte(liste,joueur,c);
  int nbhx = compte(liste,joueur,c,5);
  pts = points(liste,joueur);
  int dh = pointsDH(liste,joueur);
  //int hp = compte(liste,joueur,0,5);
  //int hc = compte(liste,joueur,1,5);
  //Si ouverture de 1 retour 0
  //if (ouv1P(liste,joueur,0,1) || ouv1C(liste,joueur,0,1)) return 0;
  //Si 2 as retourne 0
  if (nbas(liste,joueur)>1) return 0;
  if (nbhx<2 && !aas(liste,joueur,c)) return 0;
  if (pts>10 || (pts==10 && dh>13)) return 0;
  //Si deuxième majeure par 4 correcte retourne 0
  int d = (c+1)%2;
  if (compte(liste,joueur,d)>=4 && compte(liste,joueur,d,3)>0) return 0;
  return n==6 && (dh>=9 || (!v && nbhx>=3));
  //bool cp = (np== 6 && nc<4 && nk<5<<nt<5 && pts<11&& nbas(liste,joueur)<2&&
  //	    ((dh>=9 && hp>1) || (!v && pts>=6 && hp>1)));
  //bool cc = (nc== 6 && np<4 && nk<5<<nt<5 && pts<11&& nbas(liste,joueur)<2&&
  //		    ((dh>=9 && hc>1) || (!v && pts>=6 && hp>1)));
  //if (c==3) return cp;
  //else if (c==2) return cc;
  //else return (cp||cc);
  //else return 1;
}

bool cond2Mfort(int c,char* liste,int joueur){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int L = compte(liste,joueur,c);
  int GH = compte(liste,joueur,c,3);
  int H = points(liste,joueur);
  int DH = pointsDH(liste,joueur);
  float Ldj = ldj(liste,joueur); 
  //if (c==P)
  //  cout << "DH : "<<DH<<"  Ldj : "<<Ldj<<endl;
  if (L<5 || GH<2 || H<18 || DH>23 || disttri[2]>4) return 0;
  return (L==5 &&  H>=20) || (L==6 && DH>=20) || (Ldj>=8 && Ldj<9);
}

bool cond2mfort(int c,char* liste,int joueur){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int L = compte(liste,joueur,c);
  float Ldj = ldj(liste,joueur);
  int H = points(liste,joueur);
  if (L<7 || H<15 || disttri[2]>4) return 0;
  return (Ldj>=9 && Ldj<10);
}


bool ouv2C(char* liste,int joueur,int sys,int no){
  //cout<<"cond 2M "<<cond_2Mfaible(2,liste,joueur,vul(joueur,no))<<endl;
  if (sys==0) return cond_2Mfaible(C,liste,joueur,vul(joueur,no));
  else return 1;
}


bool ouv2P(char* liste,int joueur,int sys,int no){
  if (sys==0) return cond_2Mfaible(P,liste,joueur,vul(joueur,no));
  else return 1;
}

bool ouv2M(char* liste,int joueur,int sys,int no){
  return ouv2C(liste,joueur,sys,no) || ouv2P(liste,joueur,sys,no);
  //if (sys==0) return cond_2Mfaible(2,liste,joueur,sys,no);
  //else return 1;
}


bool ouv2C_Muiderberg(char* liste,int joueur,int no){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int nt = dist[3];
  int nk = dist[2];
  int np = dist[0];
  int nc = dist[1];
  int pts = points(liste,joueur);
  if (np>=4) return 0;
  return (nc==5 && (nt>=4 || nk>=4) && pts>=5 && pts <=10);
}

bool ouv2C_Ekren(char* liste,int joueur,int no){
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  //int nt = dist[3];
  //int nk = dist[2];
  int np = dist[0];
  int nc = dist[1];
  int pts = points(liste,joueur);
  int v=vul(joueur,no);
  if (pts>10) return 0;
  if (nc<4 || np <4) return 0;
  if (np+nc-8+pts-2*v<6) return 0; 
  return 1;
}


bool ouv2SA(char* liste,int joueur,int sys,int no){
  return condSA(liste,joueur,3);
}

bool ouvsuper2SA(char* liste,int joueur,int sys,int no){
  return condSA(liste,joueur,4);
}


bool ouv3T(char* liste,int joueur,int sys,int no){
  int pts=points(liste,joueur);
  int nt=compte(liste,joueur,T);
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  int nk = compte(liste,joueur,K);
  int GH=compte(liste,joueur,T,3);
  if (nt<6 || GH==0 || pts>10 || np>3 || nc>3) return 0;
  if (position(joueur,no)==3 && vul(joueur,no)==0 && nk>=4) return 1;    
  return nt==7 && GH>1;
}

bool ouv3K(char* liste,int joueur,int sys,int no){
  int pts=points(liste,joueur);
  int nk=compte(liste,joueur,K);
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  int nt=compte(liste,joueur,T);
  int GH=compte(liste,joueur,K,3);
    if (nk<6 || GH==0 || pts>10 || np>3 || nc>3) return 0;
  if (position(joueur,no)==3 && vul(joueur,no)==0 && nt>=4) return 1;    
  return nk==7 && GH>1;
}

bool ouv3C(char liste[52], int joueur, int sys,int no){
   return ouv_barrage_nat(liste,joueur,1,3,no);
};

bool ouv3P(char liste[52], int joueur, int sys,int no){
   return ouv_barrage_nat(liste,joueur,0,3,no);
};

bool ouv3SA(char liste[52],int joueur, int sys,int no){
  int m = couleur_max(liste,joueur);
  cout <<"couleur plus longue : "<<m<<endl;
  int pts = points(liste,joueur);
  if (m<2 || compte(liste,joueur,m)<7 || pts>12) return 0;
  int c=compte(liste,joueur,m,4);
  cout <<"c = "<<c<<endl;
  return c==4;
};

bool ouv4T(char* liste,int joueur,int sys,int no){
  int pts=points(liste,joueur);
  int nt=compte(liste,joueur,T);
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  int GH=compte(liste,joueur,T,4);
  for (int i=0;i<3;i++) if (aas(liste,joueur,i) || roi(liste,joueur,i)) return 0;
  return pts<10 && nt==8 && GH>1 && np<4 && nc<4;
}

bool ouv4K(char* liste,int joueur,int sys,int no){
  int pts=points(liste,joueur);
  int nt=compte(liste,joueur,T);
  int nk=compte(liste,joueur,K);
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  int GH=compte(liste,joueur,K,4);
  for (int i=0;i<4 && i!=2;i++) if (aas(liste,joueur,i) || roi(liste,joueur,i)) return 0;
  return pts<10 && (nk==8 || (nk==7 && nt>=4)) && GH>1 && np<4 && nc<4;
}

bool ouv4C(char liste[52],int joueur,int sys,int no){
  return ouv_barrage_nat(liste,joueur,1,4,no);
}

bool ouv4P(char liste[52],int joueur,int sys,int no){
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  if (position(joueur,no)<4)
    return ouv_barrage_nat(liste,joueur,P,4,no);  
  else return np>=7 && compte(liste,joueur,P,5)>=3 && ldj(liste,joueur)>=8 && ldj(liste,joueur)<10;
}

/* 1 (ex20) réponses */
bool repo(char* liste,int no,Condouv& coco){
  int joueur = coco.joueur;
  int sys = coco.params[0];
  int ouv =coco.params[1];
  int r=coco.params[2];
  int np=compte(liste,joueur,P);
  int nc=compte(liste,joueur,C);
  int nk=compte(liste,joueur,K);
  int nt=compte(liste,joueur,T);
  int pts=pointsHL(liste,joueur);
  int pH=points(liste,joueur);
  int dH=pointsDH(liste,joueur);
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int mini = disttri[0];
  // Ouverture de 1P, réponse 1SA
  if (ouv==13){
    if (r==14) return pts>=5 && np<3 && pts<11;
    if (r==20){
      if (pH+nt<15) return 0;
      return ((nt>=5 && nt>nk && nt>nc) || (nt>=nk && nt>=nc && pts>11));
    }
    else if (r==21){
      if (pH+nk<15 || nk<nc || nk<nt) return 0;
      return ((nk>=5 && nk>nc) || (nk==4 && nt<4 && nc<=4 && pts>11));
    }
    else if (r==23) return np==3 && dans(pointsDHS(liste,joueur,P),6,10);
    else if (r==43) return np>=5 && nbcles(liste,joueur,P)<2;
  }
  else if (ouv==14){
    //Ouverture 1SA réponses 2T, 2K, 3P et 3SA
    if (r==20) return (pts>=8 && (np==4 || nc==4)) || (nc=5 && np<4 && pts==8) || (np==5 && nc<4 && pts==8);
    else if (r==22){
      if (np<5) return 0;
      if (nc==4 && pts>7) return 0;
      if (np==5 && pH==8) return 0;
      if (nc==5 && pH>6 && pts<15) return 0;
    }
    else if (r==21){
      if (nc<5) return 0;
      if (!coul_plus_longue(liste,joueur,C,0)) return 0;
      if (np==4 && pts>7) return 0;
      if (nc==5 && pH==8) return 0;
      if (nc>=6 && disttri[2]<4 && pH>=13) return 0;
    }
    else if (r==33) return np==1 && nc==3 && nk<=5 && nt<=5 && pts>=9;
    else if (r==34) return (pts>=9 && pts<=15 && (mini==3 || (np<4 && nc<4)) && mini>1);
  }
  //Ouverture 2SA réponses 3T et 3SA
  else if (ouv==24){
    if (r==30) return (pts>=4 && (np==4 || nc==4));
    else if (r==34) return (pts>=4 && np<4 && nc<4 && dH<=11);
  }
  else if (ouv==11){
    //Ouverture 1K réponses 1C 1P 2T et 3SA
    if (r==12){
      if (nc<4) return 0;
      if (dH<6) return 0;
      if (nc==4 && np>4) return 0;
      if (nc>=5 && np>=nc) return 0;
      return 1;
    }
    else if (r==13){
      if (dH<6) return 0;
      else if (np<4) return 0;
      else if (np>nc) return 1;
    }
    else if (r==20) {
      if (pH+nt<15) return 0;
      //si majeure par 4 ouverture
      else if ((np>=4 || nc>=4) && dH<=12) return 0;
      //Si couleur plus longue >=5 et = trefle retour 1
      else if (coul_plus_longue(liste,joueur,3,1) && nt>=5) return 1;
      //Si ni 4 pique ni 4 coeurs et irrégulier retour 1
      else if (np<4 && nc<4 && mini<=1) return 1;
      else return 0;
    }
    else if (r==24) return pts==11 && np<4 && nc<4 && nk<6 && nt<6 && mini >=2;
    else if (r==34) return np<4 && nc<4 && mini >1 && nk<5 && nt<5 && pH>11 && pH<17;
  }
  else if (ouv==12){
    //Ouverture de 1C, réponses de 2T, 2K et 2C
    if (r==20){
      if (pH+nt<15) return 0;
      return ((nt>=5 && nt>nk && nt>np) || (nt>=nk && nt>np && pts>11));
    }
    else if (r==21){
      if (pH+nk<15 || nk<=np || nk<nt) return 0;
      return (nk>=5 || (nk==4 && nt<4 && pts>11));
    }
    else if (r==22)  return nc==3 && dans(pointsDHS(liste,joueur,C),6,10);
  }
  //Ouverture de 1T
  else if (ouv==10){
    if (r==11) return (dans(pts,5,7) && nt<5 && np<4 && nc<4) || (nk>4 && nc<5 && np<5 && dH>5);
    if (r==12) return pts>=4 && np<=4 && coul_plus_longue(liste,joueur,C,2);
    else if (r==13) {
      if (np<4) return 0;
      else if (np==4) return (nc<4 && nk<=4);
      else return coul_plus_longue(liste,joueur,P,0);
    }
    else if (r==24)
      return pts==11 && np<4 && nc<4 && nk<6 && nt<6 && mini >=2;
    else if (r==20){
      if (sys==0) return nt>=5 && dans(dH,5,10);
      else return nt>=5 && pts>=11;
    }
    else if (r==34) return np<4 && nc<4 && mini >1 && nk<5 && nt<5 && pH>11 && pH<17;
    else return 0;
  }
}


/* 2 (ex 10) Conditions interventions */
//param1: couleur
//param2: palier
// A travailler (bicolores, barrages)
bool intervention(char* liste,Condouv& coco,int no){
  int joueur = coco.joueur;
  int par = coco.params[0];
  int sur = coco.params[1];
  int coul_ouv=3-sur%10;
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int np=dist[0];
  int nc=dist[1];
  int nk=dist[2];
  int nt=dist[3];
  int pts = points(liste,joueur);
  //int nbH = compte(liste,joueur,coul,3);
  //int nbhx = compte(liste,joueur,coul,5);
  //int nb = dist[coul];
  bool v = vul(joueur,no);
  bool cp1 = cond_int1(liste,joueur,P,v);
  bool cc1 = cond_int1(liste,joueur,C,v);
  //passe
  if (par==0) {
    bool rep = pts>=18 || cond_int1sur(liste,joueur,coul_ouv,v) || cond_int1SA(liste,joueur,coul_ouv) || cond_int2sur(liste,joueur,coul_ouv,v);
    //cout << "int1 "<< cond_int1sur(liste,joueur,coul_ouv,v) <<"rep "<<rep<<endl;
    return !rep;
  }
  //Intervention par 1P
  if (par==13 && dans(sur,10,12)) return cp1
			 && !cond_2Mfaible(P,liste,joueur,v) 
			 &&!(cond_int_bic(liste,joueur,P,K,v) && sur!=11) 
			 &&!(cond_int_bic(liste,joueur,P,T,v) && sur !=10) 
			 && !(cond_int_bic(liste,joueur,P,C,v) && (sur !=12)) 
			 && !ouv_barrage_nat(liste,joueur,P,3,no);
  //Intervention par contre
  else if (par==8){
    if (pts>=18) return 1;
    else if (sur==10 || sur==11){
      int n;
      (sur==11) ? n=nk: n=nt;
      if (nc>=5 || np>=5) return 0;
      if (nc+np<7) return 0;
      if (pts-n<10) return 0;
      return 1;
    }
    else if (sur==12){
      if (np>=5 || nt>=6 || nk>=6) return 0;
      if (np<3) return 0;
      if (pts+np-nc<14) return 0;
      return 1;
    }
    else if (sur==13){
      if (nc<4 || nc>5) return 0;
      if (nc+pts-np<14) return 0;
      //pas bicolore
    if (cond_int_bic(liste,joueur,C,K,v) || cond_int_bic(liste,joueur,C,T,v) || cond_int_bic(liste,joueur,K,T,v)) return 0;
      //pas intervention 2X
    if (cond_int2(liste,joueur,C,v) || cond_int2(liste,joueur,K,v) || cond_int2(liste,joueur,T,v)) return 0;
    return 1;
    }
  }
  //Intervention par 1SA
  if (par==14){
    return cond_int1SA(liste,joueur,coul_ouv);
  }
  //Intervention par 2T
  if (par==20)
    if (dans(sur,10,13)) return cond_int2(liste,joueur,T,v);
    else return cond_Landy(liste,joueur,v);
  //Intervention par 2K
  if (par==21){
    if (sur == 10 || sur == 11) return cond_int_bic(liste,joueur,P,C,v);
    else if (sur==12 || sur == 13) return cond_int2(liste,joueur,K,v);
  }
  //Intervention par 2SA
  if (par==24){
    int couleur = (sur%10);
    if (couleur==0) return cond_int_bic(liste,joueur,C,K,v);
    else if (couleur==1) return cond_int_bic(liste,joueur,C,T,v);
    else return cond_int_bic(liste,joueur,K,T,v);
  }
  if (sur==10){ 
    //cout<<"ouverture de 1T"<<endl;
    //if (par==13) return cp1; 
    if (par==12) return !cp1 && cc1; 
    else if (par==11){
      //cout<<"intervention à 1K sur 1T"<<endl;
      return !cp1 && !cc1 && cond_int1(liste,joueur,K,v);  
    }
  }
  else if (sur==11){
    if (par==12) return !cp1 && cc1;
  }
  else if (sur==12){
    if (par==22) return cond_int_bic(liste,joueur,P,T,v) ;
    if (par==30) return cond_int_bic(liste,joueur,P,K,v) && np<=nk;
  }
  else if (sur==13){
    if (par==30) return cond_int_bic(liste,joueur,C,K,v) && nc<=nk;
  }
  else if (sur>=30 && sur<34){
    int coul=33-sur;
    vector<int> pms(3);
    pms[0]=coul;
    pms[1]=100;
    pms[2]=500;
    if (pts>=16 && arret(liste,joueur,pms)) return (par==34);
    if (coul==0){
      if ((nc<3 || nc>=6) && pts<18) return 0;
      return pts+nc-np>=15 && nk>=2 && nt>=2;
    } 
  }
  return 0;
}


  
  //Si Mickael, renvoyer 0
  //std::vector<int>ve(1,24);
  //if (bicolore(liste,joueur,no,ve)) return 0;
  /*for (int i=0;i<coul;i++)
    if (nb <= dist[i]) return 0;
  if (palier == 1)
    return (nb >= 5 && pts < 18 &&	\
	  (pts > 11 || \
	   ((nbhx > 2 || nbH == 2) && pts > 8) || \
	   (!vul(joueur,no) && nbH > 1)));
  else if (palier == 2)
    return (dist[coul] >= 5 && pts < 18 && couleur_max(liste,joueur) == coul && \
	    ((nbhx > 2 && pts > 13) || \
	     (dist[coul] >= 6 && nbhx > 1 && pts >= 10) || \
	     (!vul(joueur,no) && nbhx > 1 && pts > 7)));
  //else if (palier == 4)
  //  return (nb >= 8 || (nb == 7 && (ldj(liste,joueur)>= 6+v)));
  else return 0;*/
//}


/* 3 (ex 40)  conditions sur nombres de piques, coeurs, ...*/
bool forme(char* liste, Condouv& coco){
  int symbs[4]={coco.params[0],coco.params[1],coco.params[2],coco.params[3]};
  //cout << "coco.params" <<coco.params[<<endl;
  int joueur=coco.joueur;
  //cout <<"joueur "<< joueur<<endl;
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int mini = disttri[0];
  int maxi = disttri[3];
  int pf1 = disttri[1];
  //int f1=disttri[1];//l'avant dernière
  for (int c=0;c<4;c++){
    if (symbs[c]>-1){
      int nb=compte(liste,joueur,c,13);
      //cout <<"c "<<c<<" nb "<<nb<<endl;
      int s = symbs[c];
      if ((symbs[c]<10 && nb!=symbs[c])||(symbs[c]>10 && symbs[c]<20 && nb<(symbs[c]-10))||(symbs[c]>20&&symbs[c]<30&&nb>(symbs[c]-20))) return 0;
      //else if (symbs[c]==103 && nb!=1 && nb!=3) return 0;
      else if ((s/10)%10==0 && s<1000 && nb!= s%10 && nb!=s/100) return 0;
      else if (((s/10)%100 == 0) && (nb<s/1000 || nb > s%10)) return 0;
      else if (symbs[c]==6331 && !(nb==6 && pf1==3 && mini==1)) return 0;
      else if (symbs[c]==6421 && !(nb==6 && pf1==2 && mini==1)) return 0;
      //else if (symbs[c]==6991 && (nb!=6 || mini !=0
      else if (symbs[c]==5332 && (nb!=5 || mini!=2 || pf1!=3)) return 0;
      else if (symbs[c]==5530 && (nb!=5 || mini!=0 || pf1!=3)) return 0;
      //else if (symbs[c]==5991 && (nb!=5 || mini!=1)) return 0;
      //else if (symbs[c]==5990 && (nb!=5 || mini!=0)) return 0;
      else if (symbs[c]==4432 && (nb!=4 || mini!=2 || pf1!=3)) return 0;
      else if (symbs[c]==4441 && !(nb==4 && pf1==4 && maxi==4 && mini==1)) return 0;
      else if (symbs[c]==4522 && !(nb==4 && maxi==5 && mini==2)) return 0; 
      else if (((s/10)%100 == 99) && (nb!=s/1000 || mini!=s%10)) return 0;
    }
  }
  return 1;
}

bool coul_plus_longue(char* liste,int joueur,int couleur,int mode){
  /*Renvoie 1 si couleur est la plus longue 
    mode 0: à égalité, la plus chère
    mode 1: strictement
    mode 2: ne tient pas compte du rang */
  int nbc = compte(liste,joueur,couleur,13);
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int maxi = disttri[3];
  //std::cout<<" nbc "<<nbc<<" maxi "<<maxi<<std::endl;
  if (nbc < maxi) return 0;
  else{
    if (mode == 1) return nbc > disttri[2];
    else if (mode == 0) return (couleur_max(liste,joueur) == couleur);
    else return 1;}
}

//n°39 comparaison couleurs
bool comp_couleurs(char liste[52], Condouv& coco){
  int joueur=coco.joueur;
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int c1=coco.params[0];
  int d1=dist[c1];
  int c2=coco.params[1];
  int d2=dist[c2];
  int op=coco.params[2];
  //cout << "c1 " <<c1<<" d1 "<<d1<<" c2 "<<c2<<" d2 "<<d2<<" op "<<op<<endl;
  return (op==0 && d1<d2) || (op==1 && d1<=d2) ||(op==2 && d1==d2);
}

bool distribution(char liste[52], Condouv& coco){
  int joueur=coco.joueur;
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int mini = disttri[0];
  int maxi = disttri[3];
  int pf1 = disttri[1];
  int f2 = disttri[2]; 
  //int nt = dist[3];
  //int nk = dist[2];
  //int nc = dist[1];
  //int np = dist[0];
  int choix = coco.params[0];
  if (choix==4333) return mini==3;
  else if (choix==4432) return maxi==4 && mini==2;
  else if (choix==4441) return maxi==4 && mini==1;
  else if (choix==5332) return maxi==5 && f2==3;
  else if (choix==5422) return maxi==5 && f2==4 && mini==2;
  else if (choix==5431) return maxi==4 && f2==4 && mini==1;
  else if (choix==6322) return maxi==6 && mini==2;
  else if (choix==6331) return maxi==6 && f2==3 && mini==1;
  else if (choix==1) return mini <=1;
  //Les 4 derniers chiffres indiquent 0= 1+ 2-
  else if (choix==64001111) return maxi>=6 && f2>=4;
  else return 1;
}

//6 (ex 19) couleur plus longue
bool coul_plus_longue(char liste[52],Condouv& coco){
 /*Renvoie 1 si couleur est la plus longue 
    mode 0: à égalité, la plus chère
    mode 1: strictement
    mode 2: ne tient pas compte du rang */
  //cout<<"couleur plus longue"<<endl;
  int joueur=coco.joueur;
  int couleur = coco.params[0];
  int mode = coco.params[1]; 
  int nbc = compte(liste,joueur,couleur,13);
  int dist[4];
  int disttri[4];
  fodistr(liste,joueur,dist,disttri);
  int maxi = disttri[3];
  if (nbc < maxi) return 0;
  else{
    if (mode == 1) return nbc > disttri[2];
    else if (mode == 0) return (couleur_max(liste,joueur) == couleur);
    else return 1;}
}

bool teneur(char liste[52], Condouv& coco){
  int joueur=coco.joueur;
  int couleur=coco.params[0];
  int teneur=coco.params[1];
  int p=coco.params[2];
  int nbca = compte(liste,joueur,couleur,13);
  if ((p<10 && nbca!=p)||(p>10 && p<20 && nbca<p-10)||(p>20 && p<30 && nbca>(p-20))) return 0; 
  else if (p==103 && nbca!=1 && nbca!=3) return 0;
  else if (((p/10)%100 == 0) && (nbca<p/1000 || nbca > p%10)) return 0;
  else if (teneur==5000) return (compte(liste,joueur,couleur,2,0)>=1 || compte(liste,joueur,couleur)<2);
  else{
    int cb = coulenbits(liste,joueur,couleur);
    bool b=1;
    for (int i=0;i<=maxbit(teneur,12);i++){
      if (bitdans(teneur,i) && !bitdans(cb,i)) b=0;
    }
    return b;
  }
}

bool nb_cartes(char liste[52], Condouv& coco){
  int joueur=coco.joueur;
  int coul=coco.params[0];
  int petite=coco.params[1]; //2=2... As=14
  int grande=coco.params[2];
  int mini=coco.params[3];
  int maxi=coco.params[4];
  int nb = compte(liste,joueur,coul,15-petite,14-grande);
  return mini<=nb && nb<=maxi;
}

bool cartes_niveau(char liste[52],Condouv& coco){
  int joueur=coco.joueur;
  int rang=14 -coco.params[0];
  int min=coco.params[1];
  int max=coco.params[2];
  int nb=nb_rang(liste,joueur,rang);
  //cout<<"nb dix "<< nb<<endl;
  return min<=nb && nb<=max; 
}

bool arret(char liste[52], int joueur, std::vector<int>& params){
  int couleur = params[0];
  int mini = params[1];
  int maxi = params[2];
  int d=arrets(liste,joueur,couleur);
  return ((mini <= d) && (d <= maxi));
}

bool arret(char liste[52],int joueur,int couleur,int mini,int maxi){
  vector<int> pms={couleur,mini,maxi};
  //for (int k=0;k<3;k++) cout<<pms[k]<<endl;
  return arret(liste,joueur,pms);
}

bool arret(char* liste,Condouv& coco){
  int joueur = coco.joueur;
  return arret(liste,joueur,coco.params);
  /*int couleur = coco.params[0];
  int mini = coco.params[1];
  int maxi = coco.params[2];
  int n = compte(liste,joueur,couleur,13);
  bool a= aas(liste,joueur,couleur);
  bool r=roi(liste,joueur,couleur);
  bool da=dame(liste,joueur,couleur);
  bool v=valet(liste,joueur,couleur);
  bool di=dix(liste,joueur,couleur);
  int d =0;
  if (a) d+=100;
  if (r && n>=2) d+=100;
  if (da) d+= 25*n;
  if (v) d+= 20*n;
  if (di) d+= 10*n;
  return ((mini <= d) && (d <= maxi));*/
}

bool cles(char* liste,const Condouv& coco){
  int joueur = coco.joueur;
  int couleur = coco.params[0];
  int n = coco.params[1];
  //int max=coco.params[2];
  int nbc=nbcles(liste,joueur,couleur);
  if (0<=n && n<=5) return (nbc==n);
  else if (10<n && n<15) return nbc>=(n-10);
  else if (20<n && n<25) return nbc<=(n-20);
  else if (n==30 || n==41) return (nbc==n%10 || nbc==n/10);
  else if (n==62) return (nbc==2 && !dame(liste,joueur,couleur));
  else if (n==72) return (nbc==2 && dame(liste,joueur,couleur));
}

bool contr_italiens(char* liste,const Condouv& coco){
  int joueur=coco.joueur;
  int nb = nb_contr_it(liste,joueur);
  int min=coco.params[0];
  int max=coco.params[1];
  //cout <<"min "<<min<<" max "<<max<<" nb "<<nb<<endl;
  return min<=nb && nb<=max;
}
