#include <fstream>
#include "fenetre.h"

#if defined (_OPENMP)
#include <omp.h>
#endif

uintptr_t numerotation;

const char* liste_numeros[16]={"1 N/P","2 E/NS","3  S/EO","4 O/T","5 N/NS","6 E/EO","7 S/T","8 O/P","9 N/EO","10 E/T","11 S/P","12 O/NS","13 N/T","14 E/P","15 S/NS","16 O/EO"};

Contraintes::Contraintes(string s):nom(s){
  string fichier=nom;
  ifstream ist(fichier,ios::in);
  cocos.clear();
  calculs.clear();
  if  (ist){
    string ligne;
    getline(ist,ligne);
    //if (ligne!="fichier_de_contraintes"){
    //  fl_alert("Ce fichier n'est pas un fichier de contraintes");
    //  return;}
    string token0,token1;
    //while (ist.good()){
    for(string line;getline(ist,ligne);){
      //cout<<ligne<<endl;
      istringstream iss(ligne);
      iss>>token0;
      if (token0=="nom") iss>>nom;
      else if (token0=="fixees"){
	iss>>token1;
	for (int k=0;k<52;k++) cfixees[k]=token1[k];
      }
      else if (token0=="numero") iss>>numerofixe;
      else if (token0=="coco"){
	Condouv* coco=new Condouv();
	iss >> token1;
	iss >> coco->joueur;
	iss >> coco->id_condition;
	int i;
	while (iss>>i) coco->params.push_back(i);
	cocos.push_back(*coco);
	delete coco;
	coco=nullptr;
      }
      else if (token0=="contexte") iss>>con; 
      else if (token0=="calcul"){
	Calcul* calcul=new Calcul();
	iss>>token1>>calcul->nom>>calcul->alg;
	calculs.push_back(*calcul);
	delete calcul;
	calcul=nullptr;
      }
    }
  }
  else {
    //fl_alert("Ce fichier de contraintes n'existe pas");
    nom="vides";
    for (int i=0;i<52;i++) cfixees[i]='V';
    for (int i=0;i<4;i++) nbmarquees[i]=0;
    numerofixe=0;
  }
}

void Fenetre::changer_contraintes(){
  if (env.page=="ajoute"){fl_alert("Supprimer ou définir la contrainte ouverte");return;}
  detruit_widgets();
  ini_gcontr();
  //L'algèbre
  ialg->value(contr.con.c_str());
  montre_cocos();
  montre_calculs();
  env.page="montrer";
}



string Condition::nombrutchoix(int i,int v){
  //Nom de la valeur v du i-eme choix
  vector<v_n> choi = choix[i];
  int j;
  for (j=0;j<choi.size() && choi[j].v!=v;j++){}
  return choi[j].nombrut;
}

string Condition::nomchoix(int i,int v){
  //Nom de la valeur v du i-eme choix
  vector<v_n> choi = choix[i];
  int j;
  for (j=0;j<choi.size() && choi[j].v!=v;j++){}
  return choi[j].nom;
}

void cb_alg(Fl_Widget* w,void* pw){
  Fl_Input* ia=(Fl_Input*)w;
  contr.con=ia->value();
  int n=contr.con.size();
  int s=contr.cocos.size();
  for (int k=0;k<n;k++)
    if (contr.con[k]>97+s && contr.con[k]!=124) fl_alert("Coco inexistante");
  //cout<<"contr.alg : "<<contr.alg<<endl;
}

void cb_num(Fl_Widget*,void* pn){
  numerotation=(uintptr_t)pn;
  if (numerotation==0) contr.numerofixe=0;
}
void cb_numd(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int n=b->value();
  Fl_Button* bouton=(Fl_Button*)data;
  bouton->label(num[n]);
  if (numerotation==1) contr.numerofixe=n;
  b->hide();
}

void cb_sd(Fl_Widget* w,void* d){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int n=b->value();
  Fl_Button* bouton=(Fl_Button*)d;
  b->hide();
  bouton->label(joueurs[n-1]);
  if (numerotation==2) contr.numerofixe=-n;
}

void cb_bdef(Fl_Widget* chkb,void*){
  //cout<<"cb_bdef"<<endl;
  Fl_Check_Button* chk=(Fl_Check_Button*)chkb;
  bool v=chk->value();
  //cout<<v<<endl;
  if (v){
    //cout<<"remplacement"<<endl;
    config.remplace("#contraintes par défaut",contr.nom);
    config.nomcontr=contr.nom;
    (void)remove("cppgen.ini");
    rename("temp","cppgen.ini");
  }
  //chk->value(1);
}

void Fenetre::ini_gcontr(){
  begin();
  color(fl_rgb_color(190,231,239));
  //Groupe pour l'ensemble des contraintes
  gcontr=new Fl_Group(0,HMENU,x_max(),y_max()-50);
  gcontr->begin();
  gcontr->align(FL_ALIGN_INSIDE);
  //gcontr->color(fl_rgb_color(190,231,239));
  const char* filename = "images/mirandole1.jpg";
  //gcontr->image(new Fl_Tiled_Image(new Fl_JPEG_Image(filename)));

  //Goupe et boîte contenant les 4 mains
  gmains = new Fl_Group(xfmains,yfmains,wfmains,hfmains);

  //Complètement de la donne
  complete_donne(contr.cfixees);
  montrer_fixees(xfmains,yfmains,Boite_Jeu::cb_carte,contr.cfixees);
  //Nom des contraintes
  input_contr=new Fl_Output(2*ESPD,yfmains+20,250,30,"Nom des contraintes");
  input_contr->align(FL_ALIGN_TOP);
  input_contr->color(coul_fenetre_contr);
  input_contr->value(contr.nom.c_str());
  gcontr->add(input_contr);
  //Contraintes par défaut
  Fl_Check_Button* bdef=new Fl_Check_Button(2*ESPD,input_contr->y()+30,250,25,"Contraintes par défaut");
  if (contr.nom==config.nomcontr) bdef->value(1);
  else bdef->value(0);
  gcontr->add(bdef);
  bdef->callback(cb_bdef);
  
  //Numéros
  int no=contr.numerofixe;
  if (no>0) numerotation=1;
  else if (no<0) numerotation=2;
  else numerotation=0;
  Fl_Group* gnumeros=new Fl_Group(2*ESPD,input_contr->y()+100,250,200,"Numéros");
  gnumeros->align(FL_ALIGN_TOP);
  gnumeros->box(FL_DOWN_BOX);
  gnumeros->color(coul_fenetre_contr);
  gnumeros->begin();
  vector<Fl_Round_Button*> rb(3);
  for (int i=0;i<3;i++){
    rb[i]=new Fl_Round_Button(gnumeros->x()+ESPD,gnumeros->y()+(i+1)*25,125-23*i,25);
    rb[i]->type(FL_RADIO_BUTTON);
  }
  rb[numerotation]->value(1);
  rb[0]->label("numérotées à partir de 1");
  rb[0]->callback(cb_num,(void*)0);
  rb[1]->label("numéro fixe");
  rb[1]->callback(cb_num,(void*)1);
  Fl_Button* bnf=new Fl_Button(rb[1]->x()+rb[1]->w(),rb[1]->y(),40,25);
  bnf->color(fl_rgb_color(248,244,254));
  //if (numerotation==1) bnf->label(to_string(contr.numerofixe).c_str());
  if (numerotation==1) bnf->label(num[contr.numerofixe]);
  Fl_Select_Browser* snf=new Fl_Select_Browser(bnf->x()+bnf->w()+ESPC,bnf->y(),bnf->w()+40,130);
  for (int i=0;i<16;i++) snf->add(liste_numeros[i]);
  snf->hide();
  bnf->callback(cb_bjoueur,(void*)snf);
  snf->callback(cb_numd,(void*)bnf);
  rb[2]->label("donneur");
  rb[2]->callback(cb_num,(void*)2);
  Fl_Button* bd=new Fl_Button(rb[2]->x()+rb[2]->w(),rb[2]->y(),60,25);
  if (numerotation==2) bd->label(joueurs[-contr.numerofixe-1]);
  bd->color(bnf->color());
  Fl_Select_Browser* sd=new Fl_Select_Browser(bd->x()+bd->w()+ESPC,bd->y(),bd->w(),70);
  sd->hide();
  bd->callback(cb_bjoueur,(void*)sd);
  for (int i=0;i<4;i++) sd->add(joueurs[i]);
  sd->callback(cb_sd,(void*)bd);
  gnumeros->end();
  gcontr->add(gnumeros);

  //Introduction de l'algèbre
  ialg=new Fl_Input(2*ESPD,ybcocos+50,250,30,"Contexte");
  ialg->align(FL_ALIGN_TOP);
  ialg->callback(cb_alg);
  gcontr->add(ialg);

  //nbstat
  inbstat=new Fl_Input(2*ESPD+75,ialg->y()+50,100,30,"Nombre de donnes pour calculs statistiques");
  inbstat->align(FL_ALIGN_TOP);
  inbstat->value(to_string(nbstat).c_str());
  inbstat->callback(cb_inbdonnes);
  gcontr->add(inbstat);
  gcontr->end();
  ajoute_menu();
  end();
}

void Fenetre::initialise(){
  env.page="montrer";
  detruit_widgets();
  contr=Contraintes();
  ini_gcontr();
  redraw();
}

//Callback pour le choix de la condition
void Fenetre::cb_ocondition(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  //On récupère le numéro de la condition
  int valeur=b->value();
  b->hide();
  //n° coco, win, bouton, groupe
  //On affecte le numéro de la condition à la coco
  DataCond* dv=(DataCond*)data;
  unsigned short n=dv->no_coco;
  Fenetre* win=dv->win;
  Fl_Output* bout=dv->pb;
  Condition condition= conditions[valeur-1];
  contr.cocos[n].id_condition=valeur-1;
  bout->value((string("  ")+conditions[valeur-1].nom).c_str());
  //cout<<"cb_ocondition L 237"<<endl;
  //Place les browsers dans le groupe gparams
  Fl_Group* gparams=dv->pg;
  win->place_params(n,condition,gparams);
  env.page="montrer";
}

void Fenetre::place_params(int n,const Condition& condition,Fl_Group* gparams){
  //cout<<"place params"<<endl;
  gparams->clear();
  int l=condition.params.size();
  int y=gparams->y();
  static int widths[]={14,16,70};
  gparams->begin();
  //Les boutons
  vector<BoutonSymb*> vpboutons;
  //Les select
  vector<Fl_Select_Browser*> vsb;
  for (int i=0;i<l;i++){
    int nbchoix=condition.choix[i].size();
    vsb.push_back(new Fl_Select_Browser(gparams->x()+condition.xvsb[i],y+30,condition.l_browsers[i],min(20*nbchoix,140)));   
    vsb[i]->column_widths(widths);
    vsb[i]->align(FL_ALIGN_LEFT);
    for (int j=0;j<nbchoix;j++){
      vsb[i]->add(condition.choix[i][j].nom.c_str());
      Param_Choix* pc=new Param_Choix(i,condition.choix[i][j]);
      vsb[i]->data(j+1,(void*)pc);
    }
    //On initialise la coco à la première valeur de chaque paramètre
    contr.cocos[n].params.push_back(condition.choix[i][0].v);
    //Le ieme bouton
    vpboutons.push_back(new BoutonSymb(condition.params[i],gparams->x()+condition.xvsb[i],y,condition.l_browsers[i],30));
    //On passe en paramètre le n° de coco et le bouton.
    Int_BS* data=new Int_BS(n,vpboutons[i]);
    vsb[i]->callback(cb_param,(void*)data);
    vpboutons[i]->box(FL_ROUND_UP_BOX);
    vpboutons[i]->color(159);
    vsb[i]->hide();
    vpboutons[i]->callback(cb_bjoueur,(void*)vsb[i]);
  }
  gparams->end();
  redraw();
}

//Si cfixees, les cartes de contr.cfixees sont grisées
void Fenetre::montrer_fixees(int x,int y,Callback cb_c,char fixees[52],const char* lab){
  Fl_Box *fmains=new Fl_Box(x,y,wfmains,hfmains,lab);
  fmains->box(FL_SHADOW_BOX);
  fmains->color(coul_fenetre_contr);
  //Les Boîtes des joueurs
  Boite_Jeu *fnord=new Boite_Jeu(x,y,ljeu,hjeu,'N',cb_c,fixees,couleur_main);
  Boite_Jeu *fouest=new Boite_Jeu(x,y,ljeu,hjeu,'O',cb_c,fixees,couleur_main);
  Boite_Jeu *fest=new Boite_Jeu(x,y,ljeu,hjeu,'E',cb_c,fixees,couleur_main);
  Boite_Jeu *fsud=new Boite_Jeu(x,y,ljeu,hjeu,'S',cb_c,fixees,couleur_main);
}

void Fenetre::ajoute(){ 
  if (env.page!="montrer") changer_contraintes();
  else if (env.page=="entames") gentames->hide();
  else{
    if (env.pasapas==true) gpasapas->hide();
    env.page="ajoute";
    if (scroll) scroll->hide();
    int n=contr.cocos.size();
    montre_cocos();
    gcocos->resizable(NULL);
    gcocos->begin();
    contr.cocos.push_back(Condouv());
  gcocos->size(gcocos->w(),gcocos->h()+HCOCO+ESPD+200);
  int ycoco=ypremcoco+n*(HCOCO+ESPD);
  Fl_Box* bcoco=new Fl_Box(xbcocos+2*ESPD,ycoco,wbcocos-4*ESPD,HCOCO);
  bcoco->color(79);
  bcoco->box(FL_FLAT_BOX);
  Fl_Button* bouncoco=new Fl_Button(xnumcoco,ycoco,20,26,alph[n]);
  IntWin* iw=new IntWin(n,this); 
  bouncoco->callback(cb_ncoco,(void*)iw);
 
  //Le joueur
  Fl_Button* boujoueur= new Fl_Button(xjcoco,ycoco,70,30,"Joueur");
  boujoueur->box(FL_ROUND_UP_BOX);
  boujoueur->color(68);
  boujoueur->labelcolor(FL_WHITE);
  gcocos->add(boujoueur);
  Fl_Select_Browser* sjoueur=new Fl_Select_Browser(xjcoco,ycoco+30,70,80,"Joueur : ");
  sjoueur->align(FL_ALIGN_LEFT);
  sjoueur->add("Nord");
  sjoueur->add("Est");
  sjoueur->add("Sud");
  sjoueur->add("Ouest");
  Deux_Vides* sdata=new Deux_Vides(n,boujoueur);
  sjoueur->callback(cb_joueur,(void*)sdata);
  sjoueur->hide();
  boujoueur->callback(cb_bjoueur,(void*)sjoueur);

  //La condition
  Fl_Output* boucondition= new Fl_Output(xbcond,ycoco,120,30);
  boucondition->box(FL_ROUND_UP_BOX);
  boucondition->color(68);
  boucondition->textcolor(FL_WHITE);
  boucondition->value(" Condition");
  Fl_Select_Browser* scondition=new Fl_Select_Browser(xbcond,ycoco+30,150,180,"Condition");
  scondition->align(FL_ALIGN_LEFT);
  int s=conditions.size();
  for (int k=0;k<s;k++) scondition->add(conditions[k].nom.c_str());
  scondition->hide();
  boucondition->callback(cb_bjoueur,(void*)scondition);
  Fl_Group* gparams=new Fl_Group(xgparams,ycoco,700,200);
  DataCond* data =new DataCond(n,this,boucondition,gparams);
  scondition->callback(cb_ocondition,(void*)data);
  gcocos->end();

  gmains->show();
  gcontr->show();
  //redraw();
  }
}

void Fenetre::montre_cocos(){
  begin();
  if (gcocos) Fl::delete_widget(gcocos);
  gcocos=nullptr;
  int n=contr.cocos.size();
  int hbcocos=ESPD+n*(HCOCO+ESPD);//Chaque coco a une hauteur de 25, plus 8 de séparation 
  //h<50? hbcocos=60:hbcocos=h;
  gcocos=new Fl_Scroll(xbcocos,ybcocos,wbcocos,hbcocos);
  gcocos->begin();
  gcocos->box(FL_UP_BOX);
  gcocos->align(FL_ALIGN_LEFT_TOP);
  gcocos->labeltype(FL_ENGRAVED_LABEL);
  gcocos->labelsize(18);
  gcocos->color(coul_fenetre_contr);
  const char* nomjoueur[4]={"Nord","Est","Sud","Ouest"};
  for (int i=0;i<n;i++){//Pour chaque coco
    int ycoco=ybcocos+i*(HCOCO+ESPD)+ESPD;
    Fl_Box* vbcoco=new Fl_Box(xbcocos+2*ESPD,ycoco,wbcocos-4*ESPD,HCOCO);
    vbcoco->color(79);
    vbcoco->box(FL_FLAT_BOX);
    Fl_Button* vbncoco=new Fl_Button(xnumcoco,ycoco,20,HCOCO,alph[i]);
    //On transmet le numéro de la coco au callback
    IntWin* iw=new IntWin(i,this); 
    vbncoco->callback(cb_ncoco,(void*)iw);
    //Le joueur
    new Fl_Box(xjcoco,ycoco,70,HCOCO,nomjoueur[contr.cocos[i].joueur]);
    //La condition
    Condouv coco=contr.cocos[i];
    Condition condition=conditions[coco.id_condition];
    new Fl_Box(xjcoco+100,ycoco,80,HCOCO,conditions[coco.id_condition].nom.c_str());
    //Les paramètres de la i-ème cocos
    //On remplit une boîte boiteparams avec une fonction draw spéciale pour intégrer les symboles de couleurs
    string ch;    
    int l=condition.params.size();
    for (int p=0;p<l;p++){//Pour chaque paramètre
      //ch += "     " +condition.params[p]+" : ";
      ch += condition.params[p]+" FPC ";
      int v=contr.cocos[i].params[p];//valeur du i-eme choix
      ch+= condition.nombrutchoix(p,v);
      ch += " FNC ";
    }
    BoiteParams* bp=new BoiteParams(ch,xjcoco+250,ycoco,470,HCOCO);//Boite spéciale pour tracer symboles de couleurs (laissez espaces autour du symbole)
  } 
  gcocos->end();
  gcontr->add(gcocos);
  ialg->show();
  end();
  redraw();
}

void cb_ncoco(Fl_Widget* pw,void* data){
  if (env.page=="ajoute"){
    fl_alert("coco non définie en cours");
    return;
  }
  delete pw;
  pw=nullptr;
  IntWin* iw=(IntWin*)data;
  if (contr.cocos[iw->n].id_condition==-1){
    contr.cocos.erase(contr.cocos.begin()+iw->n);
    iw->fenetre->changer_contraintes();
    return;
  }
  iw->fenetre->modif_coco(iw->n);
}

void cb_bval(Fl_Widget* w,void* pw){
  env.page=="modif_coco";
  Fenetre* win=(Fenetre*)pw;
  win->changer_contraintes();
}

void Fenetre::modif_coco(int n){
  Condouv coco=contr.cocos[n];
  gcontr->hide();
  begin();
  gmodif=new Fl_Group(10,30,1400,700);
  gmodif->begin();
  string s="Modification de la coco "+(string)alph[n];
  Fl_Output* omodif=new Fl_Output(xddd,80,450,40);
  omodif->value(s.c_str());
  omodif->textsize(30);
  omodif->box(FL_NO_BOX);
  omodif->textfont(FL_HELVETICA_BOLD);
  //La boîte des paramètres
  Fl_Box* bpar=new Fl_Box(xbchoix,ybchoix,wbchoix,450);
  bpar->box(FL_UP_BOX);
  bpar->color(coul_fenetre_contr);
 //Bouton valider
  Fl_Button* bval=new Fl_Button(xbchoix+ESPD,ybchoix+360,70,30,"&Modifier");
  bval->callback(cb_bval,(void*)this);
  //Le joueur
  int X=xbchoix+ESPD;
  int Y=ybchoix+2*ESPD;
  Fl_Output* bouton=new Fl_Output(X+70,Y,70,25,"Joueur : ");
  bouton->labelsize(16);
  bouton->color(68);
  bouton->box(FL_ROUND_UP_BOX);
  ostringstream oss;
  oss<<"   "<<joueurs[contr.cocos[n].joueur];
  bouton->value(oss.str().c_str());
  bouton->textcolor(FL_WHITE);
  Fl_Select_Browser* choix=new Fl_Select_Browser(X+140,Y,70,70);
  for (int j=0;j<4;j++) choix->add(joueurs[j]);
  Int_Output* data=new Int_Output(n,bouton);
  choix->callback(Fenetre::cb_ojoueur,(void*)data);
  bouton->callback(Fenetre::cb_bjoueur,(void*)choix);
  choix->hide();
  //La condition
  Fl_Output* bcond=new Fl_Output(xbchoix+ESPD+70,Y+80,150,30,"Condition : ");
  string st="  "+conditions[coco.id_condition].nom;
  bcond->value(st.c_str());
  bcond->box(FL_ROUND_UP_BOX);
  bcond->color(68);
  bcond->textcolor(FL_WHITE);
  Fl_Select_Browser* scond=new Fl_Select_Browser(xbchoix+ESPD+70,Y+110,150,200);
  int kl=conditions.size();
  for (int k=0;k<kl;k++){
    scond->add(conditions[k].nom.c_str());
  }
  scond->hide();
  bcond->callback(cb_bjoueur,(void*)scond);
  int xparams=xbchoix+ESPD+200;
  Fl_Group* gparams=new Fl_Group(xparams,Y+80,700,200);
  montre_params(contr.cocos[n],n,gparams);
  DataCond* sdata=new DataCond(n,this,bcond,gparams);
  scond->callback(cb_ocondition,(void*)sdata);
  //Le bouton supprimer
  Fl_Button* bsupp=new Fl_Button(xbchoix+ESPD+100,ybchoix+360,80,30,"&Supprimer");
  IntWin* supdata=new IntWin(n,this);
  bsupp->callback(cb_sup,(void*)supdata);
  gmodif->end();
  end();
}

void cb_sup(Fl_Widget*,void* data){
  IntWin* iw=(IntWin*)data;
  int n=iw->n;
  iw->fenetre->supprime_coco(n);
}

void Fenetre::supprime_coco(int n){
  contr.cocos.erase(contr.cocos.begin()+n);
  changer_contraintes();
  if (contr.con!="") fl_alert("Algèbre à modifier");
}

void enregistre_contr(const char* charnom){
  string nom=charnom;
  ofstream fichier;
  fichier.open(nom);
  fichier<<"fichier_de_contraintes\n";
  //Le nom
  fichier<<"nom "<<nom+"\n"<<"fixees ";
  //Les cartes fixées
  for (int i=0;i<52;i++)
    fichier<<contr.cfixees[i];
  fichier<<"\n";
  //numerofixe
  fichier<<"numero "<<contr.numerofixe<<"\n";
  //Les cocos
  //le numéro le joueur id_condition
  int n=contr.cocos.size();
  for (int i=0;i<n;i++){
    fichier<<"coco "<<alph[i]<<" "<<contr.cocos[i].joueur<<" "<<contr.cocos[i].id_condition<<" ";
    int k=contr.cocos[i].params.size();
    for (int j=0;j<k;j++) fichier<<contr.cocos[i].params[j]<<" ";
    fichier<<" \n";
  }
 //L'algèbre
  if (contr.con != "")
    fichier<<"contexte "<< contr.con+"\n";
  //Les calculs
  n=contr.calculs.size();
  for (int i=0;i<n;i++) fichier<<"calcul "<<Alph[i]<<" "<<contr.calculs[i].nom<<" "<<contr.calculs[i].alg<<" \n";
  fichier.close();
}



//Format du fichier:
//nom
//fixees
//numerofixe
//algebre
//cocos
//contexte (Non)
//calculs
void Fenetre::enr_contr(){
  //Enregistrement dans le fichier <nom>
  const char* charnom=0L;
  charnom=fl_file_chooser("Choisissez un nom de fichier","*",contr.nom.c_str(),1);
  if (charnom){
    //cout <<"charnom "<<charnom<<endl;
    enregistre_contr(charnom);
    contr.nom=charnom;
    //input_contr->value(nom.c_str());
    input_contr->value(charnom);
  }
}


//Récupération des contraintres v0.3_3
void Fenetre::cb_choisir_contr(Fl_Widget*,void* pw){
  //cout<<"cb_choisir_contr"<<endl;
  Fenetre* win=(Fenetre*)pw;
  win->choisir_contr();
}

void Fenetre::charge_contr(const char* charnom){
  string fichier=charnom;
  ifstream ist(fichier,ios::in);
  if  (ist){
    contr=Contraintes(charnom);
    changer_contraintes();
  }
  else initialise();
}

void Fenetre::choisir_contr(){
  detruit_widgets();
  const char* charnom=0L;
  charnom= fl_file_chooser("donnes_dds","*",NULL,1);
  if (charnom){
    charge_contr(charnom);
  }
  redraw();
}

void cb_inomcalc(Fl_Widget* w,void* data){
  Fl_Input* inom=(Fl_Input*)w;
  int* pi=(int*)data;
  string nom=inom->value();
  //On remplace les espaces par des souligne;
  for (int i=0;i<nom.size();i++) if (nom[i]==32) nom[i]='_';
  contr.calculs[*pi].nom=nom;
}
void cb_ialgcalc(Fl_Widget* w,void* data){
  Fl_Input* icalc=(Fl_Input*)w;
  int* pi=(int*)data;
  contr.calculs[*pi].alg=icalc->value();
}
void cb_supcalc(Fl_Widget*,void* data){
  IntWin* iw=(IntWin*)data;
  int i=iw->n;
  Fenetre* win=iw->fenetre;
  contr.calculs.erase(contr.calculs.begin()+i);
  win->changer_contraintes();
}

void Fenetre::place_calcul(int i){
  int ycalc=gcalculs->y()+i*(HCOCO+ESPD)+ESPD;
  Fl_Box* bcalcul=new Fl_Box(xbcocos+2*ESPD,ycalc,wbcocos-4*ESPD,HCOCO);
  bcalcul->color(206);
  bcalcul->box(FL_FLAT_BOX);
  Fl_Box* bncalc=new Fl_Box(xnumcoco,ycalc,20,HCOCO,Alph[i]);
  //Le nom du calcul;
  Fl_Input* inomcalc=new Fl_Input(xnumcoco+80,ycalc,150,HCOCO,"nom");
  inomcalc->value(contr.calculs[i].nom.c_str());
  int* pj=new int;
  *pj = i;
  inomcalc->callback(cb_inomcalc,(void*)pj);
  Fl_Input* ialgcalc=new Fl_Input(xnumcoco+300,ycalc,100,HCOCO,"algèbre");
  ialgcalc->value(contr.calculs[i].alg.c_str());
  ialgcalc->callback(cb_ialgcalc,(void*)pj);
  //Bouton suppression
  Fl_Button* bsuppcalc=new Fl_Button(xnumcoco+wbcocos-80,ycalc+3,20,20,"X");
  IntWin* iw=new IntWin(i,this);
  bsuppcalc->callback(cb_supcalc,(void*)iw);
}


void Fenetre::montre_calculs(){
  gcontr->begin();
  if (gcalculs) Fl::delete_widget(gcalculs);
  gcalculs=nullptr;
  int n=contr.calculs.size();
  int hgcalculs=ESPD+n*(HCOCO+ESPD);
  int hbcocos=ESPD+contr.cocos.size()*(HCOCO+ESPD);
  int ygcalculs=ybcocos+hbcocos+ESPC;
  gcalculs=new Fl_Group(xbcocos,ygcalculs,wbcocos,hgcalculs);
  gcalculs->box(FL_UP_BOX);
  gcalculs->align(FL_ALIGN_LEFT_TOP);
  gcalculs->labeltype(FL_ENGRAVED_LABEL);
  gcalculs->labelsize(18);
  gcalculs->color(coul_fenetre_contr);
  for (int i=0;i<n;i++) place_calcul(i);
  gcontr->end();
  redraw();
}

void Fenetre::ajoute_calcul(){
  int n=contr.calculs.size();
  montre_calculs();
  contr.calculs.push_back(Calcul());
  gcalculs->resizable(NULL);
  gcalculs->begin();
  gcalculs->size(gcalculs->w(),gcalculs->h()+HCOCO+ESPD);
  place_calcul(n);
  gcalculs->end();
}



/*int xc=x_max()/5;
int wc=3*x_max()/5;
Contraintes contr0=Contraintes();
Contraintes contr1;
Contraintes contr2;
extern int nbstat;

void cb_radio(Fl_Widget* w,void* data){
  Fl_Round_Button* rb=(Fl_Round_Button*)w;
  IntWin* iw=(IntWin*)data;
  int i=iw->n;
  Fenetre* win=iw->fenetre;
  if (i==1) contr0=contr;
  else if (i==2){
    const char* charnom;
    charnom=fl_file_chooser(" ","*",NULL,1);
    contr0=Contraintes(charnom);
  } 
  else if (i==10) contr1=contr;
  else if (i==11){
    const char* charnom;
    charnom=fl_file_chooser(" ","*",NULL,1);
    contr1=Contraintes(charnom);
  } 
}

bool cond_fixes(char liste[52],char fixes[52]){
  int i;
  for (i=0;i<52;i++)
    if (fixes[i] != 'V' && liste[i] != fixes[i])
      return 0;
  return 1;
}


vector<int> sur_result(int nbstat,Contraintes& contr0, Contraintes& contr1,int limite){
  int no=contr0.numerofixe;
  if (no==0) no++;
  else if (no<0) no=-no;
  contr0.eff();
  contr1.eff();
  int nb=0;
  int nbthreads=config.nbthreads;
  unsigned long long lim= 1<<limite;
  char liste[52];
  vector<int> sr(1);
  int sr0=0;
  int sr1=1;
  bool ccc;
  int iii;
  #if defined (_OPENMP)
omp_set_num_threads(nbthreads);
//int nt=4;
#pragma omp parallel for private(ccc,liste) schedule(dynamic) reduction(+:nb,sr0) 
//#else
// int nt=1;
#endif
  for (iii=0;iii<nbstat;iii++){
    ccc = false;
    while (!ccc and nb < lim/nbthreads){
      creedonne(liste,contr0.cfixees,contr0);
      if (cond_ouvs(liste,contr0,no)){
	  if (cond_fixes(liste,contr1.cfixees) && cond_ouvs(liste,contr1,no)) sr0++;
	  ccc=true;
      }
      nb++;
    }
  }
  sr[0]=sr0;
  cout<<"sr0"<<sr0<<endl;
  return sr;
  //win->aff_sur_result(sr);
}

void cb_cal(Fl_Widget* w,void* f){
Fenetre* win=(Fenetre*)f;
  vector<int> sr=sur_result(nbstat,contr0,contr1,limite);
cout<<"affiche résultat"<<endl;
  win->aff_sur_result(sr);
}

void Fenetre::sur(){
  detruit_widgets();
  color(fl_rgb_color(190,231,239));
  begin();
  gsur=new Fl_Group(0,30,x_max(),y_max()-30);
  gsur->begin();
  Titrepage* tsur=new Titrepage("Statistiques avec sur-contraintes");
  //Les contraintes
  if (input_contr==0){
    input_contr=new Fl_Output(2*ESPD,yfmains+100,200,30,"Nom des contraintes");
    input_contr->align(FL_ALIGN_TOP);
    input_contr->value(contr.nom.c_str());
    gsur->add(input_contr);
  }
  //Cadre données
  int d=110;
  Fl_Group* gdonnees=new Fl_Group(xc,y_max()/2,wc,y_max()/3+d);
  Fl_Box* bdonnees=new Fl_Box(gdonnees->x(),gdonnees->y(),gdonnees->w(),gdonnees->h()-d);
  bdonnees->box(FL_UP_BOX);
  bdonnees->color(coul_fenetre_contr);
  BoiteTexte* bt=new BoiteTexte(" Contraintes : ",bdonnees->x()+ESPD,bdonnees->y()+ESPD,18,FL_DARK_BLUE,FL_HELVETICA_BOLD);
  //RADIOS contraintes
  Fl_Group* o=new Fl_Group(bt->x()+120+ESPD,bdonnees->y()+ESPD,200,75);
  o->begin();
  o->box(FL_BORDER_FRAME);
  vector<Fl_Round_Button*> rb(3);
  for (int i=0;i<3;i++){
    int* pi=new int;
    *pi=i;
    rb[i]=new Fl_Round_Button(o->x()+ESPD,o->y()+25*i,150,25);
    rb[i]->type(FL_RADIO_BUTTON);
    rb[i]->callback(cb_radio,(void*)pi);
  }
  rb[0]->label(" pas de contrainte");
  rb[1]->label(" contraintes en cours");
  rb[2]->label(" choisir");
  o->end();
  //sur-contraintes1
  BoiteTexte* bt1=new BoiteTexte(" Sur-contraintes 1 : ",o->x()+o->w()+4*ESPD,bdonnees->y()+ESPD,18,FL_DARK_BLUE,FL_HELVETICA_BOLD);
  Fl_Group* o1=new Fl_Group(bt1->x()+160+ESPD,bdonnees->y()+ESPD,200,50);
  o1->begin();
  o1->box(FL_BORDER_FRAME);
  vector<Fl_Round_Button*> rb1(3);
  for (int i=0;i<2;i++){
    //int* pi=new int;
    //*pi=i;
    IntWin* data=new IntWin(i+10,this);
    rb1[i]=new Fl_Round_Button(o1->x()+ESPD,o1->y()+25*i,150,25);
    rb1[i]->type(FL_RADIO_BUTTON);
    rb1[i]->callback(cb_radio,(void*)data);
  }
  rb1[0]->label(" contraintes en cours");
  rb1[1]->label(" choisir");
  o1->end();
  //Bouton calculer
  Fl_Button* bcal=new Fl_Button(bdonnees->x()+bdonnees->w()-120,bdonnees->y()+bdonnees->h()-35,80,25,"Calculer");
  bcal->callback(cb_cal,(void*)this);
    //Nb donnes et limite
  parametres(bdonnees->y()+bdonnees->h()+ESPC,bdonnees->x(),bdonnees->w());
  gsur->end();
  end();
  }*/



/*
void Fenetre::aff_sur_result(vector<int>& sr){
//cout<<"affiche"<<endl;
  gsur->begin();
  if (gsur==nullptr) return;
  //Cadre des résultats
Fl_Group* gsurres=new Fl_Group(xc,y_max()/4,wc,y_max()/4-ESPC);
  gsurres->box(FL_UP_BOX);
  gsurres->color(coul_fenetre_contr);
  gsur->end();
redraw();
}
*/
