#include <fstream>
#include "fenetre.h"
#include "dds.h"
#include "tableaux.h"

//Variables du fichier
unsigned int jeux_ini[4][4];
deal* pdl=0;
char leveesNS = 0;
char leveesEO = 0;

//Vecteurs pour retour
vector<deal> vecteur_deal; 
vector<char> vecteurNS(1,0);
vector<char> vecteurEO(1,0);

int nb_cartes_jouees_levee(){
  int n=0;
  for (int i=0;i<3;i++){
    if (pdl->currentTrickRank[i]==0) return n;
    else n++;
  }
  return n;
}

//Remplissage auto du 4e jeu
bool remplitjeu4(){
  int nbcartes[4]={0,0,0,0};
  int totcoul[4]={0,0,0,0};
  int c;
  for (int j=0;j<4;j++)
    for (int c=0;c<4;c++){
      nbcartes[j]+=comptebit(pdl->remainCards[j][c]);
      totcoul[c]+=pdl->remainCards[j][c];
    }
  if (nbcartes[0]<13){
    if (nbcartes[1]==13 && nbcartes[2]==13 && nbcartes[3]==13)
      for (c=0;c<4;c++) pdl->remainCards[0][c]+=(1<<15)-4-totcoul[c];
  }
  else if (nbcartes[1]<13){
    if (nbcartes[2]==13 && nbcartes[3]==13) 
      for (c=0;c<4;c++) pdl->remainCards[1][c]+=(1<<15)-4-totcoul[c];
  }
  else if (nbcartes[2]<13){
    if (nbcartes[3]==13)
      for (c=0;c<4;c++) pdl->remainCards[2][c]+=(1<<15)-4-totcoul[c];
  }
  else if (nbcartes[3]<13){
    for (c=0;c<4;c++) pdl->remainCards[3][c]+=(1<<15)-4-totcoul[c];
    }
  int nbc[4]={0,0,0,0};
  for (int j=0;j<4;j++)
    for (int c=0;c<4;c++){
      nbc[j]+=comptebit(pdl->remainCards[j][c]);
    }
  for (int i=1;i<4;i++){
    for (int j=0;j<i;j++){
      if (nbc[i]!=nbc[j]){
	fl_alert("Données incorrectes, les 4 joueurs doivent avoir le même nombre de cartes");
	return 0;
      }
    }
  }
  for (int j=0;j<4;j++)
    for (int c=0;c<4;c++){
      jeux_ini[j][c]=pdl->remainCards[j][c];
    }
  return 1;
}

void ini_dl(){
  pdl=new deal;
  pdl->trump=4;
  pdl->first=3;
  for (int i=0;i<3;i++){
    pdl->currentTrickSuit[i]=0;
    pdl->currentTrickRank[i]=0;
  }
  for (int i=0;i<4;i++)
    for (int j=0;j<4;j++) pdl->remainCards[i][j]=0;
}

struct futureTricks fut;

void free_fut(futureTricks& fut){
  int i;
  fut.nodes = 0;
  fut.cards = 0;
  for (i=0;i<13;i++)
    fut.suit[i]=0;
  for (i=0;i<13;i++)
    fut.rank[i]=0;
  for (i=0;i<13;i++)
    fut.equals[i]=0;
  for (i=0;i<13;i++)
    fut.score[i]=0;
}

void cb_scouleur(Fl_Widget* brow,void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  int n=b->value();
  Fl_Button* bou=(Fl_Button*)bouton;
  b->hide();
  bou->label(sacouls[n-1]);
  pdl->trump=(n+3)%5;//pique=0 ....SA=4
}

void cb_sjoueur(Fl_Widget* brow,void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  int n=b->value();
  Fl_Button* bou=(Fl_Button*)bouton;
  b->hide();
  bou->label(nomjoueur[n-1].c_str());
  pdl->first=n-1;
}


void Fenetre::cb_demarre_analyse(Fl_Widget*,void* pw){
  vecteur_deal.clear();
  vecteurEO.clear();
  vecteurNS.clear();
  leveesNS=0;
  leveesEO=0;
  listetoremain(contr.cfixees,pdl->remainCards);
  for (int i=0;i<3;i++){
    pdl->currentTrickSuit[i]=0;
    pdl->currentTrickRank[i]=0;
  }
  remplitjeu4();
  vecteur_deal.push_back(*pdl);
  vecteurEO.push_back(0);
  vecteurNS.push_back(0);
  Fenetre* win=(Fenetre*)pw;
  free_fut(fut);
  int sb=SolveBoard(*pdl,-1,3,1,&fut,0);
  if (sb==1) win->affiche_dds();
  else{
    if (sb==-2) 
      fl_alert("Aucune cartes entrée");
    else if (sb==-4)
      fl_alert("Attention, un doublon est présent");
    else if (sb==-12)
      fl_alert("Carte incorrecte dans la levée courante");
    return;
  }
}

void Fenetre::cb_retour(Fl_Widget*,void* pw){
  vecteur_deal.pop_back();
  vecteurEO.pop_back();
  vecteurNS.pop_back();
  leveesNS = vecteurNS.back();
  leveesEO = vecteurEO.back();
  *pdl = vecteur_deal.back();
  free_fut(fut);
  int sb=SolveBoard(*pdl,-1,3,1,&fut,0);
  Fenetre* win=(Fenetre*)pw;
  if (sb==1) win->affiche_dds();
  else fl_alert("Erreur"+sb);
}

void Fenetre::cb_analyse(Fl_Widget*,void* pw){
  Fenetre* win=(Fenetre*)pw;
  if (pdl) pdl=0;
  ini_dl();
  win->affiche_dds();
}


int score(int couleur,int rang,futureTricks& fut){
  for (int i=0;i<13;i++){
    if (fut.suit[i]==couleur && fut.rank[i]==rang) return fut.score[i];
  }
  return -1;
}

int vainqueur(int couleurs[4],int rangs[4],int atout){
  //Renvoie le gagnant de la levée (first=0, ...)
  bool a=0;
  int m=0;
  int v;
  for (int j=0;j<4;j++){
    if (couleurs[j]==atout) {
      a=1; 
      if (rangs[j]>m) {m=rangs[j];v=j;}
    }
  }
  if (a==0){
    for (int j=0;j<4;j++){
      if (couleurs[j]==couleurs[0]){
	if (rangs[j]>m) {m=rangs[j]; v=j;}
      }
    }
  }
  return v;
}

struct Boite_score:Fl_Box{
  Boite_score(int x,int y,int n):Fl_Box(x,y,15,15,num[n]){
    labelcolor(FL_BLUE);
  }
};


void Fenetre::place_couleur_dds(int x,int y,int couleur,int nini,int n,int joueur){
//void Fenetre::place_couleur_dds(int x,int y,int couleur,int nini,int n,int joueur,futureTricks& fut){
  //nini cartes initiales, n cartes restantes
  extern futureTricks fut;
  new Symb_couleur(x,y,couleur);
  for (int r=14;r>1;r--){
    if (bitdans(nini,r)){
      x+=CC+ESPC;
      Bouton_carte *bc =new Bouton_carte(x,y,r);
      if (bitdans(n,r)){
	//On place la carte dans data
	if (joueur>=0 && score(couleur,r,fut)>-1){
	//if (joueur>=0 && ){
	  CardWin* data=new CardWin(joueur,couleur,r,this);
	  bc->callback(cb_boutoncarte,(void*)data);
	  new Boite_score(x,y+20,score(couleur,r,fut));
	}
      }
      else bc->value(1);
    }
  }
}

void Fenetre::place_jeu_dds(int x,int y,int place,int joueur){
  //extern futureTricks fut;
  extern deal* pdl;
  int dy=28;
  int premier=-1;
  if (place==joueur){
    dy+=10;
    premier=joueur;
  }
  for (int c=0;c<4;c++){
    place_couleur_dds(x,y+dy*c,c,jeux_ini[place][c],pdl->remainCards[place][c],premier);
  }
}


void Fenetre::affiche_dds(){
  detruit_widgets();
  begin();
  gjdds=new Fl_Group(0,30,x_max(),y_max());
  gjdds->begin();

  //Titre
  Fl_Box* btitre=new Fl_Box(xfmains,80,350,50,"Jouer avec dds");
  btitre->labelsize(40);
  btitre->labelfont(FL_HELVETICA_BOLD);
  int joueur=(pdl->first+nb_cartes_jouees_levee())%4;
  cout<<"joueur "<< joueur <<endl;

  //Choix couleur et entameur
  //La couleur
  const int yb=180;
  const int hb=25;
  const int bord=50;
  const int wbcouleur = 70;
  const int xlab=bord+ESPD;
  Fl_Box* bcouleur_lab=new Fl_Box(xlab,yb,fl_width("Atout : "),hb,"Atout : ");
  bcouleur_lab->labelsize(18);
  Fl_Button* boucouleur=new Fl_Button(bcouleur_lab->x()+bcouleur_lab->w()+ESPD,yb,wbcouleur,hb,sacouls[(pdl->trump+1)%5]);
  boucouleur->color(FL_WHITE);
  Fl_Select_Browser* scouleur=new Fl_Select_Browser(boucouleur->x(),yb+hb,wbcouleur,100);
  for (int i=0;i<5;i++) scouleur->add(sacouls[i]);
  scouleur->hide();
  scouleur->callback(cb_scouleur,(void*)boucouleur);
  boucouleur->callback(Fenetre::cb_bjoueur,(void*)scouleur);

  //Le joueur
  const int xpar=boucouleur->x()+boucouleur->w()+3*ESPD;
  const int wpar=70;
  const int xbouj= xpar+wpar;
  const int wbouj= 70;
  Fl_Box* bpar=new Fl_Box(xpar,yb,wpar,hb,"Premier : ");
  bpar->labelsize(18);
  Fl_Button*  boujoueur= new Fl_Button(xbouj,yb,wbouj,hb,joueurs[pdl->first]);
  boujoueur->color(FL_WHITE);
  Fl_Select_Browser* sjoueur=new Fl_Select_Browser(xbouj,yb+hb,wbouj,80);
  sjoueur->add("Nord");
  sjoueur->add("Est");
  sjoueur->add("Sud");
  sjoueur->add("Ouest");
  sjoueur->callback(cb_sjoueur,(void*)boujoueur);
  sjoueur->hide();
  boujoueur->callback(Fenetre::cb_bjoueur,(void*)sjoueur);

  //Bouton démarrer
  const char* lab=" Démarrer analyse ";
  Fl_Button* bdds = new Fl_Button(boujoueur->x()+boujoueur->w()+50,boujoueur->y(),fl_width(lab),hb,lab);
  bdds->callback(cb_demarre_analyse,(void*)this);

  //Bouton retour
  const char* labretour=" Retour ";
  Fl_Button* bretour = new Fl_Button(bdds->x()+bdds->w()+50,bdds->y(),fl_width(labretour),hb,labretour);
  bretour->callback(cb_retour,(void*)this);

  //La boîte des jeux
  const int yjeux=yb+40;
  //On commence par compter le nombre de cartes de la couleur la plus longue de chaque jeu
  vector<int> ml = maxlongs(jeux_ini);
  vector<int> wjeux(3);
  wjeux[0]=max(max(ml[0],ml[2])*23+30,80);//largeur jeux NS
  wjeux[1]=ml[3]*23+30;//largeur jeu ouest
  wjeux[2]=ml[1]*23+30;//largeur jeu Est
  const int hmain=130;
  Fl_Box* bmains=new Fl_Box(xfmains,yjeux,wjeux[0]+wjeux[1]+wjeux[2],3*hmain+40);
  bmains->box(FL_UP_BOX);
  bmains->color(coul_fenetre_contr);

  //On place les mains. La hauteur du joueur est augmentée de 40
  int delta=30;
  int xouest=xfmains+ESPC;
  int youest=yjeux+hmain;
  int xnord=xouest+wjeux[1];
  int ynord=yjeux+2*ESPC;
  int xest=xnord+wjeux[0];
  int ysud=youest+hmain;
  if (joueur%2==1) ysud+=delta;
  else if (joueur==0){youest+=delta;ysud+=delta;}
  place_jeu_dds(xouest,youest,3,joueur);
  place_jeu_dds(xnord,ynord,0,joueur);
  place_jeu_dds(xest,youest,1,joueur);
  place_jeu_dds(xnord,ysud,2,joueur);

  //Les levées réalisées
  int yl=yjeux+bmains->h()+2*ESPD;
  const char* lablev= " Levées NS : ";
  Fl_Value_Output* old=new Fl_Value_Output(xlab+fl_width(lablev),yl,30,25,lablev);
  old->value(leveesNS);
  old->color(FL_WHITE);
  Fl_Value_Output* oleo=new Fl_Value_Output(old->x()+old->w()+fl_width(lablev)+50,yl,30,25,"Levées EO : ");
  oleo->value(leveesEO);
  oleo->color(FL_WHITE);
  gjdds->end();
  end();
  redraw();
}

void cb_boutoncarte(Fl_Widget* obj,void* data){
  extern deal* pdl;
  Bouton_carte* refbou=(Bouton_carte*)obj;
  refbou->value(1);
  CardWin* cartewin=(CardWin*)data;
  //le joueur
  int first=pdl->first;
  int joueur=cartewin->joueur;
  int rj=(joueur-first+4)%4;
  int c=cartewin->suit;
  int r=cartewin->rank;
  pdl->remainCards[joueur][c]-=1<<r;
  if (rj<3){
    pdl->currentTrickSuit[rj]=c;
    pdl->currentTrickRank[rj]=r;
  }
  else{
    int couleurs[4];
    int rangs[4];
    for (int i=0;i<3;i++){
      couleurs[i]=pdl->currentTrickSuit[i];
      rangs[i]=pdl->currentTrickRank[i];
    }
    couleurs[3]=c;
    rangs[3]=r;
    int v=vainqueur(couleurs,rangs,pdl->trump);
    pdl->first=(pdl->first+v)%4;
    ((pdl->first)%2)? leveesEO++:leveesNS++;
    for (int i=0;i<3;i++){
      pdl->currentTrickSuit[i]=0;
      pdl->currentTrickRank[i]=0;
    }
  }
  vecteur_deal.push_back(*pdl);
  vecteurNS.push_back(leveesNS);
  vecteurEO.push_back(leveesEO);
  free_fut(fut);
  int sb=SolveBoard(*pdl,target,3,2,&fut,0);
  if (sb==-4){fl_alert("Carte multiple");}
  else if (sb==-12){fl_alert("Couleur ou rang de carte impossible");}
  cartewin->fenetre->affiche_dds();
}

void tabdds(){
  complete_donne(contr.cfixees);
  for (int i=0;i<52;i++) if (contr.cfixees[i]=='V'){
      fl_alert("La donne n'est pas complète");
      return;
    }
  ddTableDeal tableDeal;
  ddTableResults tablep;
  for (int i=0;i<4;i++) {for (int j=0;j<4;j++) tableDeal.cards[i][j]=0;};
  listetoremain(contr.cfixees,tableDeal.cards);
  for (int i=0;i<5;i++) for (int j=0;j<4;j++){
      tablep.resTable[i][j]=0;
    }
  int cb=CalcDDtable(tableDeal,&tablep);
  //cout<<"cb "<<cb<<endl;
  if (cb==-14){
    fl_alert("Toutes les mains doivent avoir le même nombre de cartes");
    return;
  }
  //Affichage des résultats
  int largeur=400;
  int hauteur=400;
  int htitre=40;
  int bord=15;
  int x=50;
  int y=50;
  int largint=largeur-2*bord;
  Fl_Window* wtabdds=new Fl_Window(2*xm/3,100,largeur,hauteur,"Tableau DDS");
  wtabdds->color(coulformext);
  wtabdds->begin();
  Fl_Box* btitre=new Fl_Box(0,0,largeur,htitre,"Tableau DDS");
  btitre->labelsize(18);
  btitre->labelcolor(246);
  Fl_Box* bcont=new Fl_Box(bord,bord+htitre,largint,hauteur-htitre-2*bord);
  bcont->color(coulformint);
  bcont->box(FL_FLAT_BOX);
  int xx = bcont->x()+bord;
  int yy= bcont->y()+bord;
  Fl_Box* ba=new Fl_Box(xx,yy,largint-2*bord,150);
  ba->box(FL_FRAME_BOX);
  ba->color(fl_rgb_color(202,251,242));
  //Le par et tabddt:
  TabDDT* tabddt=new TabDDT(xx,yy+25,ba->w(),125);
      for (int j=0;j<4;j++)
      	for (int c=0;c<5;c++)
      	  tabddt->data[j][c]=tablep.resTable[c][j];
      //serie.vtable[i]=tablep;
      structpar resupar;
      int no=contr.numerofixe;
      if (no==0){
	fl_alert("Numéro non fixé, on suppose personne vulnérable");
	no++;}
      int p=par(tablep.resTable,no,resupar);
      //serie.vresupar[i]=resupar;
      BoitePar* op=new BoitePar(xx+bord,yy,200,25,resupar);
  wtabdds->end();
  wtabdds->show();
}

void cb_tabdds(Fl_Widget*,void*){
  tabdds();
}
