#include "fenetre.h"
#include <iomanip>
#include "tableaux.h"
#include <fstream>

#include "../pixmaps/tile.xpm"

//220 cb_pdf
//324 affiche
//448 Centre::Centre
//535 verifie_coco
//684 options

const char* titre="CPPGEN, générateur et calculateur pour le bridge";

//Constantes pour affichage
int nb_d=12;
bool odds=0;
const char* nom="";
serie_donnes donnes;
vector<int> nums;

//structure pour les séries de donnes
struct Serie{
  int nb_d=12;
  serie_donnes donnes;
  vector<int> nums;
  vector<structpar> vresupar;
  string nom="Sans nom";
  vector<ddTableResults> vtable;
};

//Serie en cours
Serie serie;



Fenetre::Fenetre(int ww,int hh,const char *ss)
  :Fl_Double_Window(ww,hh,ss),w(ww),h(hh){init();}

void Fenetre::init(){
 fl_register_images(); 
 color(fl_rgb_color(248,242,180));
 //ajoute_image();
  ajoute_menu();
  ajoute_titre(titre);
  resizable(btitre);
  show();
}

void Fenetre::ajoute_image(){
   begin();
   fl_register_images();
   gimage=new Fl_Group(0,0,400,400);
   gimage->align(FL_ALIGN_INSIDE);
   const char* filename = "images/sienne.jpg";
   gimage->image(new Fl_Tiled_Image(new Fl_JPEG_Image(filename)));
   end();
}


void Fenetre::detruit_widgets(){
  btitre->hide();
//  if (gimage){
//  gimage->hide();
//    Fl::delete_widget(gimage);
//gimage=nullptr;}
  if (gres_lev){
    gres_lev->hide();
    Fl::delete_widget(gres_lev);
    gres_lev=nullptr;}
  if (gcontr) gcontr->hide();
  if (gjdds) gjdds->hide();
  if (scroll) scroll->hide();
  if (gstats) gstats->hide();
  if (gmodif){
    Fl::delete_widget(gmodif);
    gmodif=nullptr;}
  if (gentames){ //gentames->hide();
    Fl::delete_widget(gentames);
    gentames=nullptr;
  }
  if (gcompare) gcompare->hide();
  if (gpasapas){ //gpasapas->hide();
    //Fl::delete_widget(gpasapas);
    //gpasapas=nullptr;
    gpasapas->hide();
  }
  if (gsur) gsur->hide();
  if (gdistribution) gdistribution->hide();
  if (geval) geval->hide();
}


void Fenetre::ajoute_titre(const char* titre){
  //Fl_Box* boite=0;
  begin();
  btitre=new Fl_Box(x_max()/5,y_max()/4,3*x_max()/5,y_max()/3,titre);
  btitre->align(FL_ALIGN_WRAP);
  btitre->labelfont(FL_HELVETICA_BOLD);
  btitre->labelsize(26);
  btitre->color(fl_rgb_color(240,230,140));
  btitre->box(FL_UP_BOX);
  //const char* filename = "images/sienne.jpg";
  //Fl_JPEG_Image jpg(filename);
  //boite=new Fl_Box(10,10,720-20,486-20,"Boite");
  //boite->color(fl_rgb_color(100,0,1));
  //boite->image(jpg);
  new Fl_Box(x_max()-300,y_max()-40,300,40,"Etienne Marache Copyright (C) 2016-2018");
  end();
}
/////////////////////////////////////////////////////////////////
/* -------------------- CONFIGURATION -------------------------*/
/////////////////////////////////////////////////////////////////
int largeur=700;
int hauteur=600;
int bord=15;
int htitre=40;
int dx=20;
//Fl_Color coulformext=fl_rgb_color(40,101,80);
//Fl_Color coulformint=fl_rgb_color(250,255,224);

int Config::remplace(string l,string s){
  //crée une copie avec la ligne remplacée nommée temp
  ifstream filein("cppgen.ini");
  ofstream fileout("temp");
  string strtemp;
  if (!filein) {
    return 1;
  }
  if (!fileout) {
    return 1;
  }
  while(getline(filein,strtemp)){
    fileout<<strtemp<<"\n";
    if (strtemp==l){
      getline(filein,strtemp);
      fileout<<s<<"\n";
    }
  }
  //(void)remove("cppgen.ini");
  //rename("temp","cppgen.ini");
  return 0;
}

void cb_cmdpdf(Fl_Widget* w,void*){
  Fl_Input* ins=(Fl_Input*)w;
  config.cmdpdf=ins->value();
  config.remplace("#commande du lecteur pdf",string(ins->value()));
  (void)remove("cppgen.ini");
  rename("temp","cppgen.ini");
}

void cb_nbthr(Fl_Widget* w,void*){
  Fl_Input* ins=(Fl_Input*)w;
  config.nbthreads=atoi(ins->value());
  SetMaxThreads(config.nbthreads);
  config.remplace("#nombre de threads",string(ins->value()));
  (void)remove("cppgen.ini");
  rename("temp","cppgen.ini");
}

void formconfig(Config& conf){
  //Ouvre le formulaire de configuration
  //constantes dans la partie CONFIGURATION ligne 81
  Fl_Window* woptions=new Fl_Window(50,100,largeur,hauteur,"Configuration");
  woptions->color(coulformext);
  woptions->begin();
  //Le titre
  Fl_Box* btitre=new Fl_Box(0,0,largeur,htitre,"Formulaire configuration");
  btitre->labelsize(18);
  btitre->labelcolor(246);
  //La boîte des options
  Fl_Box* bcont=new Fl_Box(bord,bord+htitre,largeur-2*bord,hauteur-htitre-2*bord);
  bcont->color(coulformint);
  bcont->box(FL_FLAT_BOX);
  //Lecteur pdf
  Fl_Input* inom=new Fl_Input(bord+fl_width("Commande lecteur pdf : ")+dx,bcont->y()+ESPD,200,25,"Commande lecteur pdf : ");
  inom->value(config.cmdpdf.c_str());
  inom->callback(cb_cmdpdf);
  //Nombre de threads
  Fl_Input* ithr=new Fl_Input(bord+fl_width("Nombre de threads : ")+dx,inom->y()+50,30,25,"Nombre de threads : ");
  ithr->value(to_string(config.nbthreads).c_str());
  ithr->callback(cb_nbthr);
  woptions->end();
  woptions->show();
}

void cb_config(Fl_Widget*,void*){
  formconfig(config);
}

/* ------------------------ PDF ------------------------------- */

string latniveaux[5] = {"\\tp","\\kp","\\cp","\\pp","SA"};

bool ecrit_diag(){
  //Ecrit les diagrammes des n donnes de serie dans le fichier but."""
  //fichierbut=latex/1.tmp;
  //S'il y a des donnes, on écrit dans le fichier latex/diagrammes.tmp
  if (donnes.size()==0){
    fl_alert("Pas de diagramme à afficher");
    return 0;
  }
  string nomfichier;
  //if (odds) nomfichier="latex/diagrammesdds.tmp";
  nomfichier="latex/diagrammes.tmp";
  ofstream fichier;
  fichier.open(nomfichier);
  fichier<<nb_d<<"\n";
  fichier<<serie.nom<<"\n";
  for (int i=0;i<donnes.size();i++){
    fichier<<nums[i]<<"\n";
    for (int j=0;j<4;j++){
      for (int coul=0;coul<4;coul++){
	fichier<<cartes_couleur(donnes[i],"NOES"[j],coul)<<"\n";
      }
    }
    if (odds){
      //Ecriture du par
      //ostringstream oss;
      int niv=serie.vresupar[i].contrat;
      int d=niv/10;
      int a=niv%10;
      int b=niv%5;
      const char* cj=joueurs[serie.vresupar[i].joueur];
      fichier<<d<<latniveaux[b];
      if (a!=b) fichier<<"{}X";
      fichier<<"{  }par "<<cj<<"  "<<serie.vresupar[i].score<<"\n";
      int co[5]={3,2,1,0,4};
      for (int k=0;k<4;k++){
	fichier<<"NESO"[k];
	for (int l=0;l<5;l++) fichier<<"&"<<serie.vtable[i].resTable[co[l]][k];
	fichier<<"\n";
      }
    }
  }
  fichier.close();
  return 1;
}
  


void cb_pdf(Fl_Widget*,void*){
  int l=nb_d;
  nums.resize(l);
  if (l==0){fl_alert("Pas de donne en cours");
    return;}
  int no;
  no=contr.numerofixe;
  for (int i=0;i<l;i++){
    if (no==0) nums[i]=i+1;
    else if (no>0) nums[i]=no;
    else if (no<0) nums[i]=-no+4*i;
  }
  if (ecrit_diag()){
    char cmd[63];
    if (odds){
      system("pdflatex  --output-directory=diagrammes latex/diagrammesdds");
      sprintf(cmd,"%s diagrammes/diagrammesdds.pdf",config.cmdpdf.c_str());
    }
    else{
      system("pdflatex  --output-directory=diagrammes latex/diagrammes");
      sprintf(cmd,"%s diagrammes/diagrammes.pdf",config.cmdpdf.c_str());
    }
    system(cmd);
  }
}


void Fenetre::cb_entames(Fl_Widget*,void* pw){
  Fenetre* win=(Fenetre*)pw;
  win-> entames();//dans statistiques.cpp
  }


void Fenetre::ajoute_menu(){
  begin();
  Fl_Menu_Bar* menu=new Fl_Menu_Bar(0,0,x_max(),HMENU);
  menu->add("C&ppGen/&configurer",FL_COMMAND+'u',cb_config);
  menu->add("C&ppGen/&quitter",FL_COMMAND+'q',cb_quit,(void*)this);

  menu->add("&Contraintes/&Initialiser",FL_COMMAND+'i',cb_ini,(void*)this);
  menu->add("&Contraintes/&Montrer",FL_COMMAND+'m',cb_fixe,(void*)this);//fenetre.h L249 changer_contraintes (contraintes.cpp L65) 
  menu->add("&Contraintes/&Enregistrer",FL_COMMAND+'e',cb_enr_contr,(void*)this);
  menu->add("&Contraintes/&Choisir",FL_COMMAND+'c',cb_choisir_contr,(void*)this);
  menu->add("&Contraintes/Ajouter coco",FL_COMMAND+'o',cb_ajouter,(void*)this);
  menu->add("&Contraintes/Ajouter calcul",0,cb_calcul,(void*)this);

  menu->add("&Générateur/&Options",FL_COMMAND+'o',cb_options);
  menu->add("&Générateur/&Afficher",FL_COMMAND+'a',cb_distr,(void*)this);
  menu->add("&Générateur/&Crée pdf",FL_COMMAND+'p',cb_pdf);

  menu->add("&DDS/&Analyse",FL_COMMAND+'A',cb_analyse,(void*)this);//ddd.cpp L162
  menu->add("&DDS/Tableau",0,cb_tabdds);

  menu->add("&Statistiques/&Comparer",FL_ALT+'c',cb_comparer,(void*)this);//fenetre.h L269 lance comparer (statistiques L191)
  menu->add("&Statistiques/&Levées",FL_ALT+'l',cb_stats_levees,(void*)this);//fenetre.h L273 résultats dans statistiques#res_levees L813.
  menu->add("&Statistiques/&Meilleure carte",FL_ALT+'e',cb_entames,(void*)this);//resultat dans statistiques.cpp#entames() 
  menu->add("&Statistiques/&Pasapas",0,cb_formpasapas,(void*)this);
  menu->add("&Statistiques/&Calculer",0,cb_surcontraintes,(void*)this);//=calculer. statistiques.cppL1665

  menu->add("&Probabilités/Calculer",FL_ALT+'C',cb_probas);//dans probas.cpp
  menu->add("&Probabilités/Distribution",0,cb_distribution,(void*)this);//dans probas.cpp

  menu->add("&Evaluation",0,cb_evaluation,(void*)this);//dans eval.cpp
  end();
redraw();
}

void Fenetre::cb_joueur(Fl_Widget* w,void* sdata){
    Fl_Select_Browser* b=(Fl_Select_Browser*)w;
    int joueur=b->value()-1;
    Deux_Vides* dv=(Deux_Vides*)sdata;
    int n=dv->no_coco;
    Fl_Button* bout=dv->pb;
    contr.cocos[n].joueur=joueur;
    b->hide();
    bout->label(nomjoueur[joueur].c_str());  
  }

void Fenetre::cb_ojoueur(Fl_Widget* w,void* sdata){
  //Comme cb_joueur mais changement de value au lieu de lable
    Fl_Select_Browser* b=(Fl_Select_Browser*)w;
    int joueur=b->value()-1;
    Int_Output* dv=(Int_Output*)sdata;
    int n=dv->no_coco;
    Fl_Output* bout=dv->pb;
    contr.cocos[n].joueur=joueur;
    b->hide();
    bout->value((string("  ")+nomjoueur[joueur]).c_str());
  }

void Fenetre::affiche(){
  if (limite>31){fl_alert("limite ne doit pas dépasser 31");return;}
  time_t tbegin,tend;
  clock_t tempsd,tempsf;
  tbegin=time(NULL);
  tempsd=clock();
  //remplacer par clear ?
  if (scroll) {delete scroll;
    scroll=nullptr;
  }
  int xdeb=(xm-waff)/2;
  int ydeb=30;
  scroll=new Fl_Scroll(xdeb,26,waff+4*ESPD,ym-40,"Affichage");
  scroll->labeltype(FL_NO_LABEL);
  add(scroll);
  int nb=0;
  int* pi=&nb;
  donnes=boucle(nb_d,contr,limite,pi);
  int no=contr.numerofixe;
  if (gmains) gmains->hide();
  if (gcontr) gcontr->hide();
  
  scroll->begin();
  int nb_donnes=donnes.size();
  vector<Fl_Box*> fdonne(nb_donnes);
  int haff = daff+odds*150;//hauteur d'une donne
  ddTableDeal tableDeal;
  ddTableResults tablep;
  serie.vresupar.resize(nb_d);
  serie.vtable.resize(nb_d);
  for (int i=0;i<nb_donnes;++i){
    if (contr.numerofixe==0) no++;
    else if (contr.numerofixe<0) no+=4;
    char liste[52];
    for (int k=0;k<52;k++) liste[k]=donnes[i][k];
    //Affichage des donnes 3 sur chaque ligne
    int col=i%3;
    int lig=i/3;
    int xdonne=xdeb+(col+1)*ESPD+col*daff;
    int ydonne=ydeb+(2*lig+1)*ESPD+lig*haff;
    fdonne[i]=new Fl_Box(xdonne,ydonne,daff,haff+2*ESPC);
    fdonne[i]->color(couleur_affichage);
    fdonne[i]->box(FL_UP_BOX);
    int xnord=xdonne+maff+ESPC;
    int ynord=ydonne+ESPC;
    Boite_Main* mainn=new Boite_Main(xnord,ynord,maff,maff,liste,'N');
    //Ouest
    int xouest=xdonne+ESPC;
    int youest=ydonne+maff+ESPC;
    Boite_Main* maino=new Boite_Main(xouest,youest,maff,maff,liste,'O');
    //Centre
    Centre* centre=new Centre(xnord,youest,maff,no);
    int xest=xdonne+ESPC+2*maff;
    int ysud=ydonne+ESPC+2*maff;
    Boite_Main* maine=new Boite_Main(xest,youest,maff,maff,liste,'E');
    Boite_Main* mains=new Boite_Main(xnord,ysud,maff,maff,liste,'S');
    //Si l'analyse à 4 jeux est demandée, on crée et on affiche le par et la table
    if (odds){
      for (int i=0;i<4;i++) {for (int j=0;j<4;j++) tableDeal.cards[i][j]=0;};
      listetoremain(liste,tableDeal.cards);
      for (int i=0;i<5;i++) for (int j=0;j<4;j++){
	  tablep.resTable[i][j]=0;
	}
      int cb=CalcDDtable(tableDeal,&tablep);
      //Boîte contenant l'analyse:
      int yba=ydonne+daff;
      Fl_Box* ba=new Fl_Box(xdonne+ESPC,yba,daff-2*ESPC,150);
      ba->box(FL_FRAME_BOX);
      ba->color(fl_rgb_color(202,251,242));
      //Le par et tabddt:
      TabDDT* tabddt=new TabDDT(xdonne+ESPC,yba+25,daff-2*ESPC,125);
      for (int j=0;j<4;j++)
      	for (int c=0;c<5;c++)
      	  tabddt->data[j][c]=tablep.resTable[c][j];
      serie.vtable[i]=tablep;
      structpar resupar;
      int p=par(tablep.resTable,no,resupar);
      serie.vresupar[i]=resupar;
      BoitePar* op=new BoitePar(xdonne+ESPD,yba,200,25,resupar);
      //int contrat=resupar.contrat;
      //ostringstream oss;
      //oss<<"Par : "<<enchere(contrat)<<" par "<<joueurs[resupar.joueur]<<" "<<resupar.score;
      //op->value(oss.str().c_str());
    }
  }
  //Affichage du temps
  tend=time(NULL);
  int t=difftime(tend,tbegin);
  tempsf=clock();
  int lig=(nb_donnes+2)/3;
  int ytemps=ydeb+(2*lig+1)*ESPD+lig*haff;
  Fl_Output* ot=new Fl_Output(xdeb,ytemps,500,25);
  ostringstream oss;
  oss<<nb<<" tirages pour "<<nb_donnes<<" donnes en "<<t<<"s. Temps CPU :"<<(double)(tempsf-tempsd)/CLOCKS_PER_SEC;
  ot->value(oss.str().c_str());
  scroll->end();
  scroll->show();
  redraw();
}

Boite_Main:: Boite_Main(int x,int y,int w,int h,char* liste,char J):
  Fl_Box(x,y,w,h){
    color(FL_WHITE);
    box(FL_UP_BOX);
    new Symb_Couleur(x+ESPC,y+2*ESPC,'P');
    Fl_Output* piques=new Fl_Output(x+CC+ESPC,y+2*ESPC,maff-CC-2*ESPC,CC);
    piques->value(cartes_couleur(liste,J,0).c_str());
    piques->box(FL_NO_BOX);
    new Symb_Couleur(x+ESPC,y+3*ESPC+CC,'C');
    Fl_Output* coeurs=new Fl_Output(x+CC+ESPC,y+3*ESPC+CC,maff-CC-2*ESPC,CC);
    coeurs->value(cartes_couleur(liste,J,1).c_str());
    coeurs->box(FL_NO_BOX);
    new Symb_Couleur(x+ESPC,y+4*ESPC+2*CC,'K');
    Fl_Output* carreaux=new Fl_Output(x+CC+ESPC,y+4*ESPC+2*CC,maff-CC-2*ESPC,CC);
    carreaux->value(cartes_couleur(liste,J,2).c_str());
    carreaux->box(FL_NO_BOX);
    new Symb_Couleur(x+ESPC,y+5*ESPC+3*CC,'T');
    Fl_Output* trefles=new Fl_Output(x+CC+ESPC,y+5*ESPC+3*CC,maff-CC-2*ESPC,CC);
    trefles->value(cartes_couleur(liste,J,3).c_str());
    trefles->box(FL_NO_BOX);
  }



//Les callbacks du menu

//Autres callback
void Boite_Jeu::cb_carte(Fl_Widget* obj,void* pw){
//Ajoute la carte à fixees, liste des 52 cartes de l'as de trèfle au 2 de pique
  //La carte cliquée est dédignée par l'entier sur 8 bits p
  //0 1  pour le joueur (Nord=0)
  //2 3  pour la couleur (Pique=0)
  //4 à 8 pour le rang (As=14)
  // le 7 de coeur en est sera 1+4*1+16*7
  // La carte est envoyée dans le vecteur 4x4 fixées
  Fl_Button* refobj=(Fl_Button*)obj;
  int* p=(int*)pw;
  int joueur = (*p)%4;
  int couleur = ((*p)>>2)%4;
  int rang = *p>>4;
  if (refobj->value()==0){
    //Si la carte est cochée, on la libère
    contr.cfixees[13*(3-couleur)+(14-rang)]='V';
    refobj->value(1);
    refobj->labelcolor(FL_RED);
    refobj->down_color(couleur_main);
  }
  else{
    int no=13*(3-couleur)+(14-rang);
    if (contr.cfixees[no]!='V'){
      char J=contr.cfixees[no];
      ostringstream oss;
      oss<<vl[14-rang]<<" de "<<sacouls[couleur+1]<<" déjà présent en "<<J<<endl;
      fl_alert(oss.str().c_str());
      //fl_choice(oss.str().c_str(),"Non","Oui",0);
      //switch(fl_choice(oss.str().c_str(),"Non","Oui",0)){
      //case 0: return;
      //case 1: ;
	//L'ancienne case est libérée  
    }
    else{
    contr.cfixees[no]=jsymbs[joueur];
    refobj->value(0);
    refobj->labelcolor(FL_DARK_BLUE);
    refobj->color(255);
    }
  }
}

void Fenetre::ajoute_params(int n,const Condition& condition){
 //Ajoute les browsers des params quand on clique sur la condition
  //n est le numéro de la coco
  //le group gparams est vidé puis rempli.
  static int widths[]={14,16,70};
  gcocos->begin();
  int l=condition.params.size();
  //On forme un vecteur pointeurs de boutons et un de sélecteurs
  vector<BoutonSymb*> vpboutons;
  vector<Fl_Select_Browser*> vsb;
  //y ordonnées des  boutons
  int y=ypremcoco+50*n;
  for (int i=0;i<l;i++){
    int nbchoix=condition.choix[i].size();
    vsb.push_back(new Fl_Select_Browser(xgparams+condition.xvsb[i],y+30,condition.l_browsers[i],min(20*nbchoix,140),condition.params[i].c_str()));   
    vsb[i]->column_widths(widths);
    vsb[i]->align(FL_ALIGN_LEFT);
    //On place les lignes du Select_Browser
    //Les choix sont des couples (valeur,étiquette) représentés par la structure v_n
    //Les choix forment un vecteur de v_n membre de la condition
    //condition.choix est le vecteur des différents choix
    for (int j=0;j<nbchoix;j++){
      vsb[i]->add(condition.choix[i][j].nom.c_str());
      Param_Choix* pc=new Param_Choix(i,condition.choix[i][j]);
      vsb[i]->data(j+1,(void*)pc);
    }
    //On initialise la coco à la première valeur de chaque paramètre
    contr.cocos[n].params.push_back(condition.choix[i][0].v);
    //gparams->add(vsb[i]);
    //Le ieme bouton 
    vpboutons.push_back(new BoutonSymb(condition.params[i],xgparams+condition.xvsb[i],y,condition.l_browsers[i],30));
    //On passe en paramètre le n° de coco et le bouton.
    Int_BS* data=new Int_BS(n,vpboutons[i]);
    vsb[i]->callback(cb_param,(void*)data);
    vpboutons[i]->box(FL_ROUND_UP_BOX);
    vpboutons[i]->color(159);
    vsb[i]->hide();
    vpboutons[i]->callback(cb_bjoueur,(void*)vsb[i]);
  }
  gcocos->end();
  //gparams->show();
  redraw();
}

bool verifie_coco(Condouv& coco,int nparam,int v){
  //nparam numéro du paramètre, v choix à examiner
  int r=1;
  int p1 = coco.params[1];
  if (coco.id_condition==0 && nparam==2){
    if ((v==1214 || v==1819) && (p1>13 && p1!=100)){r=0;}
    else if (v==20 && !dans(coco.params[1],20,21)) r=0;//forcing manche
  }
  
  //réponses, nparam=2: réponses, v choix de la réponse
  else if (coco.id_condition==1 && nparam==2){
    int ouv=coco.params[1];
    //if (v==12 && !(ouv==10  || ouv==11)) r=0;
    if (v==13 && ouv >=12) r=0;
    else if (v==14 && ouv !=13) r=0;
    else if (v==20 && !(ouv ==10 || ouv==14)) r=0;
    else if (v==21 && (ouv>14 || ouv<12)){r=0;}
    else if (v==22 && !(ouv==12 || ouv==14)) r=0;//réponse de 2C seulement sur 1C et 1SA
    else if (v==23 && ouv!=13) r=0;
    else if (v==24 && ouv>11) r=0;
    else if (v==30 && ouv!=24) r=0;
    else if (v==33 && ouv!=14) r=0;
    else if (v==34 && (ouv==12 ||ouv==13)) r=0;
    else if (v==43 && ouv != 13) r=0;
  }
  //interventions
  else if (coco.id_condition==2 && nparam==1){
    // ici v==sur
    int par=coco.params[0];
    if (par==8 && !(v>=10 && v<=13)) r=0;
    else if (v==13 && par>30) r=0;
    else if (par!=0 && par<=v && par>9){
      fl_alert("Intervention impossible");
      r=0;
    }
    // intervention sur barrage
    else if (v>=30 && par!=8) r=0;
  }

  //Points
  else if (coco.id_condition==2 && nparam==0){
    if (v==1 && !(coco.params[1]<3 && coco.params[2]==4)) r=0;
  }

  if (r==0){
      fl_alert("Condition impossible ou non encore installée");
      return 0;
  }
  else return 1;
}


void Fenetre::cb_param(Fl_Widget* sb,void* data){
  //callback de select param
  Fl_Select_Browser* fbs=(Fl_Select_Browser*)sb;
  //pc est un pointeur sur la structure des données (int param,v_n choix,int v=v_n.v) 
  Param_Choix* pc=(Param_Choix*)fbs->data(fbs->value());
  //On remplit la coco
  int nparam=pc->param;
  v_n choix=pc->choix;
  //On cache le browser
  fbs->hide();
  //On récupère le data (int,bouton,groupe)
  Int_BS* dv=(Int_BS*)data;
  int n = dv->no_coco;
  if (verifie_coco(contr.cocos[n],nparam,choix.v)){
    contr.cocos[n].params[nparam]=choix.v;
  }
  else{return;}
  //Le choix est placé dans le bouton
  BoutonSymb* b=dv->pbs;
  string vs=choix.nombrut;
  b->ch=vs;
}


Centre::Centre(int x,int y,int w,int no):Fl_Box(x,y,w,w){
    Fl_Box* bnn=new Fl_Box(x+w/3,y,w/3,w/3);
    bnn->box(FL_FLAT_BOX);
    if (donneur(0,no)) {
      bnn->label("D");
      bnn->labelcolor(FL_WHITE);}
    else bnn->label("N");
    if (vul(0,no)) bnn->color(FL_RED);
    else bnn->color(FL_GREEN);
    Fl_Box* bno=new Fl_Box(x,y+w/3,w/3,w/3);
    bno->box(FL_FLAT_BOX);
    if (donneur(3,no)) {
      bno->label("D");
      bno->labelcolor(FL_WHITE);}
    else bno->label("O");
    if (vul(3,no)) bno->color(FL_RED);
    else bno->color(FL_GREEN);
    //Le numéro
    char cn[5];
    sprintf(cn," %d ",no);
    double l=fl_width(cn);
    Fl_Output* ono=new Fl_Output(bnn->x()+(bno->w()-l)/2,bno->y(),l,bno->h());
    ono->box(FL_NO_BOX);
    ono->value(cn);
    //Est
    Fl_Box* bne=new Fl_Box(x+2*w/3,y+w/3,w/3,w/3);
    bne->box(FL_FLAT_BOX);
    if (donneur(1,no)) {
      bne->label("D");
      bne->labelcolor(FL_WHITE);}
    else bne->label("E");
    if (vul(1,no)) bne->color(FL_RED);
    else bne->color(FL_GREEN);
    Fl_Box* bns=new Fl_Box(x+w/3,y+2*w/3,w/3,w/3);
    bns->box(FL_FLAT_BOX);
    if (donneur(2,no)) {
      bns->label("D");
      bns->labelcolor(FL_WHITE);}
    else bns->label("S");
    if (vul(2,no)) bns->color(FL_RED);
    else bns->color(FL_GREEN);
}

void Fenetre::montre_params(Condouv& coco,int n,Fl_Group* gparams){
  gparams->clear();
  //n est l'indice de coco dans contr.cocos
  Condition condition=conditions[coco.id_condition];
  int l=condition.params.size();
  int y=gparams->y();
  static int widths[]={14,16,70};
  gparams->begin();
  //Les boutons
  vector<BoutonSymb*> vpboutons;
  //Les select
  vector<Fl_Select_Browser*> vsb;
  for (int i=0;i<l;i++){
    int nbchoix=condition.choix[i].size();
    vsb.push_back(new Fl_Select_Browser(gparams->x()+condition.xvsb[i],y+30,condition.l_browsers[i],min(20*nbchoix,160),condition.params[i].c_str()));   
    vsb[i]->column_widths(widths);
    vsb[i]->align(FL_ALIGN_LEFT);
    for (int j=0;j<nbchoix;j++){
      vsb[i]->add(condition.choix[i][j].nom.c_str());
      Param_Choix* pc=new Param_Choix(i,condition.choix[i][j]);
      vsb[i]->data(j+1,(void*)pc);
    }
    //Le ieme bouton 
    int v=contr.cocos[n].params[i];//valeur du i-eme choix
    string nombrut = conditions[contr.cocos[n].id_condition].nombrutchoix(i,v);
    vpboutons.push_back(new BoutonSymb(nombrut,gparams->x()+condition.xvsb[i],y,condition.l_browsers[i],30));
    //On passe en paramètre le n° de coco et le bouton.
    Int_BS* data=new Int_BS(n,vpboutons[i]);
    vsb[i]->callback(cb_param,(void*)data);
    //vpboutons[i]->box(FL_ROUND_UP_BOX);
    //vpboutons[i]->color(159);
    gparams->add(vpboutons[i]);
    vsb[i]->hide();
    vpboutons[i]->callback(cb_bjoueur,(void*)vsb[i]);
  }
  gparams->end();
  gparams->show(); 
}

//Callback pour Input, affectant la valeur à un entier
void cb_nbdonnes(Fl_Widget* w,void* data){
  Fl_Int_Input* ip=(Fl_Int_Input*)w;
  int* pi=(int*)data;
  *pi=atoi(ip->value());
  //cout<<"nb_d"<<nb_d<<endl;
}

void cb_checkdds(Fl_Widget* w,void*){
  Fl_Check_Button* chb=(Fl_Check_Button*)w;
  odds=chb->value();
}

void cb_nomserie(Fl_Widget* w,void*){
  Fl_Input* ins=(Fl_Input*)w;
  serie.nom=ins->value();
}


void options(){
  //constantes dans la partie CONFIGURATION ligne 81
  Fl_Window* woptions=new Fl_Window(50,100,largeur,hauteur,"Options");
  woptions->color(coulformext);
  woptions->begin();
  //Le titre
  Fl_Box* btitre=new Fl_Box(0,0,largeur,htitre,"Options générateur");
  btitre->labelsize(18);
  btitre->labelcolor(246);

  //La boîte des options
  Fl_Box* bcont=new Fl_Box(bord,bord+htitre,largeur-2*bord,hauteur-htitre-2*bord);
  bcont->color(coulformint);
  bcont->box(FL_FLAT_BOX);
  //Option nom de la série
  Fl_Input* inom=new Fl_Input(bord+fl_width("Nom de la série : ")+dx,bcont->y()+ESPD,200,25,"Nom de la série : ");
  inom->value(serie.nom.c_str());
  inom->callback(cb_nomserie);
  //Option nombre de donnes
  int* pi;
  pi=&nb_d;
  const char* l="Nombre de donnes : ";
  Fl_Int_Input* bnbdonnes=new Fl_Int_Input(bord+fl_width(l)+dx,inom->y()+25+ESPD,30,25,l);
  bnbdonnes->value(to_string(nb_d).c_str());
  bnbdonnes->callback(cb_nbdonnes,(void*)pi);
  //Option limite
  Fl_Int_Input* blimite=new Fl_Int_Input(bord+ESPD+59,bnbdonnes->y()+25+ESPD,30,25,"Limite : ");
  blimite->value(to_string(limite).c_str());
  pi=&limite;
  blimite->callback(cb_nbdonnes,(void*)pi);
  Fl_Box* bl=new Fl_Box(blimite->x()+65,blimite->y(),320,25,"Le nombre maximum de donnes créées est 2^limite.");
  bl->labelfont(FL_HELVETICA_ITALIC);
  //DDS
  Fl_Check_Button* checkdds=new Fl_Check_Button(bord+ESPD+3,blimite->y()+25+ESPD,100,25," Tableau DDS");
  checkdds->value(odds);
  checkdds->callback(cb_checkdds);
  
  woptions->end();
  woptions->show();
}

void cb_options(Fl_Widget*,void*){
  options();
}

