#include "fenetre.h"
#include "stat.h"
#include <math.h>

BoiteCadre* bmains=0;
Fl_Output* oldec=0;
Fl_Output* oldef=0;
Fl_Output* otirages=0;
Fl_Output* otemps=0;

const int dy=28;

Deja dpap;

struct Rpap{
  int no;
  double pourc;
};

vector<int> rpap;
vector<float> vesp;

int n,t;

vector<Carte*> vcartes;
vector<BoutonCarte*> vboutonscartes;

void Fenetre::cb_formpasapas(Fl_Widget*,void* pw){
  Fenetre* win=(Fenetre*)pw;
  //On vérifie que les 4 jeux sont définis
  if (dpap.noc==0 && strchr(contr.cfixees,'V')!=NULL){
    fl_alert("Pas a pas exige les 4 jeux complets"); 
    win->changer_contraintes();}
  else{
    win->detruit_widgets();
    if (win->gpasapas) win->gpasapas->show();
    else win->formpasapas();
  }
}

void cb_nivpap(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  dpap.niveau=b->value()-1;
  Fl_Button* bouton=(Fl_Button*)data;
  bouton->label(num[dpap.niveau]);
  b->hide();
}

void cb_coupap(Fl_Widget* brow, void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  int n=b->value();
  //cout<<"n "<<n<<endl;
  Fl_Button* bou=(Fl_Button*)bouton;
  b->hide();
  bou->label(sacouls[n-1]);
  dpap.couleur=(n+3)%5;
}

void cb_joupap(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int jou=((b->value()-1)+2)%4;
  dpap.declarant=jou;
  b->hide();
  Fl_Button* bou=(Fl_Button*)data;
  bou->label(nomjoueur[jou].c_str());
}

void cb_initialise(Fl_Widget*,void* w){
  Fenetre* win=(Fenetre*)w;
  Fl::delete_widget(win->gpasapas);
  win->gpasapas=nullptr;
  dpap=Deja();
  win->choisir_contr();
}


void cb_entamer(Fl_Widget*,void* w){
  Fenetre* win=(Fenetre*)w;
  /*if (dpap.noc>0){
    for (int i=0;i<52;i++) contr.cfixees[i]=dpap.fixees[i];
    dpap.ini_entame();
    vcartes.clear();
    vboutonscartes.clear();
    win->formpasapas();
    //return;
    }*/
  dpap.noc++;
  res_pap();
  win->formpasapas();
}

void cb_suivante(Fl_Widget* w,void* data){
  //Fenetre* win=(Fenetre*)w;
  WinNG* iw=(WinNG*)data;
  Fenetre* win=iw->fenetre;
  int no=iw->n;
  iw->groupe->clear();
  Fl::delete_widget(iw->groupe);
  iw->groupe=nullptr;
  //On ajoute la carte aux déjà jouées
  dpap.ajoute_dj(no);
  dpap.noc++;
  res_pap(no);
  win->formpasapas();
}

void Fenetre::formpasapas(){
  env.pasapas=true;
  int hresultats=3*HMAIN+90;
  begin();
  if (dpap.noc==0){
    detruit_widgets();
    //Les contraintes sont sauvegardées et copiées comme «contraintes/pasapas»
    const char* charnom="contraintes/pasapas";
    enregistre_contr(charnom);
    contr.nom=charnom;
    //for (int i=0;i<52;i++) dpap.fixees[i]=contr.cfixees[i];
    //listetoremain(dpap.fixees,dpap.jeux_ini);
    gpasapas=new Fl_Group(0,40,x_max(),y_max()-10);
    gpasapas->begin();
    color(fl_rgb_color(190,231,239));
    //Le titre
    new Titrepage("Analyse pas à pas",50,100,350);
    vector<int> ml = maxlongs(dpap.jeux_ini);
    vector<int> wjeux(3);
    wjeux[0]=max(max(ml[0],ml[2])*WC+30,80);//largeur jeux NS
    wjeux[1]=ml[3]*WC+30;//largeur jeu ouest
    wjeux[2]=ml[1]*WC+30;//largeur jeu Est
    //Le cadre des mains bmains
    bmains=new BoiteCadre(xpap+wpap/4,YBDONNE,wjeux[0]+wjeux[1]+wjeux[2],hresultats);
    //Le cadre des levées
    new BoiteCadre(bmains->x(),YBDONNE+bmains->h()-30,bmains->w(),30);
    oldec=new Fl_Output(bmains->x()+fl_width(" Déclarant : "),YBDONNE+bmains->h()-28,25,25,"Déclarant :");
    oldec->box(FL_NO_BOX);
    oldef=new Fl_Output(bmains->x()+(bmains->w())/2+fl_width(" Défense : "),oldec->y(),25,25,"Défense :");
    oldef->box(FL_NO_BOX);
    //La donne. Chaque carte a un bouton associée dont on fixe à chaque étape la couleur et le callback. 
    vector<int> xs={wjeux[1],wjeux[1]+wjeux[0],wjeux[1],0};
    vector<int> ys={2,HMAIN-1,2*HMAIN+2,HMAIN-1};
    int xouest=bmains->x()+BORD;
    int youest=bmains->y()+HMAIN+BORD+3;
    int xnord=xouest+wjeux[1];
    int ynord=bmains->y()+2*ESPC+BORD;
    int xest=xnord+wjeux[0];
    int ysud=youest+HMAIN+3;
    //On place les symboles de couleur
    for (int c=0;c<4;c++){
      new Symb_couleur(xnord,ynord+c*dy,c);
      new Symb_couleur(xouest,youest+c*dy,c);
      new Symb_couleur(xest,youest+c*dy,c);
      new Symb_couleur(xnord,ysud+c*dy,c);
    }
    //On place les cartes
    for (int i=0;i<52;i++){
      vcartes.push_back(new Carte(i,dpap.fixees[i]));
      int couleur=vcartes[i]->couleur;
      int joueur=vcartes[i]->joueur();
      //Nombre de bits de rang plus élevé 
      vcartes[i]->rangcoul=comptebit(dpap.jeux_ini[joueur][couleur],14,vcartes[i]->rang);
      vcartes[i]->x=xs[joueur]+WC*vcartes[i]->rangcoul;
      vcartes[i]->y=ys[joueur]+couleur*dy;
      vboutonscartes.push_back(new BoutonCarte(vcartes[i],bmains->x()+ESPC,bmains->y()+2*ESPC));
    }
  }
  else{
    gpasapas->begin();
    int xresultats=bmains->x()+bmains->w()+ESPD;
    int bcjy=YBDONNE+40;
    int bcjw=80;
    if (dpap.noc==1){
      //La Boîte des résultats
      BoiteCadre* bresultats=new BoiteCadre(xresultats,YBDONNE,WRESULTATS,hresultats);
      BoiteCadre* btitreresultats=new BoiteCadre(xresultats,YBDONNE,WRESULTATS,40,"Résultats");
      btitreresultats->labelsize(20);
      //Le tableau des résultats
      BoiteCadre* bcj=new BoiteCadre(xresultats,YBDONNE+40,80,hresultats-100);
      //bcj->color(FL_RED);
      BoiteCadre* bcp=new BoiteCadre(xresultats+bcj->w(),bcj->y(),bresultats->w()-bcj->w(),bcj->h());
      otirages=new Fl_Output(bresultats->x()+ESPD,bresultats->y()+bresultats->h()-55,bresultats->w()-2*ESPD,25);
      otirages->box(FL_NO_BOX);
      otemps=new Fl_Output(bresultats->x()+ESPD,bresultats->y()+bresultats->h()-30,bresultats->w()-2*ESPD,25);
      otemps->box(FL_NO_BOX);
    }
    else{//Les cartes sont mises à la couleur voulue
      for (int i=0;i<52;i++) vboutonscartes[i]->labelcolor(FL_GRAY0);
      for (int i=0;i<dpap.nosdj.size();i++) vboutonscartes[dpap.nosdj[i]]->labelcolor(25);      
    }
    if (dpap.noc%4==1){
      oldec->value(to_string(dpap.leveesdec).c_str());
      oldef->value(to_string(dpap.leveesdef).c_str());}
    int l=rpap.size();
    //Groupe des résultats
    Fl_Group* gres=new Fl_Group(xresultats,bcjy,WRESULTATS,hresultats);
    gres->begin();
    for (int i=0;i<l;i++){
      int no=rpap[i];
      //La carte est mise en bleu
      vboutonscartes[no]->labelcolor(FL_BLUE);
      //On attache un callback aux cartes jouables
      WinNG* data=new WinNG(this,no,gres);
      vboutonscartes[no]->callback(cb_suivante,(void*)data);
      int h=29;
      new BoiteCarte(no,xresultats,bcjy+i*h,bcjw,h);
      char cp[20];
      if (dpap.niveau>0){
	sprintf(cp,"%10.1f %%",vesp[i]*100);
      }
      else{
	sprintf(cp,"%10.2f",vesp[i]);
      }
      Fl_Output* bp=new Fl_Output(xresultats+bcjw,bcjy+i*h+11,WRESULTATS-bcjw,h);
      bp->textsize(18);
      bp->textcolor(FL_DARK_BLUE);
      bp->value(cp);
      bp->box(FL_NO_BOX);
    }
    int minutes=t/60;
    int secondes=t%60;
    //On remplit la boîte des tirages
    ostringstream osss;
    osss<<n<<" tirages, "<<nbstat<<" donnes ";
    otirages->value(osss.str().c_str()); 
    osss.str("");
    osss<<"analysées en "<<minutes<<"'"<<secondes<<"''";
    otemps->value(osss.str().c_str()); 
    gres->end();
    gpasapas->add(gres);
  }
  //Boîte Formulaire
  BoiteForm* bff=new BoiteForm(550,200,"Formulaire",xpap,wpap);
  BoiteChamp* bc=new BoiteChamp(bff->x()+ESPD,bff->y()+2*ESPD,bff->w()-2*ESPD,35,"Choix des contraintes");
  const char* comm="Modifiez les contraintes («contraintes/pasapas») au fur et à mesure du déroulement de la donne.";
  Fl_Box* bcomm=new Fl_Box(bc->x()+ESPC,bc->y()+2*ESPC,bc->w()-2*ESPC,bc->h()-2*ESPC,comm);
  //Les paramètres
  BoiteChamp* bc2=new BoiteChamp(bc->x(),bc->y()+bc->h()+4*ESPD+50,bc->w(),40,"Paramètres");
  intparametres(bc2->y());//fixe nbstat et limite
  //Le contrat
  BoiteChamp* bc1=new BoiteChamp(bc->x(),bc->y()+bc->h()+2*ESPD,bc->w(),50,"Contrat");
  BoutonChoix* bniv=new BoutonChoix(bc1->x()+2*ESPD,bc1->y()+2*ESPD,50,25,num[dpap.niveau]);
  SelectNombre* sniv=new SelectNombre(bniv->x(),bniv->y()+bniv->h(),bniv->w(),135,7);
  bniv->callback(cb_bjoueur,(void*)sniv);
  sniv->callback(cb_nivpap,(void*)bniv);
  //if (dpap.noc==0)
  BoutonChoix* bcou=new BoutonChoix(bniv->x()+bniv->w()+ESPD,bniv->y(),80,bniv->h(),sacouls[(dpap.couleur+1)%5]);
  SelectCouleur* scou=new SelectCouleur(bcou->x(),bcou->y()+bcou->h(),bcou->w(),100);
  bcou->callback(cb_bjoueur,(void*)scou);
  scou->callback(cb_coupap,(void*)bcou);
  BoiteTexte2* bpar=new BoiteTexte2(bcou->x()+bcou->w()+ESPD,bcou->y()," par ");
  BoutonChoix* bjou=new BoutonChoix(bpar->x()+bpar->w()+ESPD,bcou->y(),80,25,"Sud");
  SelectJoueur* sjou=new SelectJoueur(bjou->x(),bjou->y()+bjou->h(),bjou->w(),100);
  bjou->callback(cb_bjoueur,(void*)sjou);
  sjou->callback(cb_joupap,(void*)bjou);
  //Le bouton entamer
  Fl_Button* bentamer=new Fl_Button(bc->x()+550,bniv->y()-5,70,30,"Évaluer");
  bentamer->callback(cb_entamer,(void*)this);
  //Le bouton initialise
  Fl_Button* binitialise=new Fl_Button(bc->x()+700,bniv->y()-5,70,30,"Initialiser");
  binitialise->callback(cb_initialise,(void*)this);
  gpasapas->end();
  end();
  gpasapas->show();
}

void res_pap(int no){
  time_t tbegin,tend;
  rpap.clear();
  tbegin=time(NULL);
  //noc désigne le nombre de cartes jouées celle-ci comprise.
  int mort=(dpap.declarant+2)%4;
  char symbmort="NESO"[mort];
  if (dpap.noc==1){
    //Entame
    //for (int i=0;i<52;i++) dpap.fixees[i]=contr.cfixees[i];
    dpap.premier=(dpap.declarant+1)%4;
    dpap.joueur=dpap.premier;
    dpap.dernier=dpap.joueur;
  }
  if (dpap.noc>1){
    int ordre=(dpap.noc-2)%4; //rang de la carte jouée dans la levée
    Carte carte(no,dpap.fixees[no]);
    if (ordre<3){
      dpap.joueur=(dpap.premier+ordre+1)%4;
      dpap.ctcouleurs[ordre]=carte.couleur;
      dpap.ctranks[ordre]=carte.rang;
    }
    else{
      int couleurs[4];
      int rangs[4];
      for (int i=0;i<3;i++){
	couleurs[i]=dpap.ctcouleurs[i];
	rangs[i]=dpap.ctranks[i];
      }
      couleurs[3]=carte.couleur;
      rangs[3]=carte.rang;
      int v=vainqueur(couleurs,rangs,dpap.couleur);
      dpap.premier=(dpap.premier+v)%4;
      dpap.joueur=dpap.premier;
      for (int i=0;i<3;i++){
	dpap.ctcouleurs[i]=0;
	dpap.ctranks[i]=0;
      }
      if (dpap.joueur%2==dpap.declarant%2) dpap.leveesdec++;
      else dpap.leveesdef++;
      dpap.dernier=dpap.joueur;
    }
  }
  char symbjoueur="NESO"[dpap.joueur];
  char symbdeclarant="NESO"[dpap.declarant];
  //liste pour les numéros utiles
  char liste[52];
  for (int i=0;i<52;i++){
    contr.cfixees[i]=dpap.fixees[i];
    if (dpap.joueur!=mort){
      if (contr.cfixees[i]!=symbjoueur && (dpap.noc==1 || contr.cfixees[i]!=symbmort)) contr.cfixees[i]='V';}
    else {
      if (contr.cfixees[i]!=symbjoueur && contr.cfixees[i]!=symbdeclarant) contr.cfixees[i]='V';
    }
    liste[i]=dpap.fixees[i];
  }
  //On enlève les cartes déjà jouées
  for (int i=0;i<dpap.nosdj.size();i++){
    contr.cfixees[dpap.nosdj[i]]=dpap.fixees[dpap.nosdj[i]];
    liste[dpap.nosdj[i]]='V';
  }
  n=stat(dpap);
  if (n>=1<<limite){ fl_alert("limite dépassée"); return;}
  //Les cartes jouables et les réponses associées. On enlève les cartes déjà jouées
  if (dpap.joueur==dpap.premier){
    rpap=numeros_utiles(liste,"NESO"[dpap.joueur]);}
  else rpap=numeros_jouables(liste,"NESO"[dpap.joueur],dpap.ctcouleurs[0]);
  //On forme les vecteurs de résultats triés
  vesp.clear();
  for (int i=0;i<rpap.size();i++){
    if (dpap.niveau==0){
      int total=0;
      for (int n=1;n<13;n++) total += n*tabstat[rpap[i]][n];
      float esp=(float)total/nbstat;
      if ((dpap.joueur+dpap.declarant)%2) esp+=dpap.leveesdef;
      else esp +=dpap.leveesdec;
      vesp.push_back(esp);
    }
    else{
      vesp.push_back(nbchutes[rpap[i]]/(float)nbstat);
    }
  }
  tri(rpap,vesp);
  tend=time(NULL);
  t=(int)difftime(tend,tbegin);
}
