#include <vector>
#include <iostream>
#include "condouv.h"
using namespace std;

int score_levee(int couleur){
  // pique 0
  int sl;
  if (couleur==2 || couleur==3) sl=20;
  else sl=30;
  return sl;
}

//couleur dds (0 pique) et contrat generateur (10 1 trèfle à 74 7SA)
int contrat(int levees,int couleur){
  if (levees < 7) return 0;
  if (couleur < 4) couleur = 3-couleur;
  return 10*(levees-6)+couleur;
}

int score(int niv,int couleur,bool vul,int contre){
  //score du contrat juste fait
  //couleur pique=0
  int bonus,score=0;
  int co=4;//trefle 0
  if (couleur <4) co=3-couleur;
  int contrat=10*niv+co;
  if (contrat>=10){
    if (co<2) score=20*niv;
    else score=30*niv;
    if (co==4) score+=10;
    if (contre>0) score *=1<<contre;
    if (niv==7){
      if (vul) bonus=2000;
      else bonus=1300;
    }
    else if (niv==6){
      if (vul) bonus=1250;
      else bonus=800;
    }
    else if (score>=100){
      if (vul) bonus=500;
      else bonus=300;
    }
    else bonus=50;
    score +=bonus;
    score +=50*contre;
  }
  return score;
}

int score(int contr,int vul,int contre){
  int couleur=contr%10;
  if (couleur<4) couleur=3-couleur;
  return score(contr/10,couleur,vul,contre);
}

int penalite(int chute,bool vul,int contre){
  int p=0;
  if (contre==0) p=50*(1+vul)*chute;
  else{
    if (vul==0){
      if (chute==1) p=100;
      else if (chute==2) p=300;
      else if (chute==3) p=500;
      else p=chute*300-400;
    }
    else p=chute*300-100;
    if (contre==2) p*=2;
  }
  return p;
}


int fscore(int levees,int niv,int couleur,bool vul,int contre){
  //couleur pique =0
  //int co=3-couleur;
  int n=levees-6;
  int sco;
  int mieux;
  if (n>=niv){
    sco=score(niv,couleur,vul,contre);
    if (n>niv){
      int lm=n-niv;
      int vl=score_levee(couleur);
      if (contre==0) mieux=lm*vl;
      else mieux=lm*50*(1<<contre)*(1+vul);
      sco+=mieux;
    }
  }
  else{
    int chute=niv-n;
    sco=-penalite(chute,vul,contre);
  }
  return sco;
}



double esperance(vector<double>& probas,int niv,int co,bool vul,int contre){
  double sum=0;
  for (int i=0;i<14;i++){
    sum+=probas[i]*fscore(i,niv,co,vul,contre);
  }
  return sum;
}

// Remplit une liste resupar de 3 entiers: contrat,joueur,score
int par(int tabddt[5][4],int no,structpar& resupar){
  //const int couldds[5] = {4,0,1,2,3};
  //int co;
  int j,G,delta;
  int s,contr;
  int i;
  struct structpar maxcontrat;
  struct structpar maxscore;
  struct structpar sacrifice;
  int oppcontrat=0;//21.8.4
  int oppjoueur=0;
  maxscore.score = 0;
  struct structpar maxNS;
  maxNS.contrat = 0;
  maxNS.joueur = 0;
  maxNS.score = 0;
  struct structpar maxEO;
  maxEO.contrat = 0;
  maxEO.joueur = 1;
  maxEO.score = 0;
  //Calcul du plus grand contrat dans chaque ligne
  //et du plus gros score
  for (i=0;i<5;i++){
    //co = couldds[i]; 
    for (j=0;j<4;j++){
      contr = contrat(tabddt[i][j],i);
      //cout<<contr<<endl;//OK
      s = score(contr,vul(j,no),0);
      //cout<<s<<endl;
      if (j%2 == 0){
	if (contr > maxNS.contrat){ 
	  maxNS.contrat=contr;
	  maxNS.joueur=j;
	  maxNS.score = s;
	};}
      else
	if (contr > maxEO.contrat){ 
	  maxEO.contrat=contr;
	  maxEO.joueur=j;
	  maxEO.score = s;
	}
      // On note le plus grand score
      if (s>maxscore.score){
	maxscore.score = s;
	maxscore.joueur = j;
	maxscore.contrat = contr;
      }
    }
  }
  //cout<<maxscore.score<<endl;
  // On regarde dans quelle ligne le plus grand contrat est atteint
  if (maxNS.contrat > maxEO.contrat) {
    maxcontrat.contrat = maxNS.contrat;
    maxcontrat.joueur = maxNS.joueur;
    maxcontrat.score = maxNS.score;
  }
  else {
    maxcontrat.contrat = maxEO.contrat;
    maxcontrat.joueur = maxEO.joueur;
    maxcontrat.score = maxEO.score;
  }
  //cout<<"maxcontrat "<<maxcontrat.contrat<<endl;
  // G est le camp du plus gros score (0 pour NS, 1 pour EO)
  G = maxscore.joueur%2;
  // Si le meilleur contrat du camp opposé est plus grand que maxscore.contrat:
  if ((G && maxNS.contrat > maxscore.contrat) || (!G && maxEO.contrat > maxscore.contrat)){
      resupar.contrat = maxcontrat.contrat;
      resupar.joueur = maxcontrat.joueur;
      resupar.score = maxcontrat.score;
  }
  else{
  resupar.contrat = maxscore.contrat;
  resupar.joueur = maxscore.joueur;
  resupar.score = maxscore.score;
  }
  //cout<<"maxcontrat "<<maxcontrat.contrat<<endl;
  // On envisage une défense
  G = resupar.joueur%2;
  // meilleur contrat du camp opposé
  if (G) {
    oppcontrat = maxNS.contrat;
    oppjoueur = maxNS.joueur;
  }
  else {
    oppcontrat = maxEO.contrat;
    oppjoueur = maxEO.joueur;
  }
  //On compare le sacrifice au plus grand contrat
  delta = (maxcontrat.contrat - oppcontrat)/10 + 1; // modifié 16.2.0
  sacrifice.score = penalite(delta,vul(!G,no),1);
  //////////cout << sacrifice.score << endl;
  sacrifice.joueur = oppjoueur;
  sacrifice.contrat = oppcontrat + 10*delta;
  if (sacrifice.contrat < 80 && sacrifice.score < maxcontrat.score){
    resupar.score = sacrifice.score;
    resupar.joueur = sacrifice.joueur;
    resupar.contrat = sacrifice.contrat+5;
  }
  //On compare le sacrifice au resupar (21.8.4)
  else {
    delta =  (resupar.contrat - oppcontrat)/10 + 1;
    sacrifice.score = penalite(delta,vul(!G,no),1);
    sacrifice.contrat = oppcontrat + 10*delta;
    if (sacrifice.contrat < 80 && sacrifice.score < resupar.score){
         //correction bug 21.12.6
      if (sacrifice.score > maxcontrat.score){
	resupar.score = sacrifice.score;
	resupar.joueur = sacrifice.joueur;
	resupar.contrat = sacrifice.contrat;
	  }
      else{
        resupar.score = maxcontrat.score;
        resupar.joueur = maxcontrat.joueur;
        resupar.contrat = maxcontrat.contrat;
      }
    }
  }
  if (G)
    resupar.score = -resupar.score;
  return 1;
}
