#include <cmath>
#include "fenetre.h"
#include "dll.h"
#include "tableaux.h"
#include "stat.h"

#if defined (_OPENMP)
#include <omp.h>
#endif

//200 comparaison des contrats
//743 page levées/espérance (stats_levees)
//813 res_levees
//Entames (cb_entames,entames())
//1103 entames(): formulaire
//1392 entames résultats
//1453 affichage comparaison directe entames

int limite=29;

int espcoul(int c){
  if (c<4) return 10;
  else return 18;
}
  
string s="NESO";
//const string cartes("0123456789XVDRA");

const int wbcouleur = 70;
int ycomparaison;

/*struct DonneesStat{
  int target;
  int atout;
  int first;
  int contre;
  DonneesStat(){};
  DonneesStat(int niveau,int couleur,int declarant,int contr):
    target(8-niveau),atout(couleur),first((declarant+1)%4),contre(contr){}
};
*/


//Variables glogales pour comparer
int nb_contrats=2;
vector<DonneesStat> vcontrats(nb_contrats);
vector<int> comp_niveau(nb_contrats,3);
vector<int> comp_couleur(nb_contrats,4);
vector<int> comp_declarant(nb_contrats,2);
vector<int> comp_contre(nb_contrats,0);
uintptr_t comparaison=0;
vector<double> rep(nb_contrats);

//Variables globales pour stat_levees
vector<bool> couleurs(5,0);
vector<int> declarants(5,2);
vector<bool> contres(5,0);
int nbstat=100;

//Variables globales pour entames (stat.h)
Deja deja;

int tabstat[52][14];
int nbchutes[52];

//compentames
int nos[2];

int retrovl(char C){
  switch(C){
  case 'A':return 14;
  case 'R':return 13;
  case 'D':return 12;
  case'V':return 11;
  case 'X':return 10;
  case '9':return 9;
  case '8':return 8;
  case '7':return 7;
  case '6':return 6;
  case '5':return 5;
  case '4':return 4;
  case '3':return 3;
  case '2':return 2;
  case '0':return 0;
  }
}


void cb_inbdonnes(Fl_Widget* w,void*){
  Fl_Int_Input* iv=(Fl_Int_Input*)w;
  const char* i=iv->value();
  nbstat=atoi(i);
}

void cb_limite(Fl_Widget* w,void*){
  Fl_Int_Input* iv=(Fl_Int_Input*)w;
  const char* i=iv->value();
  limite=atoi(i);
}


//Boite pour nombre de tirages et limite
//Prototypes pour intparametres et parametres dans fenetre.h 448
void intparametres(int Y,int X,int W){
  //BoiteForm* params=new BoiteForm(Y,50);
  int d=80;
  Fl_Int_Input* inbdonnes=new Fl_Int_Input(xbcontrats+150-2*d/3,Y+ESPD,50,25,"Nombre de donnes : ");
  inbdonnes->value(to_string(nbstat).c_str());
  inbdonnes->callback(cb_inbdonnes);
  //limite
  Fl_Int_Input* inblimite=new Fl_Int_Input(xbcontrats+280-2*d/3,Y+ESPD,30,25,"Limite : ");
  inblimite->value(to_string(limite).c_str());
  inblimite->callback(cb_limite);
  Fl_Box* blimite = new Fl_Box(xbcontrats+500-2*d/3,Y+ESPD,50,25,"entre 0 et 26; le nombre maximal de donnes créées est 2^limite.");
  blimite->labelfont(FL_HELVETICA_ITALIC);
}

void parametres(int Y,int X,int W){
  BoiteForm* params=new BoiteForm(Y,50,0L,X,W);
  intparametres(Y,X,W);
}


void cb_nbcontrats(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int n=b->value();
  WinBout* wb=(WinBout*)data;
  Fl_Button* bouton=wb->bout;
  bouton->label(num[n]);
  b->hide();
  nb_contrats=n;
  Fenetre* win=wb->win;
  Fl::delete_widget(win->gcompare);
  win->gcompare=nullptr;
  win->input_contr=nullptr;
  vcontrats.resize(n);
  comp_niveau.resize(n);
  comp_couleur.resize(n);
  comp_contre.resize(n);
  comp_declarant.resize(n);
  win->comparer();  
}

void cb_comp(Fl_Widget* w,void* data){
  Fl_Round_Button* rb=(Fl_Round_Button*)w;
  comparaison=(uintptr_t)data;
}

void cb_comp_niveau(Fl_Widget* w,void* data){
   Fl_Select_Browser* b=(Fl_Select_Browser*)w;
   b->hide();
   int niv=b->value();
   IntBouton* ib=(IntBouton*)data;
   comp_niveau[ib->entier]=niv;
   ib->bouton->label(num[niv]);
}

void cb_comp_cou(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  b->hide();
  int n=b->value();
  IntBouton* ib=(IntBouton*)data;
  comp_couleur[ib->entier]=(n+3)%5;
  ib->bouton->label(sacouls[n-1]);
}

void cb_comp_contre(Fl_Widget* w, void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  b->hide();
  int n=b->value();
  IntBouton* ib=(IntBouton*)data;
  comp_contre[ib->entier]=n-1;
  ib->bouton->label(b->text(n));
}

void cb_comp_jou(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int joueur=((b->value()-1)+2)%4;
  IntBouton* ib=(IntBouton*)data;
  comp_declarant[ib->entier]=joueur;
  b->hide();
  ib->bouton->label(nomjoueur[joueur].c_str());
}

void cb_calcomp(Fl_Widget*,void* data){
  Fenetre* win=(Fenetre*)data;
  win->res_compare();
}

/////////////////////////////////////////////////////////////////////////////////////
/* -------------------------- COMPARAISON DES CONTRATS --------------------------- */
/////////////////////////////////////////////////////////////////////////////////////

void Fenetre::comparer(bool brep, int nb,int t){
  color(fl_rgb_color(190,231,239));
  detruit_widgets();
  int ygcontrats=400;
  int hgcontrats=210+25*nb_contrats;
  if (gcompare==0){
    begin();
    gcompare=new Fl_Group(0,30,x_max(),y_max()-30);
    Titrepage* tcompare=new Titrepage("Comparaison des contrats");
    //Les contraintes
    if (input_contr==0){
      input_contr=new Fl_Output(2*ESPD,yfmains+100,200,30,"Nom des contraintes");
      input_contr->align(FL_ALIGN_TOP);
      input_contr->value(contr.nom.c_str());
      gcompare->add(input_contr);
    }
    //Le groupe des contrats
    int d=80;
    Fl_Group* gcontrats=new Fl_Group(xbcontrats-d,ygcontrats,wbcontrats+d,hgcontrats+110);
    Fl_Box* bgcontrats=new Fl_Box(xbcontrats-d,ygcontrats,wbcontrats+d,hgcontrats,"Contrats");
    bgcontrats->box(FL_UP_BOX);
    bgcontrats->align(FL_ALIGN_LEFT_TOP);
    bgcontrats->labeltype(FL_ENGRAVED_LABEL);
    bgcontrats->labelsize(18);
    bgcontrats->color(coul_fenetre_contr);
    int wnbcontrats=150;
    Fl_Box* nbcontr=new Fl_Box(xbcontrats-d,ygcontrats+ESPD,wnbcontrats,25,"Nombre de contrats ");
    Fl_Button* bnbcontrats=new Fl_Button(xbcontrats-d+wnbcontrats+ESPC,ygcontrats+ESPD,35,25,num[nb_contrats]);
    bnbcontrats->color(FL_WHITE);
    Fl_Select_Browser* snbcontrats=new Fl_Select_Browser(xbcontrats-d+wnbcontrats+ESPC+40+d,ygcontrats+ESPD,35,70);
    for (int i=1;i<5;i++) snbcontrats->add(num[i]);
    snbcontrats->hide();
    bnbcontrats->callback(Fenetre::cb_bjoueur,(void*)snbcontrats);
    WinBout* wb=new WinBout(this,bnbcontrats);
    snbcontrats->callback(cb_nbcontrats,(void*)wb);
    //Bouton calcul
    Fl_Button* bcalcomp=new Fl_Button(xbcontrats+480,ygcontrats+190+25*(nb_contrats-1),70,30,"Calculer");
    bcalcomp->callback(cb_calcomp,(void*)this);
    //Les boutons radios
    Fl_Group* o=new Fl_Group(xbcontrats-d,ygcontrats+55,200,126);
    o->begin();
    vector<Fl_Round_Button*> rb(5);
    for (int i=0;i<5;i++){
      rb[i]=new Fl_Round_Button(xbcontrats+ESPD-2*d/3,ygcontrats+60+25*i,150,25);
      rb[i]->type(FL_RADIO_BUTTON);
    }
    rb[0]->label("pourcentage de réussite de chaque contrat");
    rb[0]->callback(cb_comp,(void*)0);
    rb[1]->label("meilleur contrat (comparaison des scores de contrats dont les déclarants appartiennent au même camp)");
    rb[1]->callback(cb_comp,(void*)1);
    rb[2]->label("comparaison fine de 2 contrats");
    rb[2]->callback(cb_comp,(void*)2);
    rb[3]->label("meilleur contrat strict (comparaison des scores de 2 contrats de déclarants quelconques; les pourcentages sont pour le camp du contrat n°1)");
    rb[3]->callback(cb_comp,(void*)3);
    rb[4]->label("pourcentage de réussite de l'un des contrats");
    rb[4]->callback(cb_comp,(void*)4);
    o->end();
    parametres(ygcontrats+hgcontrats+ESPC,xbcontrats-d,wbcontrats+d);
    //Les contrats
    //const char* scontrats[4]={"Contrat n°1","Contrat n°2","Contrat n°3","Contrat n°4"};
    vector<Fl_Button*> vbniv(nb_contrats);
    vector<Fl_Select_Browser*> vsniv(nb_contrats);
    vector<Fl_Button*> vbcou(nb_contrats);
    vector<Fl_Select_Browser*> vscou(nb_contrats);
    vector<Fl_Button*> vbcontre(nb_contrats);
    vector<Fl_Select_Browser*> vscontre(nb_contrats);
    vector<Fl_Button*> vbjou(nb_contrats);
    vector<Fl_Select_Browser*> vsjou(nb_contrats);
    for (int i=nb_contrats-1;i>=0;i--){
      new Fl_Box(xbcontrats+30,ygcontrats+200+25*i,63,25,"Contrat n°");
      new Fl_Box(xbcontrats+30+63,ygcontrats+200+25*i,10,25,num[i+1]);
      new Fl_Box(xbcontrats+30+63+10,ygcontrats+200+25*i,15,25," : ");
      int xbniv=xbcontrats+30+63+10+10;
      vbniv[i]=new Fl_Button(xbniv,ygcontrats+200+25*i,40,25,num[comp_niveau[i]]);
      vbniv[i]->color(FL_WHITE);
      vsniv[i]=new Fl_Select_Browser(xbniv,ygcontrats+200+25*i+25,40,115); 
      for (int n=1;n<8;n++) vsniv[i]->add(num[n]);
      vsniv[i]->hide();
      vbniv[i]->callback(Fenetre::cb_bjoueur,(void*)vsniv[i]);
      IntBouton* data=new IntBouton(i,vbniv[i]);
      vsniv[i]->callback(cb_comp_niveau,(void*)data);
      //couleur
      int xscou=xbniv+45;
      vbcou[i]=new Fl_Button(xscou,ygcontrats+200+25*i,75,25,sacouls[(comp_couleur[i]+1)%5]);
      vbcou[i]->color(FL_WHITE);
      vscou[i]=new Fl_Select_Browser(xscou,ygcontrats+200+25*i+25,75,90);
      for (int n=0;n<5;n++) vscou[i]->add(sacouls[n]);
      vscou[i]->hide();
      vbcou[i]->callback(Fenetre::cb_bjoueur,(void*)vscou[i]);
      IntBouton* datacou=new IntBouton(i,vbcou[i]);
      vscou[i]->callback(cb_comp_cou,(void*)datacou);
      int xbcontre=xscou+80;
      vbcontre[i]=new Fl_Button(xbcontre,ygcontrats+200+25*i,90,25,"non contré");
      vbcontre[i]->color(FL_WHITE);
      vscontre[i]=new Fl_Select_Browser(xbcontre,ygcontrats+200+25*i+25,90,55);
      vscontre[i]->add("non contré");
      vscontre[i]->add("contré");
      vscontre[i]->hide();
      vbcontre[i]->callback(Fenetre::cb_bjoueur,(void*)vscontre[i]);
      IntBouton* datacontre=new IntBouton(i,vbcontre[i]);
      vscontre[i]->callback(cb_comp_contre,(void*)datacontre);
      //joueur
      Fl_Box* bpar=new Fl_Box(xscou+165,ygcontrats+200+25*i,50,25,"par ");
      int xsjou=xscou+205;
      vbjou[i]=new Fl_Button(xsjou,ygcontrats+200+25*i,largeurSelect,hboutonSelect,joueurs[comp_declarant[i]]);    
      vbjou[i]->color(FL_WHITE);
      vsjou[i]=new Fl_Select_Browser(xsjou,ygcontrats+200+25*i+25,largeurSelect,80);
      for (int j=0;j<4;j++) vsjou[i]->add(joueurs[(j+2)%4]);
      vsjou[i]->hide();
      vbjou[i]->callback(Fenetre::cb_bjoueur,(void*)vsjou[i]);
      IntBouton* datajou=new IntBouton(i,vbjou[i]);
      vsjou[i]->callback(cb_comp_jou,(void*)datajou);
    }
    end();
  }
  else{
    //Les contraintes
    Fl::delete_widget(input_contr);
    input_contr=nullptr;
    gcompare->begin();
    input_contr=new Fl_Output(2*ESPD,yfmains+100,200,30,"Nom des contraintes");
    input_contr->value(contr.nom.c_str());
    input_contr->align(FL_ALIGN_TOP);
    if (brep){
      int nbtemp=nb_contrats;
      int yboiter=150;
      int hboiter=175;
      int htitrer=45;
      int l=50;//Moitié de "2C par nord"
      if (comparaison==2) l=70;
      int fs=18;
      
      BoiteForm* boiter=new BoiteForm(yboiter,hboiter);
      //Le titre
      Fl_Box* titrer=new Fl_Box(xbcontrats,yboiter,wbcontrats,45,"Résultats");
      titrer->box(FL_BORDER_FRAME);
      titrer->labelsize(20);
      titrer->labelcolor(FL_DARK_BLUE);
      int n=rep.size();
      if (comparaison==4){
	n=1;
	//nb_contrats=1;
	nbtemp=1;
      }
      int W=wbcontrats/n;
      int Y=yboiter+htitrer;
      //for (int i=0;i<nb_contrats;i++){
      for (int i=0;i<nbtemp;i++){
	Fl_Box* bc=new Fl_Box(xbcontrats+i*W,Y,W,hboiter-htitrer-25);
	bc->box(FL_BORDER_FRAME);
	if (comparaison <4){
	  int c=comp_couleur[i];
	  int j=comp_declarant[i];
	  const char* nj=joueurs[j];
	  int lj=strlen(nj);
	  Fl_Box* bn=new Fl_Box(xbcontrats+i*W+W/2-l,yboiter+htitrer,fs,30,num[comp_niveau[i]]);
	  bn->labelsize(fs);
	  bn->labelcolor(FL_DARK_BLUE);
	  Fl_Box* bcol=new Fl_Box(xbcontrats+i*W+W/2-l+fs,yboiter+htitrer,espcoul(c),30,scoul[c]);
	  bcol->labelsize(fs);
	  bcol->labelcolor(couls[c]);
	  int xbpar=xbcontrats+i*W+W/2-l+fs+espcoul(c)+ESPD;
	  Fl_Box* bpar=new Fl_Box(xbpar,yboiter+htitrer,30,30,"par");
	  bpar->labelsize(fs);
	  bpar->labelcolor(FL_DARK_BLUE);
	  Fl_Box* bjoue=new Fl_Box(xbpar+30+ESPC,yboiter+htitrer,10*lj,30,nj);
	  bjoue->labelsize(fs);
	  bjoue->labelcolor(FL_DARK_BLUE);
	  if (comparaison==2){
	    Fl_Box* bseul=new Fl_Box(xbpar+30+2*ESPC+10*lj,yboiter+htitrer,40,30,"seul");
	    bseul->labelsize(fs);
	    bseul->labelcolor(FL_DARK_BLUE);
	  }
	}
	//Le pourcentage rep[i]%
	Fl_Output* bres=new Fl_Output(xbcontrats+i*W+W/2-20,yboiter+htitrer/2+hboiter/2-30,40,hboiter/2-htitrer/2);
	bres->value(to_string(rep[i]).c_str());
	bres->textcolor(FL_RED);
	bres->textsize(20);
	bres->box(FL_NO_BOX);
      }
      //Cas de comparaison==2, cellule réussite des deux
      if (comparaison==2){
	BoiteTexte* bt=new BoiteTexte("Les deux",xbcontrats+2*W+W/2-35,Y,fs,FL_DARK_BLUE);
	Fl_Output* bres=new Fl_Output(xbcontrats+2*W+W/2-20,yboiter+htitrer/2+hboiter/2-30,40,hboiter/2-htitrer/2);
	bres->value(to_string(rep[2]).c_str());
	bres->textcolor(FL_RED);
	bres->textsize(20);
	bres->box(FL_NO_BOX);
      }
      //Le temps
      Fl_Box* bt=new Fl_Box(xbcontrats,yboiter+hboiter-25,wbcontrats,25);
      bt->box(FL_BORDER_FRAME);
      Fl_Output* ot=new Fl_Output(xbcontrats+20,yboiter+hboiter-25,350,25);
      int minutes=t/60;
      int secondes=t%60;
      ostringstream osss;
      osss<<nb<<" tirages, "<<nbstat<<" donnes analysées en "<<minutes<<"'"<<secondes<<"''";
      ot->value(osss.str().c_str());
      ot->box(FL_NO_BOX);
    }
    gcompare->end();
    gcompare->show();
    redraw();
  }
}

int statlevees(DonneesStat& dstat){
  //Version simple calculant le nb de réussites d'un contrat
  contr.eff();
  unsigned long long lim=1<<limite;
  unsigned int nd=0;
  int nbgagne=0;
  futureTricks futt;
  char liste[52];
  unsigned long nb = 0;
  int nbthreads=config.nbthreads;
  bool ccc;
  int iii;
  int tmp=0;
  omp_set_num_threads(nbthreads);
#pragma omp parallel for private(liste,ccc,futt,tmp) schedule(dynamic) reduction(+:nb)
  for (iii=0;iii<nbstat;iii++){
    ccc=false;
    deal dl = {0,0,{0,0,0},{0,0,0},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
    int ij,ic,ir;
    while (!ccc && nb < lim){
      creedonne(liste,contr.cfixees,contr);
      nb++;
      if (cond_ouvs(liste,contr)){
	//int score;
	free_fut(futt);
	for (int i=0;i<52;i++){
	  ij = s.find(liste[i]);
	  ic = 3-i/13;
	  ir = i%13;
	  dl.remainCards[ij][ic] += (1<<(14-ir));
	}
	target=dstat.target;
	dl.trump=dstat.atout;
	dl.first=dstat.first;
	tmp=SolveBoard(dl,target,1,0,&futt,omp_get_thread_num());
	if (futt.score[0]<=0) nbgagne++;
	nd++;
	ccc=true;
      }
    }
  }
  if (nd<nbstat-3) return nbstat;
  else return nbgagne;
}

int statlevees(vector<DonneesStat>& dstat,vector<int>& nbgagne){
  //0 : réussite de chaque contrat
  //1: meilleur contrat
  //2: comparaison fine
  //3: meilleur strict
  //4: réussite de l'un des contrats
  contr.eff();
  int tmp=0;
  unsigned long long lim= 1<<limite;
  unsigned int nd=0;
  //std::vector<int> score(dstat.size());
  futureTricks futt;
  char liste[52];

  // La vulnérabilité
  int no = contr.numerofixe;
  //if (no==0) fl_alert("Attention vulnérabilité non fixée");
  int top,vuln;
  unsigned long nb = 0;
  int nbthreads=config.nbthreads;
  bool ccc;
  int iii;
#if defined (_OPENMP)
  omp_set_num_threads(nbthreads);
#pragma omp parallel for private(liste,ccc,futt,tmp,top) schedule(dynamic) reduction(+:nb)
  #endif
  for (iii=0;iii<nbstat;iii++){
    ccc=false;
    deal dl = {0,0,{0,0,0},{0,0,0},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
    int b,j,ij,ic,ir;
    bool gagne0=0;
    while (!ccc && nb < lim){
      creedonne(liste,contr.cfixees,contr);
      nb++;
      if (cond_ouvs(liste,contr,no)){
	std::vector<int> score(dstat.size());
	free_fut(futt);
	for (int i=0;i<52;i++){
	  ij = s.find(liste[i]);
	  ic = 3-i/13;
	  ir = i%13;
	  dl.remainCards[ij][ic] += (1<<(14-ir));
	}
	if (comparaison==1 || comparaison==3) {
	  top = -1500;
	  j=-1;
	}
	//#if defined (_OPENMP)
	//	  #pragma omp critical
	for (int cp=0;cp<dstat.size();cp++){
	  target = dstat[cp].target;
	  if (comparaison==1||comparaison==3){
	    b = target;
	    target = -1;
	  }
	  dl.trump = dstat[cp].atout;
	  dl.first = dstat[cp].first; 
	  int num;
#if defined (_OPENMP)
	  num=omp_get_thread_num();
#else
	  num=0;
#endif
	  tmp = SolveBoard(dl,target,1,0,&futt,num);
	  if (comparaison==1){
	    score[cp] = fscore(13-futt.score[0],8-b,dl.trump,1,0);
	    if (score[cp]>= top) {
	      nbgagne[cp]++;
	      if (score[cp]>top){
		for (int i=0;i<cp && score[i] == top;i++) nbgagne[i]--;
		top = score[cp];
	      }
	    }
	  }
	  else if (comparaison==3){
	    int declarant = (dl.first-1)%4;
	    int camp=1;
	    if ((dl.first-dstat[0].first)%2) camp=-1;
	    vuln = vul(declarant,no);
	    score[cp] = fscore(13-futt.score[0],8-b,dl.trump,vuln,dstat[cp].contre)*camp;
	    if (score[cp]>= top) {
	      if (j>-1) {
		nbgagne[j]--;
	      }
	      if (score[cp] > top){
		nbgagne[cp]++;
		top = score[cp];
		j = cp;
	      }
	    }
	  } 
	  // Si comparaison=1 ou 3, target est mis à -1 et le but est dans b et on calcule le score du déclarant
	  // Si comparaison=2, on ajoute en 0 pour 1 seul, en 1 pour 2 seul et en 2 pour les 2 réussis
	  else if (comparaison == 2){
	    if (cp == 0){
	      if (futt.score[0] <= 0) gagne0=1;
	      else gagne0=0;}
	    else 
	      if (futt.score[0] <=0){
		nbgagne[1]+=1-gagne0;
		nbgagne[2]+=gagne0;}
	      else nbgagne[0]+=gagne0;
	  }
	  else	if (futt.score[0] <= 0) 
	    if (comparaison == 4) {//On ajoute 1 dans nbgagne[0] et on interrompt la boucle
	      nbgagne[0]++;
	      break;
	    } 
	    else 
	      nbgagne[cp]++; 
	}
	//#endif
	nd ++;
	ccc=true;
      }
    }
    //1 ligne à commenter version web
  }
  //#endif
  if (nd < nbstat) return nb=0;
  else return nb;
}

void Fenetre::res_compare(){
  time_t tbegin,tend;
  tbegin=time(NULL);
  if (dans(comparaison,2,3) && nb_contrats!=2){
    fl_alert("Uniquement pour 2 contrats");
    return;
  }
  vector<int> nbgagne(nb_contrats);
  if (comparaison==2){
    nbgagne.resize(3);
    rep.resize(3);
  }
  else rep.resize(nb_contrats);
  for (int i=0;i<nb_contrats;i++) 
    vcontrats[i]=DonneesStat(comp_niveau[i],comp_couleur[i],comp_declarant[i],comp_contre[i]);
  int nb = statlevees(vcontrats,nbgagne);
  if (nb==0){
    fl_alert("Limite atteinte avant terme. Augmentez la limite ou diminuez le nombre de donnes");
    return;
  }
  //if (comparaison!=2)
  for (int i=0;i<rep.size();i++) rep[i]=nbgagne[i]*100.0/(double)nbstat;
  tend=time(NULL);
  int t=(int)difftime(tend,tbegin);
  bool brep=1;
  comparer(brep,nb,t);
}

//////////////////////////////////////////////////////////////////////////////////////
////////////                Nombre de levées et espérance              ///////////////
//////////////////////////////////////////////////////////////////////////////////////


  /*statlc remplit le vecteur nbgagne de longueur N=14xnc */
int statlc(vector<int>& couleurs,vector<int>& declarants,vector<int>& nbgagne){
  contr.eff();
  int k = 14;
  int levees;
  int tmp=0;
  unsigned long long lim=1<<limite;
  futureTricks futt;
  char liste[52];
  unsigned long nb=0;
  int nc=couleurs.size();
  bool ccc;
  int iii;
  int nbthreads=config.nbthreads;
  int no=contr.numerofixe;
#if defined (_OPENMP)
  omp_set_num_threads(nbthreads);
  //int nt=4;
  //num = omp_get_thread_num()
#pragma omp parallel for private(ccc,liste,futt) schedule(dynamic) reduction(+:nb)
  //#else
  //int nt=1;
#endif
  for (iii=0;iii<nbstat;iii++){
    ccc=false;
    int ij,ic,ir;
    while(!ccc && nb<lim){ 
      nb++;
      creedonne(liste,contr.cfixees,contr);
      if (cond_ouvs(liste,contr,no)){
	  deal dl2={0,0,{0,0,0},{0,0,0},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
	  for (int i=0;i<52;i++){
	    ij = s.find(liste[i]);
	    ic = 3-i/13;
	    ir = i%13;
	    dl2.remainCards[ij][ic] += (1<<(14-ir));
	  }
	  int j0=0;
	  int m=-k;
	  for (int i=0;i<nc;i++){
	    free_fut(futt);
	    m+=k;
	    //int first=(declarants[i]+1)%4;
	    dl2.trump=couleurs[i];
	    dl2.first=(declarants[i]+1)%4;
	    int num;
#if defined (_OPENMP)
	    num=omp_get_thread_num();
#else
	    num=0;
#endif
	    SolveBoard(dl2,-1,1,0,&futt,num);
	    levees=13-futt.score[0];
	    for (int j=0;j<=levees;j++) nbgagne[m+j]++;
	  }
	  ccc=true;
      }
    }
  }
  return nb;
}

void cb_check(Fl_Widget* w,void* data){
  Fl_Check_Button* chb=(Fl_Check_Button*)w;
  int* couleur=(int*)data;
  if (chb->value()==1) couleurs[*couleur]=1;
  else couleurs[*couleur]=0;
}

void cb_contre(Fl_Widget* w,void* data){
  Fl_Check_Button* chb=(Fl_Check_Button*)w;
  int* couleur=(int*)data;
  if (chb->value()==1) contres[*couleur]=1;
  else contres[*couleur]=0;
}

void cb_choix(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  IntBouton* ib=(IntBouton*)data;
  int couleur=ib->entier;
  int joueur=((b->value()-1)+2)%4;
  declarants[couleur]=joueur;
  b->hide();
  Fl_Button* bout=ib->bouton;
  bout->label(nomjoueur[joueur].c_str());
}

void cb_callev(Fl_Widget*,void* data){
  IntIntWin* dsl=(IntIntWin*)data;
  dsl->win->res_levees(couleurs);
}

void cb_calent(Fl_Widget*,void* pw){
  res_entames();//
}

void cb_calini(Fl_Widget*,void* pw){
  deja.ini();
  Fenetre* win=(Fenetre*)pw;
  win-> entames();
}

void cb_compentames(Fl_Widget* w,void* pw){
  Fenetre* win=(Fenetre*)pw;
  Fl::delete_widget(win->bres);
  win->res_compentames();
}

class SelectJ:public Fl_Group{
  Fl_Button* bouton;

public:
  Fl_Select_Browser* choix;
  SelectJ(int X,int Y,int W,int H,int C,const char* L=0):Fl_Group(X,Y,W,H,L){
    begin();
    bouton=new Fl_Button(X,Y,largeurSelect,hboutonSelect,"Sud");
    bouton->labelsize(16);
    bouton->color(FL_WHITE);
    choix=new Fl_Select_Browser(X+largeurSelect,Y,largeurSelect,H);
    for (int j=0;j<4;j++) choix->add(joueurs[(j+2)%4]);
    choix->hide();
    bouton->callback(Fenetre::cb_bjoueur,(void*)choix);
   //On passe en paramètre, le bouton et la couleur
    IntBouton* data=new IntBouton(C,bouton);
    choix->callback(cb_choix,(void*)data);
    end();
  }
};

class Choix_Stat:public Fl_Group{
  Fl_Check_Button* check;
  Fl_Check_Button* check_contre;
  SelectJ* sel_decl;
public:
  Choix_Stat(int X,int Y,int W,int H,int C,const char* L=0):Fl_Group(X,Y,W,H){
    declarant=2;
    checked=0;
    begin();
    check=new Fl_Check_Button(X+ESPD,Y+ESPD,100,hboutonSelect,T[C]);
    check->labelsize(18);
    int *pc=new int;
    *pc=C;
    check->callback(cb_check,(void*)pc);
    sel_decl=new SelectJ(X+dxSelect,Y+ESPD,2*largeurSelect,hauteurSelect,C);
    check_contre=new Fl_Check_Button(sel_decl->x()+2*largeurSelect+ESPD,check->y(),100,check->h(),"Contré");
    check_contre->callback(cb_contre,(void*)pc);
    end();
  }
  bool checked;
  int declarant;
  const char* T[5]={" Pique par "," Cœur par "," Carreau par "," Trèfle par ","Sans-atout par"};

  virtual ~Choix_Stat(){};
};

void Fenetre::stats_levees(){
  const int ybtirages=ybcontrats+6*hcg+ESPD;
  color(fl_rgb_color(190,231,239));
  detruit_widgets();
  if (gstats==0){
      begin();
      //Le groupe de la page
      gstats=new Fl_Group(0,30,x_max(),y_max()-30);
 
     //Le titre
      Titrepage* bstats=new Titrepage("Statistiques nombre de levées");

      //Les contraintes
      Fl_Box* bcontraintes=new Fl_Box(xbcontrats,ybchoix,wbcontrats,50);
      bcontraintes->box(FL_UP_BOX);
      bcontraintes->color(coul_fenetre_contr);
      Fl_Output* ocontraintes=new Fl_Output(xbcontrats+100,ybchoix+10,150,25,"Contraintes :");
      ocontraintes->labelfont(FL_HELVETICA_ITALIC);
      ocontraintes->align(FL_ALIGN_LEFT);
      ocontraintes->value(contr.nom.c_str());

      //Le choix des contrats
      Fl_Box* bcontrats=new Fl_Box(xbcontrats,ybcontrats,wbcontrats,6*hcg,"Contrats");
      bcontrats->box(FL_UP_BOX);
      bcontrats->align(FL_ALIGN_LEFT_TOP);
      bcontrats->labeltype(FL_ENGRAVED_LABEL);
      bcontrats->labelsize(18);
      bcontrats->color(coul_fenetre_contr);
      Choix_Stat* choix_stat0=new Choix_Stat(xbcontrats,ybcontrats,500,2*hcg,0);
      Choix_Stat* choix_stat1=new Choix_Stat(xbcontrats,ybcontrats+hcg,500,2*hcg,1);
      Choix_Stat* choix_stat2=new Choix_Stat(xbcontrats,ybcontrats+2*hcg,500,2*hcg,2);
      Choix_Stat* choix_stat3=new Choix_Stat(xbcontrats,ybcontrats+3*hcg,500,2*hcg,3);
      Choix_Stat* choix_stat4=new Choix_Stat(xbcontrats,ybcontrats+4*hcg,500,2*hcg,4);

      //paramètres
      Fl_Box* btirages=new Fl_Box(xbcontrats,ybtirages,wbcontrats,50,"Nombre de tirages");
      btirages->align(FL_ALIGN_LEFT_TOP);
      btirages->labeltype(FL_ENGRAVED_LABEL);
      btirages->box(FL_UP_BOX);
      btirages->labelsize(18);
      btirages->color(coul_fenetre_contr);
      Fl_Int_Input* inbdonnes=new Fl_Int_Input(xbcontrats+150,ybtirages+ESPD,50,25,"Nombre de donnes : ");
      inbdonnes->value(to_string(nbstat).c_str());
      inbdonnes->callback(cb_inbdonnes);
      //limite
      Fl_Int_Input* inblimite=new Fl_Int_Input(xbcontrats+300,ybtirages+ESPD,30,25,"Limite : ");
      inblimite->value(to_string(limite).c_str());
      inblimite->callback(cb_limite);
      Fl_Box* blimite = new Fl_Box(xbcontrats+510,ybtirages+ESPD,50,25,"entre 0 et 31; le nombre maximal de donnes créées est 2^limite.");
      blimite->labelfont(FL_HELVETICA_ITALIC);

      //Bouton calcul
      Fl_Button* bcallev=new Fl_Button(xbcontrats+ESPD,ybcontrats+5*hcg+ESPD,70,30,"&Calculer");
      IntIntWin* data=new IntIntWin(nbstat,limite,this);
      bcallev->callback(cb_callev,(void*)data);
      end();
      redraw();
  }
  else{
    gstats->show();
    redraw();
  }
}
  
void Fenetre::res_levees(vector<bool>& couleurs){
  time_t tbegin,tend;
  tbegin=time(NULL);
  vector<int> atouts;
  vector<int> decls;
  for (int i=0;i<5;i++){
    if (couleurs[i]){
      atouts.push_back(i);
      decls.push_back(declarants[i]);
    }
  }
  int nc=atouts.size();
  if (nc==0){
    fl_alert("Aucune couleur choisie");
    return;
  }
  int l=14*nc;
  vector<int> nbgagne(l);
  long int nb = statlc(atouts,decls,nbgagne);
  if (nb==0){
    fl_alert("Limite atteinte avant terme. Augmentez la limite ou diminuez le nombre de donnes.");
    return;
  }
  vector<double> rep(l);
  vector<double> ENV(7*nc);
  vector<double> EV(7*nc);
  vector<double> moyenne(nc);
  int contrat;
  for (int i=0;i<l;i++){
    rep[i]=(double)(nbgagne[i]*100)/nbstat;
  }
  for (int j=0;j<nc;j++){
    int co=atouts[j];
    vector<double> probas(14);
    moyenne[j]=0;
    for (int i=0;i<13;i++){
      probas[i]=(double)(nbgagne[14*j+i]-nbgagne[14*j+i+1])/nbstat;
      moyenne[j]+=probas[i]*i;
    }
    probas[13]=(double)nbgagne[14*j+13]/nbstat;
    moyenne[j]+=probas[13]*13;
    for (int levees=7;levees<14;levees++){
      ENV[7*j+levees-7]=esperance(probas,levees-6,co,0,contres[co]);
      EV[7*j+levees-7]=esperance(probas,levees-6,co,1,contres[co]);
    }
  }
  //Affichage des résultats de stat_levées;
  gstats->hide();
  gres_lev=new Fl_Group(0,30,x_max(),y_max());
  gres_lev->begin();
  //Le titre
  Titrepage* bstats=new Titrepage("Statistiques nombre de levées");

  //Le tableau des résultats;
  int lcol=120-12*nc;
  int wtableau=4*nc*lcol+(2*nc+1)*ESPC;
  int xtableau=(x_max()-wtableau)/2;
  int ytableau=ybchoix;
  Fl_Box* bres=new Fl_Box(xtableau,ybchoix,wtableau,600);
  bres->color(coul_fenetre_contr);
  bres->box(FL_UP_BOX);
  //Le titre Résultats;
  Fl_Box* bresultats=new Fl_Box(xtableau,ybchoix,wtableau,40,"Résultats");
  bresultats->labelcolor(FL_DARK_BLUE);
  bresultats->labelsize(25);
  bresultats->labelfont(FL_HELVETICA_BOLD);
  bresultats->box(FL_UP_BOX);
  bresultats->color(coul_fenetre_contr);
  //Les boîte de couleur ;
  int ymoyenne=ybchoix+72+15*31;
  for (int i=0;i<nc;i++){
    //Le titre pour chaque calcul;
    const string s=vcoulssa[atouts[i]]+" par "+nomjoueur[decls[i]];
    Fl_Box* brescoul=new Fl_Box(xtableau+(4*lcol+4)*i+4,ybchoix+41,4*lcol+3,530);
    brescoul->box(FL_FRAME_BOX);
    brescoul->color(coul_fenetre_contr);
    Fl_Output* ocoul=new Fl_Output(xtableau+110+4*lcol*i+2,ybchoix+42,200,30);
    ocoul->value(s.c_str());
    ocoul->textcolor(FL_DARK_BLUE);
    ocoul->textsize(20);
    ocoul->textfont(FL_HELVETICA_BOLD);
    ocoul->box(FL_NO_BOX);
    //Le tableau des résultats l
    int xtable=xtableau+(4*lcol+4)*i+4;
    int wtable=4*lcol+4;
    MyTable* table=new MyTable(xtable,ybchoix+72,wtable,460);
    table->col_width_all(lcol);
    for (int r=14*i;r<14*i+14;r++) table->pourcentage[r-14*i]=rep[r];
    for (int r=14*i+7;r<14*i+14;r++){
      table->data[r-14*i][2]=ENV[r-7*(i+1)];
      table->data[r-14*i][3]=EV[r-7*(i+1)];
    }
    //La moyenne.
    Fl_Output* bmoy=new Fl_Output(xtable+(wtable-70)/2,ymoyenne,70,25,"Moyenne : ");
    double m=moyenne[i];
    ostringstream oss;
    oss.precision(4);
    oss<<m;
    bmoy->value(oss.str().c_str());
  }
  //données
  tend=time(NULL);
  int t=(int)difftime(tend,tbegin);
  int minutes=t/60;
  int secondes=t%60;
  Fl_Output* ofin=new Fl_Output(xtableau+5,ymoyenne+35,400,20);
  ostringstream osss;
  osss<<nb<<" tirages, "<<nbstat<<" donnes analysées en "<<minutes<<"'"<<secondes<<"''";
  ofin->value(osss.str().c_str());
  ofin->box(FL_NO_BOX);
  gres_lev->end();
  add(gres_lev);
}

void cb_niveau(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  deja.niveau=b->value()-1;
  Fl_Button* bouton=(Fl_Button*)data;
  bouton->label(num[deja.niveau]);
  b->hide();
}
void cb_jou(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  int jou=((b->value()-1)+2)%4;
  deja.declarant=jou;
  deja.premier=(deja.declarant+1)%4;
  deja.joueur=deja.premier;
  b->hide();
  Fl_Button* bou=(Fl_Button*)data;
  bou->label(nomjoueur[jou].c_str());
}

void cb_premier(Fl_Widget* w,void* data){
  Fl_Select_Browser* b=(Fl_Select_Browser*)w;
  deja.premier=((b->value()-1)+2)%4;
  ecrit_debug("premier : "+to_string(deja.premier));
  b->hide();
  Fl_Button* bou=(Fl_Button*)data;
  bou->label(nomjoueur[deja.premier].c_str());
}

void cb_cou(Fl_Widget* brow, void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  int n=b->value();
  Fl_Button* bou=(Fl_Button*)bouton;
  b->hide();
  bou->label(sacouls[n-1]);
  deja.couleur=(n+3)%5;
  //cout<<"couleur : "<<couleur<<endl;
}

void cb_leveesdec(Fl_Widget* brow,void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  deja.leveesdec=b->value()-1;
  Fl_Button* bou=(Fl_Button*)bouton;
  bou->label(num[deja.leveesdec]);
  b->hide();
}

void cb_leveesdef(Fl_Widget* brow,void* bouton){
  Fl_Select_Browser* b=(Fl_Select_Browser*)brow;
  deja.leveesdef=b->value()-1;
  Fl_Button* bou=(Fl_Button*)bouton;
  bou->label(num[deja.leveesdef]);
  //cout<<"num["<<leveesdef<<"]="<<num[leveesdef]<<endl;
  b->hide();
}


void cb_coudeja(Fl_Widget* w,void*){
  Fl_Input* in=(Fl_Input*)w;
  const char* vin=in->value(); 
  //cout<<" cb_coudeja "<<vin<<endl;
  string sc="PCKT";
  deja.ctcouleurs[0]=sc.find(vin[0]);
  deja.ctcouleurs[1]=sc.find(vin[1]);
  deja.ctcouleurs[2]=sc.find(vin[2]);
}

void cb_rdeja(Fl_Widget* w,void*){
  Fl_Input* in=(Fl_Input*)w;
  const char* vin=in->value(); 
  deja.ctranks[0]=retrovl(vin[0]);
  deja.ctranks[1]=retrovl(vin[1]);
  deja.ctranks[2]=retrovl(vin[2]);
  deja.joueur=deja.premier;
  for (int i=0;i<3;i++)
    if (deja.ctranks[i]>0) deja.joueur=(deja.joueur+1)%4;
}


void cb_dj(Fl_Widget* w,void* pj){
  Fl_Input* in=(Fl_Input*)w;
  const char* vin=in->value();
  string s(vin);
  int *pjoueur = (int*)pj;
  int i=0,j=s.find('-');
  vector<string> vs(4);
  vs[0]=s.substr(i,j-i);
  i=++j;
  j=s.find('-',j);
  vs[1]=s.substr(i,j-i);
  i=++j;
  j=s.find('-',j);
  vs[2]=s.substr(i,j-i);
  vs[3]=s.substr(j+1,s.length());
  for (int c=0;c<4;c++){
    if (vs[c].length()>0){
      deja.dj[*pjoueur][c]=nomstoent(vs[c]);
      for (int r=2;r<15;r++){
	if (bitdans(deja.dj[*pjoueur][c],r)) contr.cfixees[13*(3-c)+14-r]=jsymbs[*pjoueur];
      }
    }
  }
}

void cb_jouees(Fl_Widget* obj,void* pw){
  //La carte cliquée est dédignée par l'entier sur 8 bits p (joueur+4*couleur+16*(14-rang))
  //0 1  pour le joueur (Nord=0)
  //2 3  pour la couleur (Pique=0)
  //4 à 7 pour le rang (As=14)
  // le 7 de coeur en est sera 1+4*1+16*7
  // La carte est envoyée dans le vecteur 4x4 deja.dj
  // Si elle ne fait pas partie de contr.cfixees, elle est ajoutée/enlevée de deja.fixees
  Fl_Button* refobj=(Fl_Button*)obj;
  int* p=(int*)pw;
  int joueur = (*p)%4;
  int couleur = ((*p)>>2)%4;
  int rang = *p>>4;
  int no=13*(3-couleur)+(14-rang);
  if (refobj->value()==0){
    //Si la carte est cochée, on la libère
    deja.jouees[no]='V';
    refobj->value(1);
    refobj->labelcolor(FL_RED);
    //Si elle n'est pas dans les fixées
    if (contr.cfixees[no]=='V'){
    refobj->down_color(couleur_main);
    //on la retire de deja.fixees
    deja.fixees[no]='V';
    }
    else{
    //Si elle est dans contr.fixées
    refobj->down_color(FL_GRAY);
    }
    deja.dj[joueur][couleur]-=1<<rang;
  }
  else{
    //si la carte a déjà été jouée
    if (deja.jouees[no]!='V'){
      char J=deja.jouees[no];
      ostringstream oss;
      oss<<vl[14-rang]<<" de "<<sacouls[couleur+1]<<" déjà présent en "<<J<<endl;
      fl_alert(oss.str().c_str());
    }
    //ou si elle appartient à un autre joueur
    else if (contr.cfixees[no]!='V' && contr.cfixees[no]!=jsymbs[joueur]){
      fl_alert("carte impossible");
    }
    else{
    deja.jouees[no]=jsymbs[joueur];
    deja.dj[joueur][couleur]+=1<<rang;
    refobj->value(0);
    refobj->labelcolor(FL_DARK_BLUE);
    refobj->color(255);
    //On rajoute éventuellement la carte dans les fixees
    deja.fixees[no]=jsymbs[joueur];
    }
  }
}


void cb_sent2(Fl_Widget* w,void* data){
  Fl_Select_Browser* sb=(Fl_Select_Browser*)w;
  IntVIBS* ib=(IntVIBS*)data;
  int n=ib->entier;
  BoutonSelect* b=ib->bouton;
  int v=sb->value();
  vector <int> vec=ib->vecteur;
  if (v>0){ 
    int no=vec[v-1];
    sb->hide();
    nos[n]=no;
    b->no=no;
    b->redraw();
    //Fl::delete_widget(ib->bouton);
    
  }
 }

void Fenetre::entames(){
  if (deja.id_contraintes!=contr.id) deja.ini();
  env.page="entames";
  detruit_widgets();
  color(fl_rgb_color(190,231,239));
  if (gentames==0){
    begin();
    gentames = new Fl_Scroll(0,30,x_max(),y_max()-60);
    gentames->begin();
    gentames->color(fl_rgb_color(190,231,239));
    Titrepage* titre=new Titrepage("Pourcentages de réussite des entames et suivantes");
    
    //Avertissement
    Fl_Text_Display* indications=new Fl_Text_Display(xbcontrats,ybchoix,wbcontrats,70);
    Fl_Text_Buffer *buff = new Fl_Text_Buffer();
    indications->box(FL_UP_BOX);
    indications->color(coul_fenetre_contr);
    indications->textfont(FL_HELVETICA_ITALIC);
    indications->textsize(15);
    indications->buffer(buff);
    buff->text("Fixez la main du joueur avec les contraintes, choisissez l'atout, le contrat, le déclarant avec les paramètres. Si le but est à 0,\n affichage du nombre de levées pour chaque donne, sinon seul le pourcentage de réussite est affiché. S'il ne s'agit pas d'une\n entame, renseignez la partie «cartes déjà jouées». Pour plus de détails, consultez la FAQ de pygen25.");

    //Les contraintes
    Fl_Output* output_contr=new Fl_Output(2*ESPD,yfmains+100,200,30,"Nom des contraintes");
    output_contr->align(FL_ALIGN_TOP);
    output_contr->value(contr.nom.c_str());
    gentames->add(output_contr);

    //Le contrat (niveau+couleur+joueur);
    int ycontrat=ybchoix+75;
    int hcontrat=65;
    BoiteForm* contrat=new BoiteForm(ycontrat,hcontrat,"Contrat ");
    Fl_Box* expl=new Fl_Box(xbcontrats,ycontrat,wbcontrats,25,"Pour obtenir l'espérance du nombre de levées, laissez le but à 0");
    expl->labelfont(FL_HELVETICA_ITALIC);
    Fl_Button* bniv=new Fl_Button(xbcontrats+ESPD,ycontrat +25,40,25,num[deja.niveau]);
    bniv->color(FL_WHITE);
    Fl_Select_Browser* sniv=new Fl_Select_Browser(xbcontrats+ESPD+43,ycontrat-30,40,115); 
    for (int i=0;i<8;i++) sniv->add(to_string(i).c_str());
    sniv->hide();
    bniv->callback(Fenetre::cb_bjoueur,(void*)sniv);
    sniv->callback(cb_niveau,(void*)bniv);
    //couleur
    int xscou=xbcontrats+ESPD+85;
    Fl_Button* cbou=new Fl_Button(xscou,ycontrat+25,75,25,sacouls[(deja.couleur+1)%5]);
    cbou->color(FL_WHITE);
    Fl_Select_Browser* csel=new Fl_Select_Browser(xscou+78,ycontrat-25,75,90);
    for (int i=0;i<5;i++) csel->add(sacouls[i]);
    csel->hide();
    cbou->callback(Fenetre::cb_bjoueur,(void*)csel);
    csel->callback(cb_cou,(void*)cbou);
    //joueur
    Fl_Box* bpar=new Fl_Box(xscou+140,ycontrat+25,50,25,"par ");
    int xsjou=xscou+180;
    Fl_Button* jbou=new Fl_Button(xsjou,ycontrat+25,largeurSelect,hboutonSelect,joueurs[deja.declarant]);    
    jbou->color(FL_WHITE);
    Fl_Select_Browser* jsel=new Fl_Select_Browser(xsjou+73,ycontrat-20,largeurSelect,80);
    for (int j=0;j<4;j++) jsel->add(joueurs[(j+2)%4]);
    jsel->hide();
    jbou->callback(Fenetre::cb_bjoueur,(void*)jsel);
    jsel->callback(cb_jou,(void*)jbou);

     //Bouton calcul
    Fl_Button* bcallev=new Fl_Button(xsjou+160,ycontrat+25,70,30,"&Calculer");
    bcallev->callback(cb_calent,(void*)this);//L694
    
    //Paramètres
    ycomparaison=ycontrat+hcontrat+ESPD;
    int hcomparaison=110;
    int dy=10;
    int ydeja=ycomparaison+hcomparaison+ESPD;
    int hdeja=200+hfmains+30;
    int yparams=ydeja+hdeja+5;
    parametres(yparams);
    
    //Cartes déjà jouées
    //Levée en cours
    BoiteForm* Deja=new BoiteForm(ydeja,hdeja,"Cartes déjà jouées ");
    Fl_Box* levenc=new Fl_Box(xbcontrats+30,ydeja+10,150,30,"Levée en cours");
    levenc->labelsize(18);
    levenc->labelfont(FL_HELVETICA_BOLD);
    //initialisation
    Fl_Button* binideja=new Fl_Button(levenc->x()+200,levenc->y(),70,25,"Initialiser");
    binideja->callback(cb_calini,(void*)this);
    int xbpremier=xbcontrats+ESPD;
    int ybpremier=ydeja+40;
    //couleurs
    Fl_Input* coudeja=new Fl_Input(xbpremier+398,ybpremier+30,40,25,"Couleurs (P,C,K,T pour les cartes jouées de la levée en cours) ");
    string s="PCKT";
    string ss="";
    string sr="";
    for (int i=0;i<3;i++){
      ss+=s[deja.ctcouleurs[i]];
      sr+=cartes[deja.ctranks[i]];
    } 
    coudeja->value(ss.c_str());
    coudeja->callback(cb_coudeja);
    //rangs
    Fl_Input* rdeja=new Fl_Input(xbpremier+432,ybpremier+57,40,25,"Rangs (A,R,D,V,X,9,...2 pour les cartes jouées de la levée en cours) ");
    rdeja->value(sr.c_str());
    rdeja->callback(cb_rdeja);

    Fl_Box* premierbox=new Fl_Box(xbpremier,ybpremier,70,25,"Premier : ");
    Fl_Button* bpremier=new Fl_Button(xbpremier+70+ESPC,ybpremier,largeurSelect,hboutonSelect,"Ouest");
    bpremier->color(FL_WHITE);
    Fl_Select_Browser* spremier=new Fl_Select_Browser(xbpremier+140+ESPC,ybpremier,largeurSelect,75);
    for (int j=0;j<4;j++) spremier->add(joueurs[(j+2)%4]);
    spremier->hide();
    bpremier->callback(Fenetre::cb_bjoueur,(void*)spremier);
    spremier->callback(cb_premier,(void*)bpremier);

    //Cartes déjà jouées. Version 0.35_4, les cartes sont cliquées dans un tableau
    Fl_Box* dejajouees=new Fl_Box(xbpremier+30,ybpremier+87,120,30,"Cartes jouées");
    dejajouees->labelsize(18);
    dejajouees->labelfont(FL_HELVETICA_BOLD);
    new Fl_Box(xbpremier+162,ybpremier+87,200,30,"(y compris levée en cours)");
    //montrer_fixees(xbpremier,dejajouees->y()+35,cb_jouees,deja.jouees);
    montrer_fixees(xbpremier,dejajouees->y()+35,cb_jouees,deja.jouees);

    //nombre de levées déjà réalisées
    int ynblb=dejajouees->y()+35+hfmains;
    int ynbldef=ynblb+30;
    new Fl_Box(xbpremier,ynblb,422,25,"Nombre de levées déjà réalisées par le camp du déclarant (but>0) : ");
    Fl_Button* nblb=new Fl_Button(xbpremier+445,ynblb,40,25,num[deja.leveesdec]);
    nblb->color(FL_WHITE);
    Fl_Select_Browser* nbls=new Fl_Select_Browser(xbpremier+445,nblb->y(),40,100);
    for (int i=0;i<11;i++) nbls->add(num[i]);
    nbls->hide();
    nblb->callback(Fenetre::cb_bjoueur,(void*)nbls);
    nbls->callback(cb_leveesdec,(void*)nblb);
    new Fl_Box(xbpremier,ynbldef,430,25,"Nombre de levées déjà réalisées par le camp de la défense (but>0) : ");
    Fl_Button* nbldefb=new Fl_Button(xbpremier+445,ynbldef,40,25,num[deja.leveesdef]);
    nbldefb->color(FL_WHITE);
    Fl_Select_Browser* nbldefs=new Fl_Select_Browser(xbpremier+405,ynbldef,40,100);
    for (int i=0;i<11;i++) nbldefs->add(num[i]);
    nbldefs->hide();
    nbldefb->callback(Fenetre::cb_bjoueur,(void*)nbldefs);
    nbldefs->callback(cb_leveesdef,(void*)nbldefb);

    //Comparaison directe
    BoiteForm* comparaison=new BoiteForm(ycomparaison,hcomparaison,"Comparaison directe");
    Fl_Button* exec_comp = new Fl_Button(xbcontrats+ESPD,ycomparaison+dy,80,25,"comparer");
    exec_comp->callback(cb_compentames,(void*)this);
    Fl_Box* bentseul=new Fl_Box(exec_comp->x()+exec_comp->w(),exec_comp->y(),150,exec_comp->h(),"(entame seulement)");
    BoutonSelect* bent1=new BoutonSelect(bentseul->x()+bentseul->w(),exec_comp->y(),60,25,-1,"carte1");//BoutonSelect défini dans fenetre.h ligne 133.
    BoutonSelect* bent2=new BoutonSelect(bent1->x()+bent1->w()+ESPD,exec_comp->y(),bent1->w(),bent1->h(),-1,"carte2");
    Fl_Select_Browser* sent1=new Fl_Select_Browser(bent1->x(),ycomparaison+dy+25,bent1->w(),110);
    Fl_Select_Browser* sent2=new Fl_Select_Browser(bent2->x(),ycomparaison+dy+25,bent2->w(),110);
    sent1->hide();sent2->hide();
    //affiche les cartes correspondant aux numéros utiles du joueur
    bent1->callback(cb_bjoueur,(void*)sent1);
    bent2->callback(cb_bjoueur,(void*)sent2);
    vector<int> nu=numeros_entame(contr.cfixees,"NESO"[deja.premier]);
    static int widths[]={20,30};
    sent1->column_widths(widths);
    sent2->column_widths(widths);
    for (int n=0;n<nu.size();n++){
      sent1->add(aff_carte(nu[n]).c_str());
      sent2->add(aff_carte(nu[n]).c_str());
    }
    IntVIBS* data1=new IntVIBS(0,nu,bent1);
    IntVIBS* data2=new IntVIBS(1,nu,bent2);
    sent1->callback(cb_sent2,(void*)data1);
    sent2->callback(cb_sent2,(void*)data2);
    gentames->end();
    end();
  }
  gentames->show();
}

void affiche(char liste[52]){
  for (int i=0;i<52;i++){
    std::cout<<liste[i];
  }
  std::cout<<std::endl;
}


int stat(Deja& deja){
 //Statistiques entame remplit le tableau nbchutes[52] et revoie un code erreur
  //0: tout va bien.
  //2: pas de donne satisfaisant aux conditions
  int nbthreads=config.nbthreads;

  deja.eff();
  int target=-1;
  int i,j,tmp;
  int solutions=3,mode=1;
  unsigned long long lim=1<<limite;
  if (deja.niveau>0){
    if ((deja.joueur+deja.declarant)%2) target=8-deja.leveesdef-deja.niveau;
    else target=6+deja.niveau-deja.leveesdec;
  }
  ecrit_debug("target "+to_string(target));
  if (target>0) solutions=2;
  for (i=0;i<52;i++) nbchutes[i]=0;
  for (i=0;i<52;i++)
    for (j=0;j<14;j++)
  	tabstat[i][j] = 0;
  unsigned long nb=0;
  int nd=0;
  char liste[52];
  futureTricks futt;
  bool ccc;
  int iii;
  #if defined (_OPENMP)
  omp_set_num_threads(nbthreads);
  #pragma omp parallel for private(tmp,ccc,liste,futt) schedule(dynamic) reduction(+:nb)
  #endif
  for (iii=0;iii<nbstat;iii++){
    deal dl = {deja.couleur,deja.premier,{deja.ctcouleurs[0],deja.ctcouleurs[1],deja.ctcouleurs[2]},{deja.ctranks[0],deja.ctranks[1],deja.ctranks[2]},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
    ccc=false;
    int ij,ic,ir;
    while(!ccc && nb<lim){
      deja.creedonne(liste);
      ecrit_debug("liste  : "+to_string(liste));
      std::string y;
      y=liste[40];
      //ecrit_debug("liste 6 de carreau "+to_string(liste[21]));
      //ecrit_debug("liste Roi de pique "+y);
      nb++;
      if (cond_ouvs(liste,contr,contr.numerofixe)){
	ecrit_debug("cond_ouvs "+to_string(nb));
	free_fut(futt);
	for (int i=0;i<52;i++){
	  ij = s.find(liste[i]);
	  ic = 3-i/13;
	  ir = i%13;
	  dl.remainCards[ij][ic] += (1<<(14-ir));
	}
	//On enlève les cartes déjà jouées
	for (int j=0;j<4;j++){
	  for (int c=0;c<4;c++){
	    if (deja.dj[j][c]>0) dl.remainCards[j][c]-=deja.dj[j][c];
	  } 
        }
	int num;
	#if defined (_OPENMP)
	num=omp_get_thread_num();
	#else
	num=0;
	#endif
	tmp = SolveBoard(dl,target,solutions,mode,&futt,num);
	if (target == -1){
	  trifut(futt.suit,futt.rank,futt.score);
	  #if defined (_OPENMP)
	  #pragma omp critical
	  #endif
	  for (i=0;i<futt.cards;i++){
	    int nnn =(3-futt.suit[i])*13+14-futt.rank[i];
	    tabstat[nnn][futt.score[i]]++;
          }
        }
	else{
	  for (int c=0;c<4;c++){
	    ecrit_debug("dl["+to_string(3)+"]["+to_string(c)+"]="+bitstocartes(dl.remainCards[3][c]));
	  }
	  #if defined (_OPENMP)
	  #pragma omp critical
	  #endif
	  for (i=0;i<13 && futt.score[i]>0;i++){
	    ecrit_debug("score "+to_string(futt.score[i]));
	    int nnn =(3-futt.suit[i])*13+14-futt.rank[i];
	    nbchutes[nnn]++;
	    ecrit_debug("nbchutes["+to_string(nnn)+"]="+to_string(nbchutes[nnn]));
	  }
	}
	ccc = true;
	nd++;
      }//fin if
    }//fin while
    //if (nb>=lim/nbthreads) break;
  }//fin for
  //for (int k=0;k<52;k++){
  //if (tabstat[k][4]>0) cout<<"i : "<<k<<" tabstat "<<tabstat[k][4]<<endl;
//}
  if (nb>=lim) return 2;
  ecrit_debug("nb "+to_string(nb));
  return nb;
}


void res_entames(){
  //le joueur doit avoir 13 cartes connues
  ecrit_debug("Resultat entame \n");
  deja.joueur=deja.premier;
  for (int i=0;i<3;i++){
    if (deja.ctranks[i]>0) deja.joueur++;
  }
  deja.joueur=deja.joueur%4;
  int n=0;
  for (int i=0;i<52;i++) 
    if (contr.cfixees[i]==jsymbs[deja.joueur]) n++;
  deja.debug();
  if (n!=13){
    fl_alert("Le joueur n'a pas 13 cartes");
    return;
  }
  time_t tbegin,tend;
  tbegin=time(NULL);
  int nb=stat(deja);//0 ok; 2 pas assez de donnes //stat()L1274
  if (nb==2){
    fl_alert("nombre de donne insuffisant, vérifiez vos contraintes");
    return;
  }
  int largeur,hauteur,l;
  vector<int> rep;
  vector<int> vesp;
  if (deja.niveau>0){largeur=320;hauteur=500;}
  else {largeur=900;hauteur=600;}  
  Fl_Window* wentames=new Fl_Window(50,130,largeur,hauteur,"Résultats entames");
  wentames->begin();
  Fl_Box* bresultats=new Fl_Box(0,0,largeur,40,"Résultats");
  bresultats->labelcolor(FL_DARK_BLUE);
  bresultats->labelsize(20);
  bresultats->labelfont(FL_HELVETICA_BOLD);
  bresultats->box(FL_FLAT_BOX);
  bresultats->color(coul_fenetre_contr);
  if (deja.niveau>0){
    for (int i=0;i<52;i++){
	  //ecrit_debug("nb chutes["+to_string(i)+"]="+to_string(nbchutes[i]));
      if (nbchutes[i]>0){
	rep.push_back(i);
	vesp.push_back(nbchutes[i]);
      }
    }
    tri(rep,vesp);
    l=rep.size();
  //Affichage des résultats
    MaTable* table=new MaTable(0,40,largeur,hauteur-66);
    table->rows(l);
    table->col_header(1);
    table->row_header(1);
    for (int k=0;k<l;k++){
      table->vdata[k]=vl[rep[k]%13];
      table->vvdata[k]=symbcoul[rep[k]/13];
      table->couleur[k]=coulsymb[rep[k]/13];
    table->cols(1);
    table->hdata[0]="% réussite";
    //for (int k=0;k<l;k++)      table->data[k][0]=(nbchutes[rep[k]]*100)/nbstat;
    for (int k=0;k<l;k++) table->data[k][0]=vesp[k]*100/nbstat;
    table->col_width_all(largeur-45);
    }
  }
  else{
    //rep=numeros_utiles(contr.cfixees,jsymbs[deja.joueur]);
    for (int i=0;i<52;i++){
	int k;
	for (k=0;k<14;k++)
	if (tabstat[i][k]>0){
	  rep.push_back(i);
	  break;
	}
      }
    l=rep.size();
    MaaTable* table=new MaaTable(0,40,largeur,hauteur-66);
    table->rows(l);
    table->col_header(1);
    table->row_header(1);
    table->cols(15);
    table->col_width_all(largeur/16);
    for (int i=0;i<14;i++) table->hdata[i]=num[i];
    table->hdata[14]="E";
    for (int i=0;i<l;i++){
	table->vdata[i]=vl[rep[i]%13];
	table->vvdata[i]=symbcoul[rep[i]/13];
	table->couleur[i]=coulsymb[rep[i]/13];
	double E=0;
	int r,T=0;
	//hauteur de ligne doublée, résultat en haut (espace de 5).
	for (int j=13;j>=0;j--){
	  r=tabstat[rep[i]][j];
	  E+=r*j;
	  T+=r;
	  table->data[i][j]=r;
	  table->ddata[i][j]=T;
	}
	E =(double)(E/nbstat);
	table->esp[i]=E;
    }
  }
  //données 
  tend=time(NULL);
  int t=(int)difftime(tend,tbegin);
  int minutes=t/60;
  int secondes=t%60;
  Fl_Output* ofin=new Fl_Output(2,hauteur-22,largeur,20);
  ostringstream osss;
  osss<<nb<<" tirages, "<<nbstat<<" donnes analysées en "<<minutes<<"'"<<secondes<<"''";
  ofin->value(osss.str().c_str());
  ofin->box(FL_NO_BOX);
  wentames->end();
  wentames->show();
}

int compentames(Deja& deja, vector<int>& nbgagne){
  //Calcul pour comparaison de deux entames
  contr.eff();
  unsigned long long lim=1<<limite;
  int co1=coulno(nos[0]);
  int rg1=rang(nos[0]);
  int co2=coulno(nos[1]);
  int rg2=rang(nos[1]);
  futureTricks fut1;
  futureTricks fut2;
  char liste[52];
  unsigned int nd;
  unsigned long nb;
  bool ccc;
int iii;
int nbthreads=config.nbthreads;
//omp_set_num_threads(nbthreads);
#if defined (_OPENMP)
  omp_set_num_threads(nbthreads);
  //nbthreads=4;
#pragma omp parallel for private(ccc,liste,fut1,fut2) schedule(dynamic) reduction(+:nb)
  //#else
  //nbthreads=1;
#endif
  for (iii=0;iii<nbstat;iii++){
    ccc=false;
    free_fut(fut1);
    free_fut(fut2);
    int ij,ic,ir;
    while(!ccc && nb<lim/nbthreads){
      nb++;
      creedonne(liste,contr.cfixees,contr);
      if (cond_ouvs(liste,contr,contr.numerofixe)){
	deal dl={deja.couleur,deja.premier,{co1,0,0},{rg1,0,0},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
	for (int i=0;i<52;i++){
	  ij = s.find(liste[i]);
	  ic = 3-i/13;
	  ir = i%13;
	  dl.remainCards[ij][ic] += (1<<(14-ir));
	}
	dl.remainCards[deja.premier][co1]-=(1<<rg1);
	int num;
#if defined (_OPENMP)
	num=omp_get_thread_num();
#else
	num=0;
#endif
	int tmp1=SolveBoard(dl,-1,1,1,&fut1,num);
	int score1=fut1.score[0];
	deal dl2={deja.couleur,deja.premier,{co2,0,0},{rg2,0,0},{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
	for (int i=0;i<52;i++){
	  ij =  s.find(liste[i]);
	  ic = 3-i/13;
	  ir = i%13;
	  dl2.remainCards[ij][ic] += (1<<(14-ir));
	}
	dl2.remainCards[deja.premier][co2]-=(1<<rg2);
	int tmp2=SolveBoard(dl2,-1,1,2,&fut2,num);
	int score2=fut2.score[0];
	#pragma omp critical
	{
	if (score1<score2) 
	  nbgagne[0]++;
	else if (score1>score2) 
	  nbgagne[2]++;
	else nbgagne[1]++;
	nd++;
	ccc=true;
	}
      }
    }
  }
return nb;
    
}

 class ResCompE:public Fl_Box{
   //class pour cellule résultat
 public:
   ResCompE(int X,int Y,int W,int H,int N,int V):Fl_Box(FL_BORDER_FRAME,X,Y,W,H,0),no(N),gagne(V){
     align(FL_ALIGN_CENTER | FL_ALIGN_CLIP);
     color(FL_DARK_BLUE);
   }
   int gagne;
   int no;
   char csc[15];
   char ccc[15];
   char res[6];
   void draw(){
     draw_box();
     fl_font(FL_HELVETICA,14);
     sprintf(csc,"%c     meilleure",cartes[rang(no)]);
     fl_draw(csc,x(),y(),w(),25,FL_ALIGN_CENTER);
     fl_color(coulsymb[coulno(no)]);
     fl_font(FL_HELVETICA,18);
     sprintf(ccc,"  %s            ",scoul[coulno(no)]);
     fl_draw(ccc,x(),y(),w(),23,FL_ALIGN_CENTER);
     sprintf(res,"%d%%",gagne);
     fl_draw(res,x(),y()+30,w(),30,FL_ALIGN_CENTER);
   }
 };


void Fenetre::res_compentames(){
  begin();
  time_t tbegin,tend;
  tbegin=time(NULL);
  vector<int> nbgagne(3,0);
  int nb=compentames(deja,nbgagne);
  gentames->begin();
  bres=new Fl_Group(xbcontrats+400,ycomparaison+3,485,104);
  bres->box(FL_BORDER_FRAME);
  bres->color(FL_DARK_BLUE);
  Fl_Box* btitrecompent=new Fl_Box(bres->x(),bres->y(),bres->w(),30,"RÉSULTATS");
  btitrecompent->labelcolor(FL_DARK_BLUE);
  btitrecompent->box(FL_BORDER_FRAME);
  btitrecompent->color(FL_DARK_BLUE);
  //Première meilleure
  ResCompE* rce=new ResCompE(bres->x(),bres->y()+btitrecompent->h(),bres->w()/3,bres->h()-btitrecompent->h(),nos[0],nbgagne[0]*100/nbstat);
  //*100/nbstat
  //égalité
  Fl_Box* beg=new Fl_Box(bres->x()+bres->w()/3,rce->y(),rce->w(),rce->h());
  beg->box(FL_BORDER_FRAME);
  Fl_Box* teg=new Fl_Box(beg->x(),beg->y(),beg->w(),25,"Égalité");
  beg->color(FL_DARK_BLUE);
  teg->labelcolor(FL_DARK_BLUE);
  char sp[4];
  sprintf(sp,"%d%%",nbgagne[1]*100/nbstat);
  int d=1;
  if (nbgagne[1]>=10) d++;
  Fl_Output* reg=new Fl_Output(beg->x()+beg->w()/2-10*d,beg->y()+30,beg->w(),30);
  reg->value(sp);
  reg->textsize(18);
  reg->box(FL_NO_BOX);
  //Deuxième meilleure
  new ResCompE(bres->x()+2*(rce->w()),bres->y()+btitrecompent->h(),bres->w()/3+1,bres->h()-btitrecompent->h(),nos[1],nbgagne[2]*100/nbstat);
  tend=time(NULL);
  int t=(int)difftime(tend,tbegin);
  int minutes=t/60;
  int secondes=t%60;
  Fl_Output* ofin=new Fl_Output(xbcontrats+ESPD,bres->y()+bres->h()-28,350,20);
  ostringstream osss;
  osss<<istring(nb)<<" tirages, "<<nbstat<<" donnes analysées en "<<minutes<<"'"<<secondes<<"''";
  ofin->value(osss.str().c_str());
  ofin->box(FL_NO_BOX);
  gentames->end();
  redraw();
  end();
}

/* //////////////////////////////////////////////////////////////// */
/* --------------------- SUR CONTRAINTES -------------------------- */
//////////////////////////////////////////////////////////////////////
// Calcul statistique des calculs
int calcule_stat(vector<int>& compteurs){
  //renvoie le nombre de donnes dans le contexte (nb)
  //if (contr.con=="") cout<<"Pas de contexte"<<endl;
  int nb=0;
  int erreur=0;
  int nb_calc=contr.calculs.size();
  int no=contr.numerofixe;
  if (no==0) no++;
  else if (no<0) no=-no;
  contr.eff();
  unsigned long long lim= 1<<limite;
  char liste[52];
  bool ccc;
  int iii;
  //int nbthreads=config.nbthreads;
  //#if defined (_OPENMP)
  //#pragma omp parallel for private(ccc,liste) schedule(dynamic) reduction(+:nb)
  //#endif
  for (iii=0;iii<nbstat;iii++){
    ccc=false;
    while (!ccc && nb<lim){
      vector<bool> calcsbool(nb_calc);
      bool boo;
      creedonne(liste,contr.cfixees,contr);
      //compteurs[0]++;
      vector<bool> rep=vconditions(liste,no);
      //cout<<liste[40]<<endl;
      //if cond_ouvs(liste,contr,no){
      if (contr.con=="" || contr.con=="Non" || traite(rep,contr.con,calcsbool)){
	nb++;
	for (int ii=0;ii<nb_calc;ii++){
	  boo=traite(rep,contr.calculs[ii].alg,calcsbool);
	  calcsbool[ii]=boo;
	  //#pragma omp critical
	  if (boo){compteurs[ii]++;}
	}
	ccc=true;
      }
      else erreur++;
    }
  }
  //cout<<"erreur "<<erreur<<" nb "<<nb<<endl;
  return nb;
}


void affiche_sur(){
  int cs=contr.calculs.size();
  vector<int> compteurs(cs,0);
  time_t tbegin,tend;
  tbegin=time(NULL);
  int nb=calcule_stat(compteurs);
  tend=time(NULL);
  for (int i=0;i<cs;i++) cout<<"compteurs["<<i<<"]="<<compteurs[i]<<endl;
  int t=(int)difftime(tend,tbegin);
  int minutes=t/60;
  int secondes=t%60;
  Fl_Window* wprobas=new Fl_Window(50,100,500,400,"Résultats statistique");
  wprobas->color(fl_rgb_color(150,231,219));
  Fl_Multiline_Output* tprobas=new Fl_Multiline_Output(50,50,400,300);
  ostringstream os;
  os<<"Nombre de mains : "<<nbstat<<"\n"<<"Mains contexte : "<<nb<<"\n";
  for (int i=0;i<cs;i++){
    os<<contr.calculs[i].nom<<" : "<<compteurs[i]<<"   soit ";
    float val=(float)compteurs[i]/nb;
    //os<< " val : "<<val<<" et ";
    os<<roundf(val*1000)/10<< "%\n";
  }
  os<<"\n durée : "<<minutes<<"'"<<secondes<<"''";
  tprobas->value(os.str().c_str());
  wprobas->end();
  wprobas->show();
}


void cb_surcontraintes(Fl_Widget*, void* data){
  //Fenetre* win=(Fenetre*)data;
  //win->sur();
  affiche_sur();
}
